/**
 * 
 */
package anl.aida.algo;

import java.io.IOException;

import anl.aida.core.MIFSTerm;
import anl.aida.util.AIDAException;

/**
 * Interface for classes that generate a scored list of concepts.
 * 
 */
public interface ConceptGenerator {
  
  /**
   * Generate the specified number of concepts.
   * 
   * 
   * @param count the suggested number of concepts to generate.
   * 
   * @return the concepts as MIFSTerms
   * 
   * @throws AIDAException if there is an error during generation
   * @throws IOException if there is an error during generation
   */
  Iterable<ScoredKeyword> generateConcepts(int count) throws AIDAException, IOException;

}
