/**
 * 
 */
package anl.aida.algo;

import anl.aida.client.CacheElement;

/**
 * Interface for classes that can produce concept generators.
 * This can be used as the elements in a combo box, for example,
 * to select which concepts will be created.
 * 
 */
public interface ConceptGeneratorProducer {
  
  /**
   * Creates a concept generator, optionally using the cache element.
   * 
   * @param element the CacheElement to use
   * @return the created ConceptGenerator
   */
  ConceptGenerator createGenerator(CacheElement element);
  
  /**
   * Gets a descriptive name for this producer.
   * 
   * @return a descriptive name for this producer.
   */
  String getName();

}
