/**
 * 
 */
package anl.aida.algo;

import anl.aida.client.DefaultKeyword;
import anl.aida.client.Keyword;

/**
 * Default implementation of Concept
 */
public class DefaultScoredKeyword implements ScoredKeyword {
  
  private int count;
  private float score;
  private Keyword keyword;
  
  public DefaultScoredKeyword(int count, float score, String text) {
    this(count, score, new DefaultKeyword(text, text));
  }

  /**
   * @param count
   * @param score
   * @param text
   */
  public DefaultScoredKeyword(int count, float score, Keyword keyword) {
    this.count = count;
    this.score = score;
    this.keyword = keyword;
  }

  /* (non-Javadoc)
   * @see anl.mifs.algo.Concept#getDocumentCount()
   */
  @Override
  public int getDocumentCount() {
    return count;
  }

  /* (non-Javadoc)
   * @see anl.mifs.algo.Concept#getScore()
   */
  @Override
  public float getScore() {
    return score;
  }

  @Override
  public String getLabel() {
    return keyword.getLabel();
  }

  /* (non-Javadoc)
   * @see anl.mifs.algo.Concept#getText()
   */
  @Override
  public String getTerm() {
    return keyword.getTerm();
  }

  @Override
  public int compareTo(Keyword o) {
    return this.keyword.compareTo(o);
  }
  
  

}
