/**
 * 
 */
package anl.aida.bubble;

import java.awt.Font;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.nodes.PPath;
import edu.umd.cs.piccolo.nodes.PText;
import edu.umd.cs.piccolo.util.PBounds;

/**
 */
@SuppressWarnings("serial")
public class AxisHighlight extends PNode {
  
  private PText pText = new PText();
  
  public AxisHighlight() {
    Font font = pText.getFont();
    pText.setFont(font.deriveFont(Font.BOLD));
  }
  
  public void update(String text) {
    removeAllChildren();
    PNode parent = pText.getParent();
    if (parent != null) {
      parent.removeChild(pText);
    }
    pText.setText(text);
    PBounds bounds = pText.getBoundsReference();
    float width = (float)(bounds.width + 10);
    float height = (float)(bounds.height + 10);
    PPath path = PPath.createRoundRectangle(0, 0, width, height, 5, 5);
    pText.setOffset(width / 2 - bounds.width / 2, height / 2 - bounds.height / 2);
    path.addChild(pText);
    addChild(path);
  }

}
