/**
 * 
 */
package anl.aida.bubble;

import edu.umd.cs.piccolo.PLayer;
import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.util.PAffineTransform;
import edu.umd.cs.piccolo.util.PPickPath;

/**
 * PLayer implementation to work around picking issue.
 */
@SuppressWarnings("serial")
public class BubbleLayer extends PLayer {
  
  public boolean fullPick(PPickPath pickPath) {
    // for some reason the bounds of this layer are not correct
    // so the fullIntersects check fails when it should succeed.
    if ((getPickable() || getChildrenPickable()) /*
						    * &&
						    * fullIntersects(pickPath.
						    * getPickBounds())
						    */) {
	pickPath.pushNode(this);
	PAffineTransform transform = getTransformReference(true);
	pickPath.pushTransform(transform);

	boolean thisPickable = getPickable() && pickPath.acceptsNode(this);

	if (thisPickable) {
	  if (pick(pickPath)) {
	    return true;
	  }
	}

	if (getChildrenPickable()) {
	  int count = getChildrenCount();
	  // for (int i = count - 1; i >= 0; i--) {
	  for (int i = 0; i < count; i++) {
	    PNode each = (PNode) getChild(i);
	    if (each.fullPick(pickPath))
	      return true;
	  }
	}

	if (thisPickable) {
	  if (pickAfterChildren(pickPath)) {
	    return true;
	  }
	}

	pickPath.popTransform(transform);
	pickPath.popNode(this);
    }

    return false;
  }
}
