package anl.aida.bubble;

/**
 * Interface for classes that want to listen for bubble
 * selection events.
 * 
 */
public interface BubbleSelectionListener {
  
  /**
   * Called when a bubble is selected.
   * 
   * @param categoryIndex the index of the category.
   */
  void bubbleSelected(int categoryIndex);
  
  /**
   * Called when a bubble is unselected.
   * 
   * @param categoryIndex the index of the category.
   */
  void bubbleUnselected(int categoryIndex);

}
