/*
 * Created by JFormDesigner on Thu Oct 08 11:52:18 EDT 2009
 */

package anl.aida.bubble;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Hashtable;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.Timer;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import anl.aida.client.util.ClientUtils;

/**
 * @author User #1
 */
@SuppressWarnings("serial")
public class BubbleSlider  {
  
  private int tsCount;
  private BubblePlot plot;
  private boolean fireSliderChange = true;
  private int timestep;
  private Timer timer;
  private boolean animate = false;
  
  private JButton playBtn;
  private JSlider timeSlider;
  
  private Icon playIcon = ClientUtils.loadIcon("player_play.png");
  private Icon stopIcon = ClientUtils.loadIcon("player_stop.png");
  
  Action playAction = new AbstractAction() {
    @Override
    public void actionPerformed(ActionEvent e) {
      timestep++;
      if (timestep > tsCount) {
	timestep = tsCount;
	stopTimer();
      } else {
	timeSlider.setValue(timestep);
	plot.updateTimeStep(timestep, true);
      }
    }
  };
  
  public BubbleSlider() {
    playBtn = new JButton();
    timeSlider = new JSlider();
    timeSlider.setPaintLabels(true);
    timeSlider.setPaintTicks(true);
    timeSlider.setSnapToTicks(true);
  }
  
  public BubbleSlider(BubbleDataset data, BubblePlot plot) {
    this();
    this.plot = plot;
    timeSlider.setMaximum(0);
    tsCount = data.getTimeStepCount() - 1;
    timeSlider.setMaximum(tsCount);
    
    timeSlider.setSnapToTicks(false);
    timeSlider.setMajorTickSpacing(4);
    
    Hashtable<Integer, JLabel> labels = new Hashtable<Integer, JLabel>();
    labels.put(0, new JLabel(data.getFormattedTimeStep(0)));
    labels.put(tsCount, new JLabel(data.getFormattedTimeStep(tsCount)));
    
    int middle = tsCount / 2;
    while (middle % 4 != 0) {
      middle--;
    }
    labels.put(middle, new JLabel(data.getFormattedTimeStep(middle)));
    
    timeSlider.setLabelTable(labels);
    
    timer = new Timer(0, playAction);
    timer.setDelay(251);
    playBtn.setIcon(ClientUtils.loadIcon("player_play.png"));
    playBtn.setText("");
    playBtn.setBorderPainted(false);
    
    initListeners();
  }
  
  public JButton getPlayButton() {
    return playBtn;
  }
  
  public JSlider getTimeSlider() {
    return timeSlider;
  }
  
  public int getTimestep() {
    return timestep;
  }

  public void setTimestep(int timestep) {
    animate = true;
    timeSlider.setValue(timestep);
    animate = false;
  }

  private void initListeners() {
    timeSlider.addChangeListener(new ChangeListener() {
      @Override
      public void stateChanged(ChangeEvent e) {
	if (fireSliderChange) {
	  timestep = timeSlider.getValue();
	  plot.updateTimeStep(timestep, animate);
	}
      }
    });
    
    
    playBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	if (timer.isRunning()) stopTimer();
	else startTimer();
      }
    });
  }
  
  private void stopTimer() {
    timer.stop();
    playBtn.setIcon(playIcon);
    fireSliderChange = true;
  }
  
  private void startTimer() {
    if (timestep == tsCount) timestep = -1;
    playBtn.setIcon(stopIcon);
    fireSliderChange = false;
    timer.start();
  }
}
