/**
 * 
 */
package anl.aida.bubble;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;

/**
 *
 */
public class BubbleTooltip extends PBasicInputEventHandler {

  private Bubble bubble;
  private BubblePlot plot;

  /**
   * @param domainAxis
   * @param rangeAxis
   */
  public BubbleTooltip(BubblePlot plot) {
    this.plot = plot;
  }

  /*
   * (non-Javadoc)
   * 
   * @see
   * edu.umd.cs.piccolo.event.PBasicInputEventHandler#mouseClicked(edu.umd.cs
   * .piccolo.event.PInputEvent)
   */
  @Override
  public void mouseClicked(PInputEvent event) {
    super.mouseClicked(event);
    PNode node = event.getPickedNode();
    if (node instanceof Bubble && node.getPickable()) {
      Bubble bubble = (Bubble) node;
      BubbleData data = (BubbleData) node.getAttribute(BubbleConstants.DATA);
      plot.selectBubble(data.categoryIndex, !bubble.isSelected());
    }
  }

  @Override
  public void mouseEntered(PInputEvent event) {
    super.mouseEntered(event);
    if (!plot.isIgnoreMouseOver()) {
      PNode node = event.getPickedNode();
      if (node instanceof Bubble && node.getPickable()) {
	BubbleData data = (BubbleData) node.getAttribute(BubbleConstants.DATA);
	System.out.println(data.category + ": " + data.sizeVal);
	this.bubble = (Bubble) node;
	bubble.setHighlight(true);
	plot.getDomainAxis().highlight(data.xVal);
	plot.getRangeAxis().highlight(data.yVal);
      }
    }
  }

  @Override
  public void mouseExited(PInputEvent event) {
    super.mouseExited(event);
    if (bubble != null) {
      bubble.setHighlight(false);
      plot.getDomainAxis().removeHighlight();
      plot.getRangeAxis().removeHighlight();
      bubble = null;
    }
  }
}
