package anl.aida.bubble;

import edu.umd.cs.piccolo.nodes.PPath;

@SuppressWarnings("serial")
public class DomainAxis extends AbstractDomainAxis {

  public DomainAxis() {
    super(new NumericRange(0, 100), "X");
  }

  public DomainAxis(NumericRange range, String label) {
    super(range, label);
    super.initRange(range.getLength() * .05);
  }

  /*
   * (non-Javadoc)
   * 
   * @see
   * anl.aida.bubble.AbstractDomainAxis#layoutTicks(edu.umd.cs.piccolo.nodes
   * .PPath)
   */
  @Override
  protected void layoutTicks(PPath ticks) {
    double labelOffset = Integer.MIN_VALUE;
    
    // pixelExtent will be 0 on the first layout so we need to adjust
    // so the first layout is approx. correct so that the bounds aren't 
    // widly incorrect.
    if (pixelExtent == 0)
      pixelExtent = canvas.getWidth();

    TickLocator locator = new TickLocator(range, (int) (pixelExtent / 40));
    labelFormatter.setMaximumFractionDigits(locator.getFracDigits());
    while (locator.hasNext()) {
      double val = locator.next();
      float pTick = getPixelLocation(val);
      ticks.moveTo(pTick, 0);
      ticks.lineTo(pTick, 5);
      tickLocations.add(pTick);

      labelOffset = addLabel(ticks, labelFormatter.format(val), pTick, labelOffset);
    }
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.aida.bubble.AbstractAxis#getPixelLocation(double)
   */
  @Override
  public float getPixelLocation(double val) {
    return super.getPixelLocationLin(val);
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.aida.bubble.AbstractAxis#getValueForPixel(float)
   */
  @Override
  public double getValueForPixel(double pixel) {
    return super.getValueForPixelLin(pixel);
  }

}
