package anl.aida.bubble;

/**
 * Encapsulates a numeric range.
 * 
 */
public class NumericRange {
  
  double start, end, length;
  
  public NumericRange(double start, double end) {
    this.start = Math.min(start, end);
    this.end = Math.max(start, end);
  }
  
  public NumericRange(NumericRange range) {
    this(range.getStart(), range.getEnd());
  }

  /**
   * @return the start
   */
  public double getStart() {
    return start;
  }

  /**
   * @return the end
   */
  public double getEnd() {
    return end;
  }
  
  /**
   * Gets the length of the range (i.e. max - min).
   * 
   * @return  the length of the range (i.e. max - min).
   */
  public double getLength() {
    return end - start;
  }
  
  public String toString() {
    return "[" + start + " - " + end + "]";
  }
  
  

}
