package anl.aida.client;

import anl.aida.client.gui.AIDAGui;
import saf.core.ui.GUIBarManager;
import saf.core.ui.IAppConfigurator;
import saf.core.ui.ISAFDisplay;
import saf.core.ui.IWindowCustomizer;
import saf.core.ui.dock.DockingManager;

import javax.swing.*;

import com.jidesoft.plaf.LookAndFeelFactory;

/**
 *         Date: Feb 3, 2009 3:24:33 PM
 */
public class AIDAClientConfigurator implements IAppConfigurator {

  private AIDAClient client;
  private AIDAGui gui;


  public AIDAClientConfigurator(AIDAClient client) {
    this.client = client;
  }

  public boolean preWindowOpen(IWindowCustomizer customizer) {
    Thread.currentThread().setContextClassLoader(getClass().getClassLoader());
    //System.out.println("setting look and feel");
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      LookAndFeelFactory.installJideExtension();
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
      //UIManager.put("ClassLoader", LookUtils.class.getClassLoader());
      //UIManager.setLookAndFeel(new PlasticXPLookAndFeel());
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    customizer.useStoredFrameBounds(800, 600);
    customizer.useSavedLayout();
    customizer.setTitle(System.getProperty(AIDAClientPlugin.TITLE_PROPERTY_KEY));
    customizer.setWindowMenuLabel("Window");

    return true;
  }

  public void fillBars(GUIBarManager guiBarManager) {
    gui.addBarManager(guiBarManager);
  }

  public void postWindowOpen(ISAFDisplay display) {
    gui.setFrame(display.getFrame());
  }

  public boolean preWindowClose() {
    return client.exit();
  }

  public void postWindowClose() {
  }

  public void createLayout(DockingManager dockingManager) {
    gui = new AIDAGui(dockingManager);
    client.init(gui);
  }
}
