package anl.aida.client;

import org.java.plugin.Plugin;
import saf.core.runtime.IApplicationRunnable;
import saf.core.ui.GUICreator;
import saf.core.ui.IAppConfigurator;
import saf.core.ui.ISAFDisplay;
import saf.core.ui.Workspace;
import simphony.util.ThreadUtilities;

import java.io.File;

/**
 * SAF Plugin class that starts the AIDA Client.
 */
public class AIDAClientPlugin extends Plugin implements IApplicationRunnable {
  
  public static final String TITLE_PROPERTY_KEY = "anl.aida.title";
  private static final String TITLE = "AIDA Client";

  // this makes the application menu etc. appear correctly on
  // OSX
  static {
    System.setProperty("apple.laf.useScreenMenuBar", "true");
    System.setProperty("com.apple.mrj.application.apple.menu.about.name", TITLE);
    System.setProperty(TITLE_PROPERTY_KEY, TITLE);
  }

  protected void doStart() throws Exception {
  }

  protected void doStop() throws Exception {
  }

  public void run(String[] args) {

    final AIDAClient client = new AIDAClient();
    final IAppConfigurator configurator = new AIDAClientConfigurator(client);
    final Workspace<AIDAClient> wksp = new Workspace<AIDAClient>(client);
    ISAFDisplay display = GUICreator.createDisplay(configurator, wksp);
    GUICreator.runDisplay(configurator, display);
    if (args.length > 0) {
      final String file = args[0];
      ThreadUtilities.runInEventThread(new Runnable() {
        public void run() {
          client.openCache(new File(file));
        }
      });
    }

  }
}
