/**
 * 
 */
package anl.aida.client;

/**
 * Encapsulates an MIFS keyword as unformatted term and 
 * a display string.
 * 
 */
public class DefaultKeyword implements Keyword {
  
  private String term, displayString;

  /**
   * Creates a keyword.
   * 
   * @param term the keywords term text
   * @param displayString the string to use when displaying the term
   */
  public DefaultKeyword(String term, String displayString) {
    this.term = term;
    this.displayString = displayString;
  }

  /**
   * Gets this Keyword's term text.
   * 
   * @return this Keyword's term text.
   */
  public String getTerm() {
    return term;
  }

  /**
   * Gets this Keyword's display string.
   * 
   * @return this Keyword's display string.
   */
  public String getLabel() {
    return displayString;
  }

  /* (non-Javadoc)
   * @see java.lang.Comparable#compareTo(java.lang.Object)
   */
  @Override
  public int compareTo(Keyword o) {
    return displayString.compareTo(o.getLabel());
  }
  
  public String toString() {
    return term + ": " + displayString;
  }
  
  
}
