package anl.aida.client;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.List;

import anl.aida.client.doc.DocSetOperation;
import anl.aida.client.gui.AIDAGui;
import anl.aida.core.DocumentID;
import anl.aida.util.DateRange;

/**
 * DocSetOperation that will show the documents in the
 * documents view.
 * 
 *         Date: Mar 4, 2009 9:48:26 AM
 */
public class ShowDocViewOp implements DocSetOperation {
  
  private static DateFormat format = new SimpleDateFormat("MM/dd/yy");

  private CacheElement element;
  private AIDAGui gui;

  public ShowDocViewOp(AIDAGui gui, CacheElement element) {
    this.gui = gui;
    this.element = element;
  }
  
  public void setElement(CacheElement element) {
    this.element = element;
  }

  @Override
  public String getLabel() {
    return "Create Documents View";
  }

  @Override
  public void run(List<DocumentID> docs) {
    try {
      TempCacheDocSet set = new TempCacheDocSet(element, docs);
      DateRange range = element.getHeader().getDateRange();
      String label = String.format("Docs selected from %s - %s", format.format(range.getStart()),
	  format.format(range.getEnd()));
      set.getDocumentsModel().setDescription(label);
      gui.loadDocs("Selected Documents", set);
    } finally {
      if (element != null) element.release();
    }
  }
}
