package anl.aida.client.doc;

import anl.aida.core.DocumentID;
import anl.aida.core.ScoredTermsCollection;

/**
 *         Date: Feb 6, 2009 2:28:33 PM
 */
public class ClientDocument {

  private String keywords, title;
  private DocumentID id;

  public ClientDocument(DocumentID id, String title, String... keywords) {
    StringBuilder buf = new StringBuilder();
    for (int i = 0; i < keywords.length; i++) {
      if (i > 0) buf.append(" ");
      buf.append(keywords[i]);

    }
    this.title = title;
    this.keywords = buf.toString();
    this.id = id;
  }

  /**
   * Gets the title of this document.
   *
   * @return the title of this document.
   */
  public String getTitle() {
    return title;
  }

  /**
   * Gets the path of this document.
   *
   * @return the path of this document.
   */
  public String getPath() {
    return id.getPath();
  }

  /**
   * Gets the keywords for this document.
   *
   * @return the keywords for this document.
   */
  public String getKeywords() {
    return keywords;
  }
}
