package anl.aida.client.doc;

import anl.aida.core.DocumentID;

import java.util.List;

/**
 * Interface for classes that perform some sort of operation
 * on a set of documents. For example, create a document view from
 * that set.
 *
 */
public interface DocSetOperation {

  /**
   * Gets a label for this op.
   * 
   * @return a label for this op.
   */
  String getLabel();

  /**
   * Runs the op on this specified list of doc
   * @param docs the docs to run the op on
   */
  void run(List<DocumentID> docs);
}
