package anl.aida.client.doc;

/**
 * Interface for classes that can return an iterable over some set
 * of Documents.
 *
 */
public interface DocSets {

  /**
   * Gets the number of document sets in this DocSets collection.
   *
   * @return the number of document sets in this DocSets collection.
   */
  int getSetCount();


  /**
   * Gets the documents in this set.
   *
   * @param index of the document set whose documents we want
   * @return the documents in this set.
   */
  Iterable<ClientDocument> getDocuments(int index);
}
