package anl.aida.client.doc;

import anl.aida.core.DocumentID;

import java.util.Collection;

/**
 *         Date: Mar 4, 2009 11:04:55 AM
 */
public interface DocumentContainer {

  /**
   * Gets the number of documents in this container.
   *
   * @return the number of documents in this container.
   */
  int getDocumentCount();

  /**
   * Gets an iterable over the docs in this
   * container.
   *
   * @return an iterable over the docs in this container.
   */
  Iterable<DocumentID> documents();

  /**
   * Gets the documents contained by this container and
   * puts them in the specified collection.
   *
   * @param docs the collection to add the documents to
   */
  void getDocuments(Collection<DocumentID> docs);


}
