/**
 * 
 */
package anl.aida.client.gui;

import java.util.HashMap;
import java.util.Map;

import saf.core.ui.event.DockableFrameAdapter;
import saf.core.ui.event.DockableFrameEvent;

/**
 * Helps AIDA gui managed dockable frame events.
 * 
 */
public class AIDADockableHelper extends DockableFrameAdapter {
  
  private Map<String, AIDAVisualization> visualizations = new HashMap<String, AIDAVisualization>();
  
  public void addVisualization(String id, AIDAVisualization viz) {
    visualizations.put(id, viz);
  }
 
  /* (non-Javadoc)
   * @see saf.core.ui.event.DockableFrameAdapter#dockableClosed(saf.core.ui.event.DockableFrameEvent)
   */
  @Override
  public void dockableClosed(DockableFrameEvent evt) {
    AIDAVisualization viz = visualizations.remove(evt.getDockable().getID());
    if (viz != null) {
      viz.closed();
    }
  }

  /* (non-Javadoc)
   * @see saf.core.ui.event.DockableFrameAdapter#dockableClosing(saf.core.ui.event.DockableFrameEvent)
   */
  @Override
  public void dockableClosing(DockableFrameEvent evt) {
    AIDAVisualization viz = visualizations.get(evt.getDockable().getID());
    if (viz != null) {
      viz.closing();
    }
  }

  /* (non-Javadoc)
   * @see saf.core.ui.event.DockableFrameAdapter#dockableMinimized(saf.core.ui.event.DockableFrameEvent)
   */
  @Override
  public void dockableMinimized(DockableFrameEvent evt) {
    AIDAVisualization viz = visualizations.get(evt.getDockable().getID());
    if (viz != null) {
      viz.minimized();
    }
  }

  /* (non-Javadoc)
   * @see saf.core.ui.event.DockableFrameAdapter#dockableMinimizing(saf.core.ui.event.DockableFrameEvent)
   */
  @Override
  public void dockableMinimizing(DockableFrameEvent evt) {
    AIDAVisualization viz = visualizations.get(evt.getDockable().getID());
    if (viz != null) {
      viz.minimizing();
    }
  }
}
