package anl.aida.client.gui;

/**
 * Interface for anything displayed as a visualization in the AIDA client.
 * 
 */
public interface AIDAVisualization {
  
  /**
   * Called immediately prior the visualization being closed.
   */
  void closing();
  
  /**
   * Called when the visualization is closed.
   */
  void closed();
  
  /**
   * Called immediately prior the visualization being minimized.
   */
  void minimizing();
  
  /**
   * Called when the visualization is minimized.
   */
  void minimized();

}
