/*
 * Created by JFormDesigner on Fri Mar 13 15:18:16 EDT 2009
 */

package anl.aida.client.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.WindowConstants;
import javax.swing.border.EmptyBorder;

import anl.aida.client.widget.AnimatorPropertyBean;
import anl.aida.client.widget.RangeChangeEvent;
import anl.aida.client.widget.RangeChangedListener;
import anl.aida.client.widget.RangeSlider;
import anl.aida.client.widget.TimeSliderInitializer;
import anl.aida.util.DateRangeProducer;

import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.DefaultComponentFactory;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.FormSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.layout.Sizes;

/**
 * @author User #1
 */
public class AnimationConfigDialog extends JDialog {
  
  private DateFormat format = new SimpleDateFormat("dd-MMM-yy");
  private Calendar cal = GregorianCalendar.getInstance();
  private DateRangeProducer ranger;
  private int minVal, maxVal;
  private Date minDate;
  private boolean canceled = true;
  
  
  public AnimationConfigDialog(Frame owner) {
    super(owner);
    initComponents();
    addListeners();
  }

  public AnimationConfigDialog(Dialog owner) {
    super(owner);
    initComponents();
    addListeners();
  }
  
  private void addListeners() {
    slider.addRangeChangedListener(new RangeChangedListener() {
      public void rangeChanged(RangeChangeEvent evt) {
	int interval = ((Number)sliceSpn.getValue()).intValue();
	if (evt.isFirstChanged()) {
	  maxVal = slider.getValue();
	  if (maxVal - interval < slider.getSecondValue()) {
	    maxVal = slider.getSecondValue() + interval;
	    slider.setValue(maxVal);
	  }
	} else if (evt.isSecondChanged()) {
	  minVal = slider.getSecondValue();
	  if (minVal + interval > slider.getValue()) {
	    minVal = slider.getValue() - interval;
	    slider.setSecondValue(minVal);
	  }
	}
	
	minDate = calcDateFromStart(minVal);
	startLbl.setText(format.format(minDate));
	endLbl.setText(format.format(calcDateFromStart(maxVal)));
      }
    });
    
    okBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	canceled = false;
	dispose();
      }
    });
    
    cancelBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	canceled = true;
	dispose();
      }
    });
  }
  
  /**
   * Gets the property bean for the current values, or null if
   * the dialog has been canceled.
   * 
   * @return the property bean for the current values, or null if
   * the dialog has been canceled.
   */
  public AnimatorPropertyBean getProperties() {
    if (!canceled) {
      int interval = ((Number)sliceSpn.getValue()).intValue();
      AnimatorPropertyBean bean = new AnimatorPropertyBean(ranger);
      bean.setMinValue(minVal);
      bean.setMaxValue(maxVal);
      bean.setInterval(interval);
      bean.setFramesPer(((Number)frameSpn.getValue()).intValue());
      bean.setIndexIncrement(((Number)indexIncr.getValue()).intValue());
      return bean;
    } 
    
    return null;
    
  }
  
  private Date calcDateFromStart(int days) {
    cal.setTime(ranger.getStart());
    cal.add(Calendar.DAY_OF_MONTH, days);
    Date date = cal.getTime();
    cal.setTime(ranger.getStart());
    return date;
  }
  
  public void init(AnimatorPropertyBean bean) {
    this.ranger = bean.getRanger();
    minVal = bean.getMinValue();
    maxVal = bean.getMaxValue();
    minDate = calcDateFromStart(minVal);
    
    TimeSliderInitializer initter = new TimeSliderInitializer(ranger, format);
    initter.initSlider(slider, 0, ranger.getTotalDays(), false);
    startLbl.setText(format.format(ranger.getStart()));
    endLbl.setText(format.format(ranger.getEnd()));
    int interval = ranger.getRangeLength();
    sliceSpn.setValue(interval);
    ((SpinnerNumberModel)sliceSpn.getModel()).setMinimum(interval);
    ((SpinnerNumberModel)sliceSpn.getModel()).setMaximum(interval);
    frameSpn.setValue(bean.getFramesPer());
    
    ((SpinnerNumberModel)indexIncr.getModel()).setMinimum(1);
    ((SpinnerNumberModel)indexIncr.getModel()).setMaximum(ranger.getTotalDays());
    indexIncr.setValue(bean.getIndexIncrement());
    
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY
    // //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
    dialogPane = new JPanel();
    contentPanel = new JPanel();
    separator1 = compFactory.createSeparator("Animation Properties");
    panel1 = new JPanel();
    label1 = new JLabel();
    startLbl = new JLabel();
    label2 = new JLabel();
    endLbl = new JLabel();
    slider = new RangeSlider();
    label4 = new JLabel();
    indexIncr = new JSpinner();
    label3 = new JLabel();
    sliceSpn = new JSpinner();
    label5 = new JLabel();
    frameSpn = new JSpinner();
    buttonBar = new JPanel();
    okBtn = new JButton();
    cancelBtn = new JButton();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setModal(true);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Configure Animation");
    Container contentPane = getContentPane();
    contentPane.setLayout(new BorderLayout());

    //======== dialogPane ========
    {
      dialogPane.setBorder(Borders.DIALOG_BORDER);
      dialogPane.setLayout(new BorderLayout());

      //======== contentPanel ========
      {
	contentPanel.setBorder(null);
	contentPanel.setLayout(new FormLayout(
	  ColumnSpec.decodeSpecs("default:grow"),
	  new RowSpec[] {
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.UNRELATED_GAP_ROWSPEC,
	    new RowSpec(RowSpec.CENTER, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
	  }));
	contentPanel.add(separator1, cc.xy(1, 1));

	//======== panel1 ========
	{
	  panel1.setBorder(new EmptyBorder(5, 5, 5, 5));
	  panel1.setLayout(new FormLayout(
	    new ColumnSpec[] {
	      FormFactory.DEFAULT_COLSPEC,
	      FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
	      new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
	    },
	    new RowSpec[] {
	      FormFactory.DEFAULT_ROWSPEC,
	      FormFactory.LINE_GAP_ROWSPEC,
	      FormFactory.DEFAULT_ROWSPEC,
	      FormFactory.LINE_GAP_ROWSPEC,
	      FormFactory.DEFAULT_ROWSPEC,
	      FormFactory.LINE_GAP_ROWSPEC,
	      FormFactory.DEFAULT_ROWSPEC,
	      FormFactory.LINE_GAP_ROWSPEC,
	      FormFactory.DEFAULT_ROWSPEC,
	      FormFactory.LINE_GAP_ROWSPEC,
	      FormFactory.DEFAULT_ROWSPEC
	    }));

	  //---- label1 ----
	  label1.setText("Start Date:");
	  panel1.add(label1, cc.xy(1, 1));

	  //---- startLbl ----
	  startLbl.setText("text");
	  panel1.add(startLbl, cc.xy(3, 1));

	  //---- label2 ----
	  label2.setText("End Date:");
	  panel1.add(label2, cc.xy(1, 3));

	  //---- endLbl ----
	  endLbl.setText("text");
	  panel1.add(endLbl, cc.xy(3, 3));
	  panel1.add(slider, cc.xywh(1, 5, 3, 1));

	  //---- label4 ----
	  label4.setText("Frame Index Increment:");
	  panel1.add(label4, cc.xy(1, 7));
	  panel1.add(indexIncr, cc.xy(3, 7));

	  //---- label3 ----
	  label3.setText("Frame Slice (Days):");
	  label3.setToolTipText("The time slice covered by each animation frame");
	  label3.setLabelFor(sliceSpn);
	  panel1.add(label3, cc.xy(1, 9));

	  //---- sliceSpn ----
	  sliceSpn.setModel(new SpinnerNumberModel(100, null, null, 1));
	  sliceSpn.setToolTipText("The time slice covered by each animation frame");
	  panel1.add(sliceSpn, cc.xywh(3, 9, 1, 1, CellConstraints.FILL, CellConstraints.DEFAULT));

	  //---- label5 ----
	  label5.setText("Frames Per Second:");
	  label5.setToolTipText("The suggested number of frames to display per second");
	  label5.setLabelFor(frameSpn);
	  panel1.add(label5, cc.xy(1, 11));

	  //---- frameSpn ----
	  frameSpn.setToolTipText("The suggested number of frames to display per second");
	  frameSpn.setModel(new SpinnerNumberModel(30, 1, 100, 1));
	  panel1.add(frameSpn, cc.xy(3, 11));
	}
	contentPanel.add(panel1, cc.xywh(1, 3, 1, 1, CellConstraints.DEFAULT, CellConstraints.TOP));
      }
      dialogPane.add(contentPanel, BorderLayout.CENTER);

      //======== buttonBar ========
      {
	buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
	buttonBar.setLayout(new FormLayout(
	  new ColumnSpec[] {
	    FormFactory.GLUE_COLSPEC,
	    FormFactory.BUTTON_COLSPEC,
	    FormFactory.RELATED_GAP_COLSPEC,
	    FormFactory.BUTTON_COLSPEC
	  },
	  RowSpec.decodeSpecs("pref")));

	//---- okBtn ----
	okBtn.setText("OK");
	buttonBar.add(okBtn, cc.xy(2, 1));

	//---- cancelBtn ----
	cancelBtn.setText("Cancel");
	buttonBar.add(cancelBtn, cc.xy(4, 1));
      }
      dialogPane.add(buttonBar, BorderLayout.SOUTH);
    }
    contentPane.add(dialogPane, BorderLayout.CENTER);
    setSize(405, 285);
    setLocationRelativeTo(getOwner());
    // JFormDesigner - End of component initialization //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JPanel dialogPane;
  private JPanel contentPanel;
  private JComponent separator1;
  private JPanel panel1;
  private JLabel label1;
  private JLabel startLbl;
  private JLabel label2;
  private JLabel endLbl;
  private RangeSlider slider;
  private JLabel label4;
  private JSpinner indexIncr;
  private JLabel label3;
  private JSpinner sliceSpn;
  private JLabel label5;
  private JSpinner frameSpn;
  private JPanel buttonBar;
  private JButton okBtn;
  private JButton cancelBtn;
  // JFormDesigner - End of variables declaration //GEN-END:variables
}
