package anl.aida.client.gui;

import java.beans.PropertyChangeListener;

import com.jgoodies.binding.beans.ExtendedPropertyChangeSupport;

/**
 * Bean for bubble plot configuration properties.
 * 
 */
public class BubbleConfigBean {
  
  public static enum AxisType {LINEAR, LOG};

  private String xLabel, yLabel, zLabel, title;
  private BubbleDialog.SourceItem xItem, yItem, zItem;
  private AxisType xAxisType, yAxisType; 
  private boolean canceled = true;
  private int entityCount = -1;

  protected ExtendedPropertyChangeSupport pcs = new ExtendedPropertyChangeSupport(this);

  public BubbleConfigBean() {
    xAxisType = AxisType.LINEAR;
    yAxisType = AxisType.LINEAR;
    title = "";
  }

  /**
   * @return the entityCount
   */
  public int getEntityCount() {
    return entityCount;
  }



  /**
   * @param entityCount the entityCount to set
   */
  public void setEntityCount(int entityCount) {
    int old = this.entityCount;
    this.entityCount = entityCount;
    pcs.firePropertyChange("entityCount", old, entityCount);
  }



  /**
   * @return the canceled
   */
  public boolean isCanceled() {
    return canceled;
  }

  /**
   * @param canceled
   *          the canceled to set
   */
  public void setCanceled(boolean canceled) {
    this.canceled = canceled;
  }

  /**
   * @return the title
   */
  public String getTitle() {
    return title;
  }

  /**
   * @param title the title to set
   */
  public void setTitle(String title) {
    String old = this.title;
    this.title = title;
    pcs.firePropertyChange("xLabel", old, title);
  }

  /**
   * @return the xLabel
   */
  public String getXLabel() {
    return xLabel;
  }

  /**
   * @param label
   *          the xLabel to set
   */
  public void setXLabel(String label) {
    String old = xLabel;
    xLabel = label;
    pcs.firePropertyChange("xLabel", old, label);
  }

  /**
   * @return the yLabel
   */
  public String getYLabel() {
    return yLabel;
  }

  /**
   * @param label
   *          the yLabel to set
   */
  public void setYLabel(String label) {
    String old = yLabel;
    yLabel = label;
    pcs.firePropertyChange("yLabel", old, label);
  }

  /**
   * @return the zLabel
   */
  public String getZLabel() {
    return zLabel;
  }

  /**
   * @param label
   *          the zLabel to set
   */
  public void setZLabel(String label) {
    String old = zLabel;
    zLabel = label;
    pcs.firePropertyChange("zLabel", old, label);
  }

  /**
   * @return the xItem
   */
  public BubbleDialog.SourceItem getXItem() {
    return xItem;
  }

  /**
   * @param item
   *          the xItem to set
   */
  public void setXItem(BubbleDialog.SourceItem item) {
    BubbleDialog.SourceItem old = xItem;
    xItem = item;
    pcs.firePropertyChange("xItem", old, item);
  }

  /**
   * @return the yItem
   */
  public BubbleDialog.SourceItem getYItem() {
    return yItem;
  }

  /**
   * @param item
   *          the yItem to set
   */
  public void setYItem(BubbleDialog.SourceItem item) {
    BubbleDialog.SourceItem old = yItem;
    yItem = item;
    pcs.firePropertyChange("yItem", old, item);
  }

  /**
   * @return the zItem
   */
  public BubbleDialog.SourceItem getZItem() {
    return zItem;
  }

  /**
   * @param item
   *          the zItem to set
   */
  public void setZItem(BubbleDialog.SourceItem item) {
    BubbleDialog.SourceItem old = zItem;
    zItem = item;
    pcs.firePropertyChange("zItem", old, item);
  }


  /**
   * @return the xAxisType
   */
  public AxisType getXAxisType() {
    return xAxisType;
  }

  /**
   * @param axisType the xAxisType to set
   */
  public void setXAxisType(AxisType axisType) {
    AxisType old = this.xAxisType;
    xAxisType = axisType;
    pcs.firePropertyChange("xAxisType", old, axisType);
  }

  /**
   * @return the yAxisType
   */
  public AxisType getYAxisType() {
    return yAxisType;
  }

  /**
   * @param axisType the yAxisType to set
   */
  public void setYAxisType(AxisType axisType) {
    AxisType old = this.yAxisType;
    yAxisType = axisType;
    pcs.firePropertyChange("yAxisType", old, axisType);
  }

  public void addPropertyChangeListener(PropertyChangeListener x) {
    pcs.addPropertyChangeListener(x);
  }

  public void removePropertyChangeListener(PropertyChangeListener x) {
    pcs.removePropertyChangeListener(x);
  }

}
