/*
 * Created by JFormDesigner on Wed Oct 14 11:47:21 EDT 2009
 */

package anl.aida.client.gui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collections;
import java.util.Comparator;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.ListModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.WindowConstants;

import anl.aida.client.gui.BubbleConfigBean.AxisType;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.adapter.Bindings;
import com.jgoodies.binding.adapter.SpinnerAdapterFactory;
import com.jgoodies.binding.list.ArrayListModel;
import com.jgoodies.binding.list.SelectionInList;
import com.jgoodies.binding.value.BufferedValueModel;
import com.jgoodies.binding.value.Trigger;
import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.DefaultComponentFactory;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.FormSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.layout.Sizes;

/**
 * @author User #1
 */
@SuppressWarnings("serial")
public class BubbleDialog extends JDialog {

  public static class SourceItem {

    FormulaListElement element;
    String label;

    public SourceItem(FormulaListElement element) {
      this.element = element;
    }
    
    public FormulaListElement getElement() {
      return element;
    }

    public String toString() {
      if (element == null)
	return "None";
      else
	return element.toString();
    }
  }

  private BubbleConfigBean bean;
  private Trigger trigger = new Trigger();

  public BubbleDialog(Frame owner) {
    super(owner);
    initComponents();
    initListeners();
  }

  public BubbleDialog(Dialog owner) {
    super(owner);
    initComponents();
    initListeners();
  }

  private void initListeners() {
    xSourceBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	fillLabel(xSourceBox, xLabelFld);

      }
    });

    ySourceBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	fillLabel(ySourceBox, yLabelFld);

      }
    });

    bubbleSourceBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	fillLabel(bubbleSourceBox, bubbleLabelFld);

      }
    });

    okButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	bean.setCanceled(false);
	trigger.triggerCommit();
	dispose();
      }
    });

    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	bean.setCanceled(true);
	dispose();
      }
    });
  }

  private void fillLabel(JComboBox box, JTextField fld) {
    SourceItem item = (SourceItem) box.getSelectedItem();
    if (item.label == null) {
      item.label = item.toString().replace("_", " ").trim();
      int index = item.label.indexOf(" ");
      while (index != -1) {
	item.label = item.label.substring(0, index)
	    + item.label.substring(index, index + 2).toUpperCase()
	    + item.label.substring(index + 2, item.label.length());
	index = item.label.indexOf(" ", index + 1);
      }
      item.label = item.label.replaceAll("\\[[0-9]\\]", "");

    }
    fld.setText(item.label);
  }

  public void init(java.util.List<FormulaListElement> elements, BubbleConfigBean bean) {
    this.bean = bean;
    PresentationModel<BubbleConfigBean> adapter = new PresentationModel<BubbleConfigBean>(bean,
	trigger);

    Collections.sort(elements, new Comparator<FormulaListElement>() {
      @Override
      public int compare(FormulaListElement o1, FormulaListElement o2) {
	return o1.getFormula().getFormulaAsString().compareToIgnoreCase(o2.getFormula().getFormulaAsString());
      }
    });
    ArrayListModel<SourceItem> xModel = new ArrayListModel<SourceItem>();
    ArrayListModel<SourceItem> yModel = new ArrayListModel<SourceItem>();
    ArrayListModel<SourceItem> zModel = new ArrayListModel<SourceItem>();
    // add a null source item signifying no source, just draw all the
    // bubbles the same size
    zModel.add(new SourceItem(null));
    for (FormulaListElement item : elements) {
      SourceItem sItem = new SourceItem(item);
      xModel.add(sItem);
      yModel.add(sItem);
      zModel.add(sItem);
    }

    BufferedValueModel model = adapter.getBufferedModel("XItem");
    SelectionInList<SourceItem> list = new SelectionInList<SourceItem>((ListModel)xModel, model);
    Bindings.bind(xSourceBox, list);
    
    model = adapter.getBufferedModel("YItem");
    list = new SelectionInList<SourceItem>((ListModel)yModel, model);
    Bindings.bind(ySourceBox, list);
    
    model = adapter.getBufferedModel("ZItem");
    list = new SelectionInList<SourceItem>((ListModel)zModel, model);
    Bindings.bind(bubbleSourceBox, list);

    model = adapter.getBufferedModel("XAxisType");
    Bindings.bind(xLinChk, model, AxisType.LINEAR);
    Bindings.bind(xLogChk, model, AxisType.LOG);
    
    model = adapter.getBufferedModel("YAxisType");
    Bindings.bind(yLinChk, model, AxisType.LINEAR);
    Bindings.bind(yLogChk, model, AxisType.LOG);
    
    model = adapter.getBufferedModel("XLabel");
    Bindings.bind(xLabelFld, model);
    
    model = adapter.getBufferedModel("YLabel");
    Bindings.bind(yLabelFld, model);
    
    model = adapter.getBufferedModel("ZLabel");
    Bindings.bind(bubbleLabelFld, model);
    
    model = adapter.getBufferedModel("title");
    Bindings.bind(titleFld, model);
    
    model = adapter.getBufferedModel("entityCount");
    SpinnerNumberModel spnModel = SpinnerAdapterFactory.createNumberAdapter(model, -1, -1, Integer.MAX_VALUE, 1);
    spinner1.setModel(spnModel);

    xSourceBox.setSelectedIndex(0);
    ySourceBox.setSelectedIndex(0);
    bubbleSourceBox.setSelectedIndex(0);
    
    fillLabel(xSourceBox, xLabelFld);
    fillLabel(ySourceBox, yLabelFld);
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY
    // //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
    dialogPane = new JPanel();
    contentPanel = new JPanel();
    label10 = new JLabel();
    titleFld = new JTextField();
    separator1 = compFactory.createSeparator("Axis Defintion");
    label1 = new JLabel();
    xSourceBox = new JComboBox();
    label2 = new JLabel();
    xLinChk = new JRadioButton();
    xLogChk = new JRadioButton();
    label3 = new JLabel();
    xLabelFld = new JTextField();
    label4 = new JLabel();
    ySourceBox = new JComboBox();
    label5 = new JLabel();
    yLinChk = new JRadioButton();
    yLogChk = new JRadioButton();
    label6 = new JLabel();
    yLabelFld = new JTextField();
    label7 = new JLabel();
    bubbleSourceBox = new JComboBox();
    label8 = new JLabel();
    bubbleLabelFld = new JTextField();
    separator2 = compFactory.createSeparator("Entity Definition");
    label9 = new JLabel();
    spinner1 = new JSpinner();
    buttonBar = new JPanel();
    okButton = new JButton();
    cancelButton = new JButton();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setModal(true);
    setTitle("Configure Bubble Plot");
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    Container contentPane = getContentPane();
    contentPane.setLayout(new BorderLayout());

    //======== dialogPane ========
    {
      dialogPane.setBorder(Borders.DIALOG_BORDER);
      dialogPane.setLayout(new BorderLayout());

      //======== contentPanel ========
      {
	contentPanel.setLayout(new FormLayout(
	  new ColumnSpec[] {
	    new ColumnSpec(Sizes.DLUX2),
	    FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
	    FormFactory.DEFAULT_COLSPEC,
	    FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
	    FormFactory.DEFAULT_COLSPEC,
	    FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
	    new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
	  },
	  new RowSpec[] {
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.UNRELATED_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.UNRELATED_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC,
	    FormFactory.LINE_GAP_ROWSPEC,
	    FormFactory.DEFAULT_ROWSPEC
	  }));

	//---- label10 ----
	label10.setText("Title:");
	contentPanel.add(label10, cc.xywh(1, 1, 3, 1));
	contentPanel.add(titleFld, cc.xywh(5, 1, 3, 1));
	contentPanel.add(separator1, cc.xywh(1, 3, 7, 1));

	//---- label1 ----
	label1.setText("X-Axis Source:");
	label1.setLabelFor(xSourceBox);
	contentPanel.add(label1, cc.xy(3, 5));
	contentPanel.add(xSourceBox, cc.xywh(5, 5, 3, 1));

	//---- label2 ----
	label2.setText("X-Axis Type:");
	contentPanel.add(label2, cc.xy(3, 7));

	//---- xLinChk ----
	xLinChk.setText("Linear");
	xLinChk.setSelected(true);
	contentPanel.add(xLinChk, cc.xy(5, 7));

	//---- xLogChk ----
	xLogChk.setText("Log");
	contentPanel.add(xLogChk, cc.xy(7, 7));

	//---- label3 ----
	label3.setText("X-Axis Label:");
	label3.setLabelFor(xLabelFld);
	contentPanel.add(label3, cc.xy(3, 9));
	contentPanel.add(xLabelFld, cc.xywh(5, 9, 3, 1));

	//---- label4 ----
	label4.setText("Y-Axis Source:");
	label4.setLabelFor(xSourceBox);
	contentPanel.add(label4, cc.xy(3, 11));
	contentPanel.add(ySourceBox, cc.xywh(5, 11, 3, 1));

	//---- label5 ----
	label5.setText("Y-Axis Type:");
	contentPanel.add(label5, cc.xy(3, 13));

	//---- yLinChk ----
	yLinChk.setText("Linear");
	yLinChk.setSelected(true);
	contentPanel.add(yLinChk, cc.xy(5, 13));

	//---- yLogChk ----
	yLogChk.setText("Log");
	contentPanel.add(yLogChk, cc.xy(7, 13));

	//---- label6 ----
	label6.setText("Y-Axis Label:");
	label6.setLabelFor(xLabelFld);
	contentPanel.add(label6, cc.xy(3, 15));
	contentPanel.add(yLabelFld, cc.xywh(5, 15, 3, 1));

	//---- label7 ----
	label7.setText("Bubble Size Source:");
	contentPanel.add(label7, cc.xy(3, 17));
	contentPanel.add(bubbleSourceBox, cc.xywh(5, 17, 3, 1));

	//---- label8 ----
	label8.setText("Bubble Size Label:");
	contentPanel.add(label8, cc.xy(3, 19));
	contentPanel.add(bubbleLabelFld, cc.xywh(5, 19, 3, 1));
	contentPanel.add(separator2, cc.xywh(1, 21, 7, 1));

	//---- label9 ----
	label9.setText("Entity Count:");
	contentPanel.add(label9, cc.xy(3, 23));
	contentPanel.add(spinner1, cc.xywh(5, 23, 3, 1));
      }
      dialogPane.add(contentPanel, BorderLayout.CENTER);

      //======== buttonBar ========
      {
	buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
	buttonBar.setLayout(new FormLayout(
	  new ColumnSpec[] {
	    FormFactory.GLUE_COLSPEC,
	    FormFactory.BUTTON_COLSPEC,
	    FormFactory.RELATED_GAP_COLSPEC,
	    FormFactory.BUTTON_COLSPEC
	  },
	  RowSpec.decodeSpecs("pref")));

	//---- okButton ----
	okButton.setText("OK");
	buttonBar.add(okButton, cc.xy(2, 1));

	//---- cancelButton ----
	cancelButton.setText("Cancel");
	buttonBar.add(cancelButton, cc.xy(4, 1));
      }
      dialogPane.add(buttonBar, BorderLayout.SOUTH);
    }
    contentPane.add(dialogPane, BorderLayout.CENTER);
    pack();
    setLocationRelativeTo(getOwner());
    // JFormDesigner - End of component initialization //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JPanel dialogPane;
  private JPanel contentPanel;
  private JLabel label10;
  private JTextField titleFld;
  private JComponent separator1;
  private JLabel label1;
  private JComboBox xSourceBox;
  private JLabel label2;
  private JRadioButton xLinChk;
  private JRadioButton xLogChk;
  private JLabel label3;
  private JTextField xLabelFld;
  private JLabel label4;
  private JComboBox ySourceBox;
  private JLabel label5;
  private JRadioButton yLinChk;
  private JRadioButton yLogChk;
  private JLabel label6;
  private JTextField yLabelFld;
  private JLabel label7;
  private JComboBox bubbleSourceBox;
  private JLabel label8;
  private JTextField bubbleLabelFld;
  private JComponent separator2;
  private JLabel label9;
  private JSpinner spinner1;
  private JPanel buttonBar;
  private JButton okButton;
  private JButton cancelButton;
  // JFormDesigner - End of variables declaration //GEN-END:variables
}
