/*
 * Created by JFormDesigner on Thu Feb 05 15:08:07 EST 2009
 */

package anl.aida.client.gui;

import java.awt.Component;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.border.EmptyBorder;

import anl.aida.client.Cache;
import anl.aida.client.CacheDocumentSet;
import anl.aida.client.CacheElement;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

/**
 * @author User #1
 */
public class CachePanel extends JPanel {

  static class CacheRenderer extends DefaultListCellRenderer {
    @Override
    public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
      //if (value != null) value = ((CacheElement) value).getTimeStampAsString();
      return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
    }
  }

  public CachePanel() {
    initComponents();

    // hack to wrap the tab compneonts in a Progress Layer
    // so that can use the new progress status indicator
    List<JComponent> comps = new ArrayList<JComponent>();
    List<String> titles = new ArrayList<String>();
    for (int i = 0; i < tabbedPane1.getTabCount(); i++) {
      comps.add((JComponent) tabbedPane1.getComponentAt(i));
      titles.add(tabbedPane1.getTitleAt(i));
    }
    tabbedPane1.removeAll();

    for (int i = 0; i < comps.size(); i++) {
      ProgressLayer layer = new ProgressLayer(comps.get(i));
      tabbedPane1.add(titles.get(i), layer.getJXLayer());
    }
  }

  public void init(AIDAGui gui) {
    clusterPnl.init(gui);
    conceptPnl.init(gui);
    selectionPanel.init(gui);
  }

  public void addCacheDocumentSet(CacheDocumentSet set) {
    //cacheTreePanel1.addCacheDocumentSet(set);
  }


  public void docSetSelected(CacheDocumentSet set) {
    clusterPnl.reset(set);
    conceptPnl.reset(set);
  }

  public CacheElement getElement(int id) {
    //return cacheTreePanel1.getElement(id);
    return null;
  }
  
  public double getSplitDividerLocation() {
    return splitPane1.getDividerLocation() / splitPane1.getSize().getHeight();
  }
  
  public void setSplitDividerLocation(double val) {
    splitPane1.setDividerLocation(val);
  }

  public void resetCache(Cache cache) {
    // the order is important here as we 
    // are clearing the concept and cluster panel
    // then setting the cache on the selectionPanel.
    // Setting the cache should then init the other
    // two panels with some data
    conceptPnl.reset(cache.getKeywords());
    clusterPnl.reset();
    selectionPanel.reset(cache);
    
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    splitPane1 = new JSplitPane();
    selectionPanel = new CacheTSPanel();
    tabbedPane1 = new JTabbedPane();
    conceptPnl = new ConceptPanel();
    clusterPnl = new ClusterPanel();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setBorder(new EmptyBorder(4, 4, 4, 4));
    setLayout(new FormLayout(
            "default:grow",
            "fill:default:grow"));

    //======== splitPane1 ========
    {
      splitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
      splitPane1.setDividerLocation(350);
      splitPane1.setTopComponent(selectionPanel);

      //======== tabbedPane1 ========
      {
        tabbedPane1.addTab("Keywords", conceptPnl);

        //tabbedPane1.addTab("Cluster", clusterPnl);

      }
      splitPane1.setBottomComponent(tabbedPane1);
    }
    add(splitPane1, cc.xy(1, 1));
    // JFormDesigner - End of component initialization  //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JSplitPane splitPane1;
  private CacheTSPanel selectionPanel;
  private JTabbedPane tabbedPane1;
  private ConceptPanel conceptPnl;
  private ClusterPanel clusterPnl;
  // JFormDesigner - End of variables declaration  //GEN-END:variables
}
