/*
 * Created by JFormDesigner on Fri Mar 06 14:48:26 EST 2009
 */

package anl.aida.client.gui;

import anl.aida.client.Cache;
import anl.aida.client.CacheElement;
import anl.aida.client.widget.DateRangeChangedListener;
import anl.aida.client.widget.RangeEvent;
import anl.aida.client.widget.TimeSliceSlider2;
import anl.aida.util.DateRange;
import anl.aida.util.DateRangeProducer;

import com.jgoodies.forms.factories.DefaultComponentFactory;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.*;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;

/**
 * @author User #1
 */
public class CacheTSPanel extends JPanel {

  private DateFormat shortFormat = new SimpleDateFormat("MM-dd-yy");
  private DecimalFormat decFormat = new DecimalFormat("#,###");
  private Cache cache;
  private CacheElement selectedElement;
  private AIDAGui gui;
  private boolean doSetRange = true;

  public CacheTSPanel() {
    initComponents();

    timeSlider.addRangeChangedListener(new DateRangeChangedListener() {
      public void rangeChanged(RangeEvent evt) {
        DateRange range = evt.getRange();
        sEndLbl.setText(shortFormat.format(range.getStart()));
        sStartLbl.setText(shortFormat.format(range.getEnd()));
        if (evt.isAdjusting()) {
          sCountLbl.setText("---");
          sCountLbl.setEnabled(false);
        } else {
          selectElement(range);
          sCountLbl.setEnabled(true);
        }
      }
    });
  }

  private void selectElement(DateRange range) {
    selectedElement = cache.getElement(range);
    if (selectedElement == null) {
      System.out.println("TODO: Create an element on the fly for " + range.toString());
    } else {
      int docCount = selectedElement.getHeader().getDocCount();
      sCountLbl.setText(decFormat.format(docCount));
    }

    if (gui != null && doSetRange) gui.cacheElementSelected(selectedElement);
  }

  public void reset(Cache cache) {
    this.cache = cache;
    // turn off the range setting code so that
    // we don't set intermediate ranges while the gui initializes
    doSetRange = false;
    DateRangeProducer ranger = cache.getRanger();
    timeSlider.init(ranger);
    countLbl.setText(decFormat.format(cache.getTotalDocs()));
    endLbl.setText(shortFormat.format(ranger.getStart()));
    startLbl.setText(shortFormat.format(ranger.getEnd()));
    if (gui != null) gui.cacheElementSelected(selectedElement);
    doSetRange = true;
  }

  public void init(AIDAGui gui) {
    this.gui = gui;
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
    timeSlider = new TimeSliceSlider2();
    panel1 = new JPanel();
    separator1 = compFactory.createSeparator("Full Time Slice");
    label1 = new JLabel();
    endLbl = new JLabel();
    label2 = new JLabel();
    startLbl = new JLabel();
    label3 = new JLabel();
    countLbl = new JLabel();
    separator2 = compFactory.createSeparator("Selected Time Slice");
    label5 = new JLabel();
    sEndLbl = new JLabel();
    label6 = new JLabel();
    sStartLbl = new JLabel();
    label4 = new JLabel();
    sCountLbl = new JLabel();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setBorder(new EmptyBorder(5, 5, 5, 5));
    setLayout(new FormLayout(
            new ColumnSpec[]{
                    FormFactory.DEFAULT_COLSPEC,
                    FormFactory.UNRELATED_GAP_COLSPEC,
                    new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
            },
            RowSpec.decodeSpecs("fill:default:grow")));
    add(timeSlider, cc.xy(1, 1));

    //======== panel1 ========
    {
      panel1.setBorder(new EmptyBorder(5, 5, 5, 5));
      panel1.setLayout(new FormLayout(
              new ColumnSpec[]{
                      FormFactory.UNRELATED_GAP_COLSPEC,
                      new ColumnSpec(ColumnSpec.LEFT, Sizes.DEFAULT, FormSpec.NO_GROW),
                      new ColumnSpec(Sizes.DLUX8),
                      new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
              },
              new RowSpec[]{
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.LINE_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.LINE_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.LINE_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.UNRELATED_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.LINE_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.LINE_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC,
                      FormFactory.LINE_GAP_ROWSPEC,
                      FormFactory.DEFAULT_ROWSPEC
              }));
      panel1.add(separator1, cc.xywh(1, 1, 4, 1));

      //---- label1 ----
      label1.setText("Start:");
      panel1.add(label1, cc.xy(2, 3));
      panel1.add(endLbl, cc.xy(4, 3));

      //---- label2 ----
      label2.setText("End:");
      panel1.add(label2, cc.xy(2, 5));
      panel1.add(startLbl, cc.xy(4, 5));

      //---- label3 ----
      label3.setText("Doc. Count:");
      panel1.add(label3, cc.xy(2, 7));
      panel1.add(countLbl, cc.xy(4, 7));
      panel1.add(separator2, cc.xywh(1, 9, 4, 1));

      //---- label5 ----
      label5.setText("Start:");
      panel1.add(label5, cc.xy(2, 11));
      panel1.add(sEndLbl, cc.xy(4, 11));

      //---- label6 ----
      label6.setText("End:");
      panel1.add(label6, cc.xy(2, 13));
      panel1.add(sStartLbl, cc.xy(4, 13));

      //---- label4 ----
      label4.setText("Doc. Count:");
      panel1.add(label4, cc.xy(2, 15));
      panel1.add(sCountLbl, cc.xy(4, 15));
    }
    add(panel1, cc.xy(3, 1));
    // JFormDesigner - End of component initialization  //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private TimeSliceSlider2 timeSlider;
  private JPanel panel1;
  private JComponent separator1;
  private JLabel label1;
  private JLabel endLbl;
  private JLabel label2;
  private JLabel startLbl;
  private JLabel label3;
  private JLabel countLbl;
  private JComponent separator2;
  private JLabel label5;
  private JLabel sEndLbl;
  private JLabel label6;
  private JLabel sStartLbl;
  private JLabel label4;
  private JLabel sCountLbl;
  // JFormDesigner - End of variables declaration  //GEN-END:variables
}
