package anl.aida.client.gui;

import anl.aida.algo.Cluster;
import anl.aida.algo.Clusters;
import anl.aida.core.DocumentID;

import javax.swing.table.AbstractTableModel;

/**
 *         Date: Feb 12, 2009 4:42:49 PM
 */
public class ClusterTableModel extends AbstractTableModel {

  private static final String[] COL_NAMES = {"", "Keywords", "No. Docs", "[%]"};
  private static final Class[] COL_TYPES = {Boolean.class, String.class, Integer.class, String.class};

  private Clusters<DocumentID> clusters;
  private boolean[] selected;

  public void reset(Clusters<DocumentID> clusters) {
    this.clusters = clusters;
    selected = new boolean[clusters.itemCount()];
    fireTableDataChanged();
  }

  @Override
  public int getRowCount() {
    return clusters == null ? 0 : clusters.size();
  }

  @Override
  public int getColumnCount() {
    return COL_NAMES.length;
  }

  @Override
  public Object getValueAt(int row, int col) {
    if (col == 0) return selected[row];
    else {
      Cluster cluster = clusters.getCluster(row);
      if (col == 1) return cluster.getCentroidLabel();
      else if (col == 2) return cluster.getItemCount();
      else if (col == 3) {

        return String.format("%.1f", cluster.getItemCount() / (float) clusters.itemCount() * 100f);
      }
    }

    return null;
  }

  public Clusters<DocumentID> getClusters() {
    return clusters;
  }


  @Override
  public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    if (columnIndex == 0) {
      selected[rowIndex] = (Boolean) aValue;
    }
  }

  @Override
  public boolean isCellEditable(int rowIndex, int columnIndex) {
    return columnIndex == 0;
  }

  @Override
  public Class<?> getColumnClass(int columnIndex) {
    return COL_TYPES[columnIndex];
  }

  @Override
  public String getColumnName(int column) {
    return COL_NAMES[column];
  }
}
