/*
 * Created by JFormDesigner on Mon Feb 16 14:45:00 EST 2009
 */

package anl.aida.client.gui;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.RowSorter;
import javax.swing.SwingWorker;
import javax.swing.border.EmptyBorder;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

import simphony.util.messages.MessageCenter;
import anl.aida.algo.ConceptClusterer;
import anl.aida.algo.ConceptGenerator;
import anl.aida.algo.ConceptGeneratorProducer;
import anl.aida.algo.KeywordsConceptGeneratorProducer;
import anl.aida.algo.SVConceptGeneratorProducer;
import anl.aida.algo.ScoredKeyword;
import anl.aida.client.CacheDocumentSet;
import anl.aida.client.CacheElement;
import anl.aida.client.DocSetID;
import anl.aida.client.Keywords;
import anl.aida.client.util.StringNumberComparator;

import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.FormSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.layout.Sizes;

/**
 * @author User #1
 */
@SuppressWarnings("serial")
public class ConceptPanel extends JPanel implements TableModelListener {

  class ClusterWorker extends SwingWorker<Iterable<ScoredKeyword>, Object> {
    private int count;

    ClusterWorker(int count) {
      this.count = count;
    }

    @Override
    protected Iterable<ScoredKeyword> doInBackground() throws Exception {
      CacheElement element = docSet.getParent();
      ConceptGeneratorProducer prod = (ConceptGeneratorProducer) keywordBox.getSelectedItem();
      ConceptGenerator generator = prod.createGenerator(element);
      return generator.generateConcepts(count);
    }

    protected void done() {
      try {
	Iterable<ScoredKeyword> scores = get();
	KeywordTableModel model = new KeywordTableModel();
	model.reset(docSet.getDocumentCount());
	for (ScoredKeyword concept : scores) {
	  model.addItem(concept);
	}
	resetTable(model);
	int index = keywordBox.getSelectedIndex();
	keywordModelMap.put(index, model);

	unselectBtn.setEnabled(true);
	selectBtn.setEnabled(true);
	conceptTbl.getRowSorter().toggleSortOrder(KeywordTableModel.DOC_COUNT_COL);
	conceptTbl.getRowSorter().toggleSortOrder(KeywordTableModel.DOC_COUNT_COL);
	model.selectAll();
      } catch (Exception ex) {
	center.error("Error while generating concepts", ex);
      } finally {
	ProgressLayer pLayer = (ProgressLayer) getClientProperty(ProgressLayer.CLIENT_KEY);
	pLayer.setEnabled(true);
      }
    }
  }

  private static MessageCenter center = MessageCenter.getMessageCenter(ConceptPanel.class);
  private static final String SPACE_SELECTION_KEY = "SPACE_SELECTION_KEY";
  private static final int CONCEPT_COUNT = 50;

  private AIDAGui gui;
  private CacheDocumentSet docSet;
  private Map<DocSetID, TableModel> listMap = new HashMap<DocSetID, TableModel>();
  private Map<Integer, TableModel> keywordModelMap = new HashMap<Integer, TableModel>();
  private int keywordIndex = -1;

  public ConceptPanel() {
    initComponents();
    unselectBtn.setText("");
    unselectBtn.setEnabled(false);
    unselectBtn.setIcon(new ImageIcon(getClass().getClassLoader().getResource(
	"deselect_multiple.png")));
    selectBtn
	.setIcon(new ImageIcon(getClass().getClassLoader().getResource("select_multiple.png")));
    selectBtn.setText("");
    selectBtn.setEnabled(false);
    conceptTbl.setModel(new KeywordTableModel());
    addListeners();

    vizBtn.setEnabled(false);
    vizBtn.setText("");
    vizBtn.setIcon(new ImageIcon(getClass().getClassLoader().getResource("add_sub_task.png")));

    unselectBtn.setMaximumSize(vizBtn.getMaximumSize());
    unselectBtn.setMaximumSize(vizBtn.getMinimumSize());
    unselectBtn.setMaximumSize(vizBtn.getPreferredSize());

    selectBtn.setMaximumSize(vizBtn.getMaximumSize());
    selectBtn.setMaximumSize(vizBtn.getMinimumSize());
    selectBtn.setMaximumSize(vizBtn.getPreferredSize());

    // runBtn.setIcon(new
    // ImageIcon(getClass().getClassLoader().getResource("agt_runit.png")));
    // runBtn.setText("");

    TableRowSorter<KeywordTableModel> sorter = new TableRowSorter<KeywordTableModel>(
	new KeywordTableModel());
    sorter.setSortable(0, false);
    sorter.setComparator(2, new StringNumberComparator());
    sorter.setComparator(3, new StringNumberComparator());
    //sorter.setComparator(4, new StringNumberComparator());
    conceptTbl.setRowSorter(sorter);

    // conceptTbl.setColumnControlVisible(true);
    conceptTbl.addComponentListener(new ComponentAdapter() {
      public void componentResized(ComponentEvent e) {
	conceptTbl.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
	conceptTbl.getColumnModel().getColumn(0).setPreferredWidth(28);
	conceptTbl.getColumnModel().getColumn(1).setPreferredWidth(142);
	conceptTbl.getColumnModel().getColumn(2).setPreferredWidth(120);
	conceptTbl.getColumnModel().getColumn(3).setPreferredWidth(45);
	//conceptTbl.getColumnModel().getColumn(4).setPreferredWidth(45);

	conceptTbl.removeComponentListener(this);
      }
    });

    keywordBox.setRenderer(new DefaultListCellRenderer() {
      @Override
      public Component getListCellRendererComponent(JList list, Object value, int index,
	  boolean isSelected, boolean cellHasFocus) {
	if (value == null) {
	  value = "Select Keywords ...";
	} else {
	  value = ((ConceptGeneratorProducer) value).getName();
	}
	return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
      }

    });
  }
  
  private int[] viewRowsToModelRows(int[] rows) {
    int[] modelRows = new int[rows.length];
    for (int i = 0; i < rows.length; i++) {
      modelRows[i] = conceptTbl.convertRowIndexToModel(rows[i]);
    }
    return modelRows;
    
  }

  private void flipSelectedRows() {
    int[] rows = conceptTbl.getSelectedRows();
    rows = viewRowsToModelRows(rows);

    KeywordTableModel model = (KeywordTableModel) conceptTbl.getModel();
    model.flipSelectionRows(rows);
  }

  private void addListeners() {
    /*
     * runBtn.addActionListener(new ActionListener() { public void
     * actionPerformed(ActionEvent evt) { generateConcepts(); } });
     */

    KeyStroke keystroke = KeyStroke.getKeyStroke(KeyEvent.VK_SPACE, 0);

    conceptTbl.getActionMap().put(SPACE_SELECTION_KEY, new AbstractAction() {
      public void actionPerformed(ActionEvent evt) {
	flipSelectedRows();
      }
    });
    conceptTbl.getInputMap(JComponent.WHEN_FOCUSED).put(keystroke, SPACE_SELECTION_KEY);

    keywordBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	int index = keywordBox.getSelectedIndex();
	if (index != keywordIndex) {
	  keywordIndex = index;
	  generateConcepts();
	}
      }
    });

    /*
    // this is necessary because when the cache panel doesn't
    // have focus and the user clicks on the combo box, the cache
    // panel dockable frame steals the focus and the popu menu for
    // the combobox disappears immediately.
    keywordBox.addPopupMenuListener(new PopupMenuListener() {
      @Override
      public void popupMenuCanceled(PopupMenuEvent e) {
      }

      @Override
      public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
	if (!keywordBox.hasFocus()) {
	  SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
	      keywordBox.setPopupVisible(true);
	    }
	  });
	}
      }

      @Override
      public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
      }
    });
    */

    vizBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	generateViz();
      }
    });

    unselectBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	KeywordTableModel model = (KeywordTableModel) conceptTbl.getModel();
	int[] rows = conceptTbl.getSelectedRows();
	if (rows.length > 0) {
	  model.setRowsSelected(viewRowsToModelRows(rows), false);
	} else {
	  model.unselectAll();
	}
      }
    });

    selectBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	KeywordTableModel model = (KeywordTableModel) conceptTbl.getModel();
	int[] rows = conceptTbl.getSelectedRows();
	if (rows.length > 0) {
	  model.setRowsSelected(viewRowsToModelRows(rows), true);
	} else {
	  model.selectAll();
	}
      }
    });
  }

  public void tableChanged(TableModelEvent e) {
    KeywordTableModel model = (KeywordTableModel) conceptTbl.getModel();
    vizBtn.setEnabled(model.getSelectedItemCount() > 0);
  }

  private void generateViz() {
    KeywordTableModel model = (KeywordTableModel) conceptTbl.getModel();
    List<ScoredKeyword> keywords = model.getSelectedTerms();
    VizPropertyBean bean = new VizPropertyBean("Keyword Exploration", keywords);
    gui.showVizDialog(bean);

    if (!bean.isCanceled()) {
      if (bean.getType().equals(VizPropertyBean.Type.CLUSTER)) {
	/*
	try {
	  if (keywords.size() > 0) {
	    CacheElement element = docSet.getParent();
	    ConceptClusterer clusterer = new ConceptClusterer(element.getSTC(), element.getSVS());
	    gui.addClusterDisplay(docSet.getId(), clusterer.generateClusters(keywords), bean
		.getTitle());
	  }
	} catch (IOException ex) {
	  center.error("Error generating clusters for concepts", ex);
	}
	*/

      } else if (bean.getType().equals(VizPropertyBean.Type.NETWORK)) {
	gui.addNetworkDisplay(bean);
      } else if (bean.getType().equals(VizPropertyBean.Type.TIME_SERIES)) {
	gui.addTimeSeriesDisplay(bean);
      }
    }
  }

  private void generateConcepts() {
    int index = keywordBox.getSelectedIndex();
    if (index == -1) {
      resetTable(new KeywordTableModel());
    } else {
      TableModel model = keywordModelMap.get(index);
      if (model != null) {
	resetTable(model);
      } else {
	ProgressLayer pLayer = (ProgressLayer) getClientProperty(ProgressLayer.CLIENT_KEY);
	pLayer.setEnabled(false);
	int count = CONCEPT_COUNT;
	ClusterWorker worker = new ClusterWorker(count);
	worker.execute();
      }
    }
  }

  public void init(AIDAGui gui) {
    this.gui = gui;
  }

  /**
   * Reset with new keywords. This should occur when a new cache is opened.
   * 
   * @param keywords
   */
  public void reset(Keywords keywords) {
    listMap.clear();
    docSet = null;
    keywordModelMap.clear();
    resetTable(new KeywordTableModel());

    List<String> keywordSets = new ArrayList<String>(keywords.getKeywordSetNames());
    Collections.sort(keywordSets);
    DefaultComboBoxModel model = new DefaultComboBoxModel();
    for (String set : keywordSets) {
      model.addElement(new KeywordsConceptGeneratorProducer(keywords, set));
    }
    if (keywordSets.size() > 1) {
      // this adds the "All Keywords" producer
      model.addElement(new KeywordsConceptGeneratorProducer(keywords));
    }
    model.addElement(new SVConceptGeneratorProducer());
    keywordBox.setModel(model);
    keywordBox.setSelectedIndex(-1);
  }

  /**
   * Reset for new cache doc set. This should occur when date range has changed.
   * 
   * @param set
   */
  public void reset(CacheDocumentSet set) {
    keywordModelMap.clear();
    keywordBox.setSelectedIndex(-1);
    /*
     * if (docSet != null) { TableModel model = conceptTbl.getModel();
     * model.removeTableModelListener(this); listMap.put(docSet.getId(), model);
     * }
     */

    docSet = set;

    /*
     * TableModel model = listMap.get(docSet.getId()); if (model == null) {
     * model = new KeywordTableModel(); } resetTable(model);
     */
  }

  @SuppressWarnings("unchecked")
  private void resetTable(TableModel model) {
    int[] sizes = new int[conceptTbl.getColumnCount()];
    for (int i = 0; i < conceptTbl.getColumnCount(); i++) {
      sizes[i] = conceptTbl.getColumnModel().getColumn(i).getPreferredWidth();
    }

    TableRowSorter rowSorter = (TableRowSorter) conceptTbl.getRowSorter();
    List<RowSorter.SortKey> sortKeys = rowSorter.getSortKeys();
    conceptTbl.setModel(model);
    rowSorter.setModel(model);

    rowSorter.setSortable(0, false);
    rowSorter.setComparator(2, new StringNumberComparator());
    rowSorter.setComparator(3, new StringNumberComparator());
    //rowSorter.setComparator(4, new StringNumberComparator());

    rowSorter.setSortKeys(sortKeys);
    rowSorter.sort();

    model.addTableModelListener(this);
    for (int i = 0; i < conceptTbl.getColumnCount(); i++) {
      conceptTbl.getColumnModel().getColumn(i).setPreferredWidth(sizes[i]);
    }

    unselectBtn.setEnabled(model.getRowCount() > 0);
    selectBtn.setEnabled(model.getRowCount() > 0);
    vizBtn.setEnabled(((KeywordTableModel) model).getSelectedItemCount() > 0);
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY
    // //GEN-BEGIN:initComponents
	// Generated using JFormDesigner non-commercial license
	toolBar1 = new JToolBar();
	keywordBox = new JComboBox();
	selectBtn = new JButton();
	unselectBtn = new JButton();
	vizBtn = new JButton();
	scrollPane1 = new JScrollPane();
	conceptTbl = new JTable();
	CellConstraints cc = new CellConstraints();

	//======== this ========
	setBorder(new EmptyBorder(5, 5, 5, 5));
	setLayout(new FormLayout(
		new ColumnSpec[] {
			FormFactory.DEFAULT_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			new ColumnSpec("max(default;30dlu):grow")
		},
		new RowSpec[] {
			FormFactory.DEFAULT_ROWSPEC,
			FormFactory.LINE_GAP_ROWSPEC,
			new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
		}));

	//======== toolBar1 ========
	{
		toolBar1.setFloatable(false);
		toolBar1.add(keywordBox);
		toolBar1.addSeparator();

		//---- selectBtn ----
		selectBtn.setText("text");
		selectBtn.setToolTipText("Select All Keywords");
		toolBar1.add(selectBtn);

		//---- unselectBtn ----
		unselectBtn.setText("text");
		unselectBtn.setToolTipText("Unselect All Keywords");
		toolBar1.add(unselectBtn);

		//---- vizBtn ----
		vizBtn.setText("Viz");
		vizBtn.setToolTipText("Visualize Keywords");
		toolBar1.add(vizBtn);
	}
	add(toolBar1, cc.xywh(1, 1, 3, 1));

	//======== scrollPane1 ========
	{
		scrollPane1.setViewportView(conceptTbl);
	}
	add(scrollPane1, cc.xywh(1, 3, 3, 1));
    // JFormDesigner - End of component initialization //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JToolBar toolBar1;
  private JComboBox keywordBox;
  private JButton selectBtn;
  private JButton unselectBtn;
  private JButton vizBtn;
  private JScrollPane scrollPane1;
  private JTable conceptTbl;
  // JFormDesigner - End of variables declaration //GEN-END:variables
}
