/*
 * Created by JFormDesigner on Wed Feb 18 10:24:30 EST 2009
 */

package anl.aida.client.gui;

import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.HashMap;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.jdesktop.jxlayer.JXLayer;

import anl.aida.client.CacheDocumentSet;
import anl.aida.client.DocSetID;
import anl.aida.client.doc.DocumentsModel;

import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;
import com.jidesoft.swing.JideTabbedPane;
import com.jidesoft.swing.StyledLabel;

/**
 * @author User #1
 */
public class DocsTabPanel extends JPanel {

  class CloseAction extends AbstractAction {

    public void actionPerformed(ActionEvent e) {
      DocumentsView view = (DocumentsView) ((JXLayer) tabs.getSelectedComponent()).getView();
      if (view != null) {
	setMap.remove(view.getModel().getID());
      }
      tabs.remove(tabs.getSelectedComponent());
      if (tabs.getTabCount() == 0) {
	descLbl.setText("No Documents");
	// addBtn.setEnabled(false);
      }
    }
  }

  private boolean editingLbl = false;
  private DocumentsModel model;
  private Map<DocSetID, CacheDocumentSet> setMap = new HashMap<DocSetID, CacheDocumentSet>();
  private AIDAGui gui;

  public DocsTabPanel() {
    initComponents();
    tabs.setTabEditingAllowed(true);

    addListeners();
  }

  private void addListeners() {
    tabs.addChangeListener(new ChangeListener() {
      public void stateChanged(ChangeEvent e) {
	JXLayer jxLayer = (JXLayer) tabs.getSelectedComponent();
	if (jxLayer != null) {
	  DocumentsView view = (DocumentsView) jxLayer.getView();
	  model = view.getModel();
	  String desc = model.getDescription();
	  if (desc.length() == 0) {
	    descLbl.setForeground(Color.GRAY);
	    descLbl.setText("Double Click to Edit Label");
	  } else {
	    descLbl.setText(desc);
	    descLbl.setForeground(Color.BLACK);
	  }
	  // addBtn.setEnabled(model.getID().isTemporary());
	}
      }
    });

    descFld.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	if (editingLbl) {
	  flipDescComps();
	}
      }
    });

    descFld.addFocusListener(new FocusAdapter() {
      @Override
      public void focusLost(FocusEvent e) {
	if (editingLbl) {
	  flipDescComps();
	}
      }
    });

    descLbl.addMouseListener(new MouseAdapter() {
      @Override
      public void mouseClicked(MouseEvent e) {
	if (e.getClickCount() == 2 && !editingLbl) {
	  flipDescComps();
	}
      }
    });

    tabs.setCloseAction(new CloseAction());

    /*
     * addBtn.addActionListener(new ActionListener() { public void
     * actionPerformed(ActionEvent evt) { //addDocumentSetToCache(); } });
     */
  }

  public void init(AIDAGui gui) {
    this.gui = gui;
  }

  private void addDocumentSetToCache() {
    int index = findIndex(model.getID());
    if (index != -1) {
      String title = tabs.getTitleAt(index);
      CacheDocumentSet set = setMap.get(model.getID());
      // add this set to the cache tree and get the transformed
      // set back.
      CacheDocumentSet newSet = gui.addDocumentSet(title, set);
      if (newSet != null) {
	// replace the original set with the transformed set
	setMap.put(newSet.getId(), newSet);
	setMap.remove(set.getId());
	DocumentsView view = (DocumentsView) ((JXLayer) tabs.getSelectedComponent()).getView();
	view.reset(newSet.getDocumentsModel());
	model = newSet.getDocumentsModel();
	tabs.setTitleAt(index, newSet.getLabel());
	// addBtn.setEnabled(false);
      }
    }
  }

  private void flipDescComps() {
    if (editingLbl) {
      descLbl.setText(descFld.getText());
      descLbl.setForeground(Color.BLACK);
      model.setDescription(descFld.getText());
      Container parent = descLbl.getParent();
      CardLayout layout = (CardLayout) parent.getLayout();
      layout.previous(parent);
      editingLbl = false;
    } else {
      descFld.setText(descLbl.getText());
      Container parent = descLbl.getParent();
      CardLayout layout = (CardLayout) parent.getLayout();
      layout.next(parent);
      descFld.requestFocus();
      editingLbl = true;
    }
  }

  /**
   * Selects the document view whose model has the specified id.
   * 
   * @param id
   *          the id to look for
   * @return true if a view with the specified id was found, otherwise false.
   */
  public boolean selectDocSet(DocSetID id) {
    int index = findIndex(id);
    if (index != -1) {
      tabs.setSelectedIndex(index);
    }

    return index != -1;
  }

  private int findIndex(DocSetID id) {
    int index = -1;
    for (int i = 0; i < tabs.getComponentCount(); i++) {
      Component comp = tabs.getComponent(i);
      if (comp instanceof JXLayer) {
	DocumentsView view = (DocumentsView) ((JXLayer) comp).getView();
	if (view.getModel().getID().equals(id)) {
	  index = tabs.indexOfComponent(comp);
	  break;
	}
      }
    }
    return index;
  }

  /**
   * Adds a documents view with the specified title using the specified model.
   * 
   * @param title
   *          the title of the view
   * @param docSet
   *          the document set to display
   */
  public void addDocs(String title, CacheDocumentSet docSet) {
    model = docSet.getDocumentsModel();
    setMap.put(docSet.getId(), docSet);
    descLbl.setText(model.getDescription());
    DocumentsView view = new DocumentsView();
    view.init(gui);
    view.reset(model);

    tabs.add(title, view.getJXLayer());
    tabs.setSelectedIndex(tabs.getTabCount() - 1);
  }

  public void removeAllDocs() {
    tabs.removeAll();
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY
    // //GEN-BEGIN:initComponents
	// Generated using JFormDesigner non-commercial license
	panel1 = new JPanel();
	descLbl = new StyledLabel();
	descFld = new JTextField();
	tabs = new JideTabbedPane();
	CellConstraints cc = new CellConstraints();

	//======== this ========
	setBorder(new EmptyBorder(5, 5, 5, 5));
	setLayout(new FormLayout(
		"default:grow",
		"default, fill:default:grow"));

	//======== panel1 ========
	{
		panel1.setBorder(new EtchedBorder());
		panel1.setLayout(new CardLayout(4, 2));

		//---- descLbl ----
		descLbl.setText("text");
		descLbl.setHorizontalAlignment(SwingConstants.CENTER);
		descLbl.setToolTipText("Double click to edit");
		panel1.add(descLbl, "card1");
		panel1.add(descFld, "card2");
	}
	add(panel1, cc.xy(1, 1));

	//======== tabs ========
	{
		tabs.setShowCloseButtonOnTab(true);
		tabs.setTabPlacement(SwingConstants.BOTTOM);
		tabs.setTabShape(0);
		tabs.setColorTheme(1);
		tabs.setShowIconsOnTab(false);
		tabs.setShowTabButtons(true);
	}
	add(tabs, cc.xy(1, 2));
    // JFormDesigner - End of component initialization //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JPanel panel1;
  private StyledLabel descLbl;
  private JTextField descFld;
  private JideTabbedPane tabs;
  // JFormDesigner - End of variables declaration //GEN-END:variables

}
