/**
 * 
 */
package anl.aida.client.gui;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import anl.aida.formula.Formula;
import anl.aida.formula.FormulaVariable;

/**
 * Encapsulates a formula string and its variables.
 * 
 */
public class FormulaListElement {
  
  private Formula formula;
  private List<FormulaVariable> variables = new ArrayList<FormulaVariable>();
  
  
  public FormulaListElement(Formula formula, FormulaVariable variable) {
    this.formula = formula;
    variables.add(variable);
  }
  
  
  /**
   * @param formula
   * @param variables
   */
  public FormulaListElement(Formula formula, List<FormulaVariable> variables) {
    this.formula = formula;
    this.variables.addAll(variables);
  }
  
  public List<FormulaVariable> getVariables() {
    return Collections.unmodifiableList(variables);
  }
  
  public Formula getFormula() {
    return formula;
  }
  
  public String toString() {
    return formula.getFormulaAsString();
  }
}
