/*
 * Created by JFormDesigner on Tue Mar 03 09:20:12 EST 2009
 */

package anl.aida.client.gui;

import anl.aida.client.net.*;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.adapter.Bindings;
import com.jgoodies.binding.adapter.SpinnerAdapterFactory;
import com.jgoodies.binding.list.ArrayListModel;
import com.jgoodies.binding.list.SelectionInList;
import com.jgoodies.binding.value.BufferedValueModel;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.*;
import com.jidesoft.swing.TitledSeparator;

import javax.swing.*;
import javax.swing.text.DefaultFormatter;
import javax.swing.text.DefaultFormatterFactory;
import javax.swing.text.NumberFormatter;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;

/**
 * @author User #1
 */
public class GraphOptionsPanel extends JPanel {


  public GraphOptionsPanel() {
    initComponents();
    filterBox.setRenderer(new DefaultListCellRenderer() {
      @Override
      public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected,
                                                    boolean cellHasFocus) {
        if (value != null) value = ((TSFilterCreator) value).getLabel();
        return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
      }
    });

    filterBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        nodeThreshFld.setEnabled(!(filterBox.getSelectedItem() instanceof OccurrenceFilterCreator));
        ntLbl.setEnabled(nodeThreshFld.isEnabled());
      }
    });

    ((JLabel) edgeSep.getLabelComponent()).setText("Edges");
    edgeSep.setBarAlignment(SwingConstants.CENTER);

    ((JLabel) nodeSep.getLabelComponent()).setText("Nodes");
    nodeSep.setBarAlignment(SwingConstants.CENTER);

    edgeFilterBox.setRenderer(new DefaultListCellRenderer() {
      @Override
      public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected,
                                                    boolean cellHasFocus) {
        if (value != null) value = ((EdgeCreatorCreator) value).getLabel();
        return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
      }
    });

    edgeFilterBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        scoreThreshFld.setEnabled(!(edgeFilterBox.getSelectedItem() instanceof OccurenceEdgeCC));
        stLbl.setEnabled(scoreThreshFld.isEnabled());
      }
    });
  }

  public void setEnabled(boolean enabled) {
    super.setEnabled(enabled);
    for (int i = 0; i < this.getComponentCount(); i++) {
      getComponent(i).setEnabled(enabled);
    }
    edgeSep.getLabelComponent().setEnabled(enabled);
    nodeSep.getLabelComponent().setEnabled(enabled);
  }

  public void init(PresentationModel<VizPropertyBean> adapter) {

    ArrayListModel<TSFilterCreator> typeModel = new ArrayListModel<TSFilterCreator>();
    typeModel.add(new OccurrenceFilterCreator());
    typeModel.add(new SimilarityFilterCreator());
    typeModel.add(new TFIDFFilterCreator());
    typeModel.add(new TFFilterCreator());
    BufferedValueModel model = adapter.getBufferedModel("nodeFilter");
    SelectionInList<TSFilterCreator> list = new SelectionInList<TSFilterCreator>((ListModel) typeModel, model);
    Bindings.bind(filterBox, list);
    filterBox.setSelectedIndex(0);

    model = adapter.getBufferedModel("nodeThresh");
    DefaultFormatter numberFormatter = new NumberFormatter(new DecimalFormat("0.0#######"));
    DefaultFormatterFactory fmtFactory = new DefaultFormatterFactory(numberFormatter);
    numberFormatter.setValueClass(Double.class);
    numberFormatter.setAllowsInvalid(false);
    numberFormatter.setOverwriteMode(false);
    nodeThreshFld.setFormatterFactory(fmtFactory);
    Bindings.bind(nodeThreshFld, model);

    model = adapter.getBufferedModel("edgeScoreThresh");
    scoreThreshFld.setFormatterFactory(fmtFactory);
    Bindings.bind(scoreThreshFld, model);

    model = adapter.getBufferedModel("edgeDocThresh");
    SpinnerNumberModel spnModel = SpinnerAdapterFactory.createNumberAdapter(model, 0, 0, Integer.MAX_VALUE, 1);
    docSpn.setModel(spnModel);


    ArrayListModel<EdgeCreatorCreator> edgeTypeModel = new ArrayListModel<EdgeCreatorCreator>();
    edgeTypeModel.add(new OccurenceEdgeCC());
    edgeTypeModel.add(new SVEdgeCC());
    edgeTypeModel.add(new TFEdgeCC());
    edgeTypeModel.add(new TFIDFEdgeCC());

    model = adapter.getBufferedModel("edgeFilter");
    SelectionInList<EdgeCreatorCreator> edgeList = new SelectionInList<EdgeCreatorCreator>((ListModel) edgeTypeModel,
            model);
    Bindings.bind(edgeFilterBox, edgeList);
    edgeFilterBox.setSelectedIndex(0);
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    nodeSep = new TitledSeparator();
    label1 = new JLabel();
    filterBox = new JComboBox();
    ntLbl = new JLabel();
    nodeThreshFld = new JFormattedTextField();
    edgeSep = new TitledSeparator();
    label2 = new JLabel();
    edgeFilterBox = new JComboBox();
    label3 = new JLabel();
    docSpn = new JSpinner();
    stLbl = new JLabel();
    scoreThreshFld = new JFormattedTextField();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setBorder(null);
    setLayout(new FormLayout(
            new ColumnSpec[]{
                    FormFactory.RELATED_GAP_COLSPEC,
                    FormFactory.DEFAULT_COLSPEC,
                    FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                    new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
            },
            new RowSpec[]{
                    FormFactory.DEFAULT_ROWSPEC,
                    FormFactory.LINE_GAP_ROWSPEC,
                    FormFactory.DEFAULT_ROWSPEC,
                    FormFactory.LINE_GAP_ROWSPEC,
                    FormFactory.DEFAULT_ROWSPEC,
                    FormFactory.LINE_GAP_ROWSPEC,
                    FormFactory.DEFAULT_ROWSPEC,
                    FormFactory.LINE_GAP_ROWSPEC,
                    FormFactory.DEFAULT_ROWSPEC,
                    FormFactory.LINE_GAP_ROWSPEC,
                    FormFactory.DEFAULT_ROWSPEC,
                    FormFactory.LINE_GAP_ROWSPEC,
                    FormFactory.DEFAULT_ROWSPEC
            }));

    //---- nodeSep ----
    nodeSep.setBarAlignment(1);
    add(nodeSep, cc.xywh(1, 1, 4, 1));

    //---- label1 ----
    label1.setText("Filter:");
    add(label1, cc.xy(2, 3));
    add(filterBox, cc.xy(4, 3));

    //---- ntLbl ----
    ntLbl.setText("Threshold:");
    add(ntLbl, cc.xy(2, 5));
    add(nodeThreshFld, cc.xy(4, 5));

    //---- edgeSep ----
    edgeSep.setBarAlignment(1);
    add(edgeSep, cc.xywh(1, 7, 4, 1));

    //---- label2 ----
    label2.setText("Filter:");
    add(label2, cc.xy(2, 9));
    add(edgeFilterBox, cc.xy(4, 9));

    //---- label3 ----
    label3.setText("Document Threshold:");
    add(label3, cc.xy(2, 11));
    add(docSpn, cc.xy(4, 11));

    //---- stLbl ----
    stLbl.setText("Score Threshold:");
    add(stLbl, cc.xy(2, 13));
    add(scoreThreshFld, cc.xy(4, 13));
    // JFormDesigner - End of component initialization  //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private TitledSeparator nodeSep;
  private JLabel label1;
  private JComboBox filterBox;
  private JLabel ntLbl;
  private JFormattedTextField nodeThreshFld;
  private TitledSeparator edgeSep;
  private JLabel label2;
  private JComboBox edgeFilterBox;
  private JLabel label3;
  private JSpinner docSpn;
  private JLabel stLbl;
  private JFormattedTextField scoreThreshFld;
  // JFormDesigner - End of variables declaration  //GEN-END:variables
}
