/*
 * Created by JFormDesigner on Wed May 20 13:43:12 EDT 2009
 */

package anl.aida.client.gui;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.jdesktop.swingx.renderer.DefaultListRenderer;

import anl.aida.client.Cache;
import anl.aida.query.Trigger;

import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.ColumnSpec;
import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.FormSpec;
import com.jgoodies.forms.layout.RowSpec;
import com.jgoodies.forms.layout.Sizes;

/**
 * @author User #1
 */
public class TriggerPanel extends JPanel {

  private static class TriggerNameRenderer extends DefaultListRenderer {
    @Override
    public Component getListCellRendererComponent(JList list, Object value, int index,
	boolean isSelected, boolean cellHasFocus) {
      if (value != null)
	value = ((Trigger) value).getName();
      return super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
    }

  }

  private Cache cache;
  private Trigger selectedTrigger;
  private boolean dirty = false;

  public TriggerPanel() {
    initComponents();
    triggerList.setCellRenderer(new TriggerNameRenderer());
    queryArea.setWrapStyleWord(true);
    addListeners();
    resultsArea.setFont(new Font("Monospaced", Font.PLAIN, 12));
  }

  private void addListeners() {
    splitPane1.setDividerLocation(140);
    deleteBtn.setEnabled(false);
    runBtn.setEnabled(false);
    
    runBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	saveTrigger();
	tabbedPane1.setSelectedIndex(1);
	resultsArea.setText("");
	resultsArea.append("--- Testing Alert ---\n");
	resultsArea.append("\nAlert Name: " + selectedTrigger.getName());
	resultsArea.append("\nAlert Query: " + selectedTrigger.getQuery() + "\n");  
	TriggerRunnerWorker worker = new TriggerRunnerWorker(selectedTrigger, cache, resultsArea);
	worker.execute();
      }
    });
    
    addBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	if (dirty) saveTrigger();
	Trigger trigger = new Trigger("New Alert", "", "");
	DefaultListModel model = (DefaultListModel) triggerList.getModel();
	model.addElement(trigger);
	triggerList.setSelectedIndex(model.getSize() - 1);
      }
    });

    deleteBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
	if (selectedTrigger != null) {
	  int result = JOptionPane.showConfirmDialog(TriggerPanel.this,
	      "Do you wish to delete the selected trigger", "Delete Alert?", JOptionPane.YES_NO_OPTION,
	      JOptionPane.QUESTION_MESSAGE);
	  if (result == JOptionPane.YES_OPTION) {
	    int index = triggerList.getSelectedIndex();
	    DefaultListModel model = (DefaultListModel) triggerList.getModel();
	    model.remove(index);
	    selectedTrigger = null;
	    if (model.size() > index) {
	      triggerList.setSelectedIndex(index);
	    } else {
	      triggerList.setSelectedIndex(-1);
	    }
	  }
	}
      }
    });

    triggerList.addListSelectionListener(new ListSelectionListener() {
      @Override
      public void valueChanged(ListSelectionEvent e) {
	if (dirty) {
	  saveTrigger();
	}
	if (!e.getValueIsAdjusting()) {
	  selectedTrigger = (Trigger) triggerList.getSelectedValue();
	  if (selectedTrigger == null) {
	    nameFld.setText("");
	    queryArea.setText("");
	    emailFld.setText("");
	  } else {
	    nameFld.setText(selectedTrigger.getName());
	    queryArea.setText(selectedTrigger.getQuery());
	    emailFld.setText(selectedTrigger.getEmail());
	    dirty = true;
	  }
	}

	deleteBtn.setEnabled(selectedTrigger != null);
	runBtn.setEnabled(selectedTrigger != null);
      }
    });
  }

  protected void saveTrigger() {
    if (selectedTrigger != null) {
      selectedTrigger.setEmail(emailFld.getText().trim());
      selectedTrigger.setName(nameFld.getText().trim());
      selectedTrigger.setQuery(queryArea.getText().trim());
      dirty = false;
    }
  }

  public void init(List<Trigger> triggers, Cache cache) {
    this.cache = cache;
    DefaultListModel model = new DefaultListModel();
    for (Trigger trigger : triggers) {
      model.addElement(trigger);
    }
    triggerList.setModel(model);
    if (model.size() > 0) triggerList.setSelectedIndex(0);
  }
  
  public List<Trigger> getAlerts() {
    List<Trigger> triggers = new ArrayList<Trigger>();
    DefaultListModel model = (DefaultListModel) triggerList.getModel();
    for (int i = 0; i < model.size(); i++) {
      triggers.add((Trigger)model.get(i));
    }
    
    return triggers;
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY
    // //GEN-BEGIN:initComponents
	// Generated using JFormDesigner non-commercial license
	splitPane1 = new JSplitPane();
	panel1 = new JPanel();
	toolBar1 = new JToolBar();
	addBtn = new JButton();
	deleteBtn = new JButton();
	scrollPane1 = new JScrollPane();
	triggerList = new JList();
	tabbedPane1 = new JTabbedPane();
	panel2 = new JPanel();
	label1 = new JLabel();
	nameFld = new JTextField();
	label2 = new JLabel();
	scrollPane2 = new JScrollPane();
	queryArea = new JTextArea();
	label3 = new JLabel();
	emailFld = new JTextField();
	panel4 = new JPanel();
	runBtn = new JButton();
	panel3 = new JPanel();
	scrollPane3 = new JScrollPane();
	resultsArea = new JTextArea();
	CellConstraints cc = new CellConstraints();

	//======== this ========
	setBorder(new EmptyBorder(5, 5, 5, 5));
	setLayout(new BorderLayout());

	//======== splitPane1 ========
	{
		splitPane1.setResizeWeight(0.3);
		splitPane1.setBorder(null);

		//======== panel1 ========
		{
			panel1.setLayout(new BorderLayout());

			//======== toolBar1 ========
			{
				toolBar1.setFloatable(false);

				//---- addBtn ----
				addBtn.setText("+");
				toolBar1.add(addBtn);

				//---- deleteBtn ----
				deleteBtn.setText("-");
				toolBar1.add(deleteBtn);
			}
			panel1.add(toolBar1, BorderLayout.NORTH);

			//======== scrollPane1 ========
			{

				//---- triggerList ----
				triggerList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
				scrollPane1.setViewportView(triggerList);
			}
			panel1.add(scrollPane1, BorderLayout.CENTER);
		}
		splitPane1.setLeftComponent(panel1);

		//======== tabbedPane1 ========
		{

			//======== panel2 ========
			{
				panel2.setBorder(new EmptyBorder(5, 5, 5, 5));
				panel2.setLayout(new FormLayout(
					ColumnSpec.decodeSpecs("default:grow"),
					new RowSpec[] {
						FormFactory.UNRELATED_GAP_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC,
						FormFactory.LINE_GAP_ROWSPEC,
						FormFactory.DEFAULT_ROWSPEC
					}));

				//---- label1 ----
				label1.setText("Name:");
				panel2.add(label1, cc.xy(1, 3));
				panel2.add(nameFld, cc.xy(1, 5));

				//---- label2 ----
				label2.setText("Query:");
				panel2.add(label2, cc.xy(1, 7));

				//======== scrollPane2 ========
				{

					//---- queryArea ----
					queryArea.setRows(3);
					queryArea.setLineWrap(true);
					queryArea.setColumns(40);
					scrollPane2.setViewportView(queryArea);
				}
				panel2.add(scrollPane2, cc.xy(1, 9));

				//---- label3 ----
				label3.setText("Send Alerts To:");
				panel2.add(label3, cc.xy(1, 11));
				panel2.add(emailFld, cc.xy(1, 13));

				//======== panel4 ========
				{
					panel4.setLayout(new FlowLayout(FlowLayout.RIGHT));

					//---- runBtn ----
					runBtn.setText("Test");
					panel4.add(runBtn);
				}
				panel2.add(panel4, cc.xy(1, 15));
			}
			tabbedPane1.addTab("Alert", panel2);


			//======== panel3 ========
			{
				panel3.setLayout(new BorderLayout());

				//======== scrollPane3 ========
				{
					scrollPane3.setViewportView(resultsArea);
				}
				panel3.add(scrollPane3, BorderLayout.CENTER);
			}
			tabbedPane1.addTab("Test Results", panel3);

		}
		splitPane1.setRightComponent(tabbedPane1);
	}
	add(splitPane1, BorderLayout.CENTER);
    // JFormDesigner - End of component initialization //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JSplitPane splitPane1;
  private JPanel panel1;
  private JToolBar toolBar1;
  private JButton addBtn;
  private JButton deleteBtn;
  private JScrollPane scrollPane1;
  private JList triggerList;
  private JTabbedPane tabbedPane1;
  private JPanel panel2;
  private JLabel label1;
  private JTextField nameFld;
  private JLabel label2;
  private JScrollPane scrollPane2;
  private JTextArea queryArea;
  private JLabel label3;
  private JTextField emailFld;
  private JPanel panel4;
  private JButton runBtn;
  private JPanel panel3;
  private JScrollPane scrollPane3;
  private JTextArea resultsArea;
  // JFormDesigner - End of variables declaration //GEN-END:variables
}
