/*
 * Created by JFormDesigner on Mon Mar 02 13:42:02 EST 2009
 */

package anl.aida.client.gui;

import static anl.aida.client.gui.VizPropertyBean.Type.*;

import com.jgoodies.binding.PresentationModel;
import com.jgoodies.binding.adapter.Bindings;
import com.jgoodies.binding.list.ArrayListModel;
import com.jgoodies.binding.list.SelectionInList;
import com.jgoodies.binding.value.BufferedValueModel;
import com.jgoodies.binding.value.Trigger;
import com.jgoodies.forms.factories.Borders;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.*;
import com.jidesoft.swing.TitledSeparator;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author User #1
 */
public class VizDialog extends JDialog {

  private VizPropertyBean bean;
  private Trigger trigger = new Trigger();

  public VizDialog(Frame owner) {
    super(owner);
    initComponents();
    init();
  }

  public VizDialog(Dialog owner) {
    super(owner);
    initComponents();
    init();
  }

  private void init() {
    addListeners();

    ((JLabel) titleSep.getLabelComponent()).setText("General");
    titleSep.setBarAlignment(SwingConstants.CENTER);
    titleSep.setTextAlignment(SwingConstants.LEFT);
    
    this.getRootPane().setDefaultButton(okButton);
  }

  public void init(VizPropertyBean bean) {
    this.bean = bean;
    PresentationModel<VizPropertyBean> adapter = new PresentationModel<VizPropertyBean>(this.bean, trigger);
    BufferedValueModel model = adapter.getBufferedModel("title");
    Bindings.bind(titleFld, model);

    ArrayListModel<VizPropertyBean.Type> typeModel = new ArrayListModel<VizPropertyBean.Type>();
    typeModel.add(NETWORK);
    typeModel.add(TIME_SERIES);
    //typeModel.add(CLUSTER);
    model = adapter.getBufferedModel("type");
    SelectionInList<VizPropertyBean.Type> list = new SelectionInList<VizPropertyBean.Type>((ListModel) typeModel, model);
    Bindings.bind(typeCmb, list);

    model = adapter.getBufferedModel("twod");
    Bindings.bind(twoDBox, model);

    model = adapter.getBufferedModel("threed");
    Bindings.bind(threeDBox, model);
    
    ButtonGroup grp = new ButtonGroup();
    grp.add(twoDBox);
    grp.add(threeDBox);

    optionsPnl.init(adapter);
  }

  private void addListeners() {

    cancelButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        bean.setCanceled(true);
        dispose();
      }
    });

    okButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        trigger.triggerCommit();
        bean.setCanceled(false);
        dispose();
      }
    });

    typeCmb.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        optionsPnl.setEnabled(typeCmb.getSelectedIndex() == 0);
        threeDBox.setEnabled(typeCmb.getSelectedIndex() == 0);
      }
    });
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    dialogPane = new JPanel();
    contentPanel = new JPanel();
    titleSep = new TitledSeparator();
    label2 = new JLabel();
    titleFld = new JTextField();
    label1 = new JLabel();
    typeCmb = new JComboBox();
    twoDBox = new JCheckBox();
    threeDBox = new JCheckBox();
    optionsPnl = new GraphOptionsPanel();
    buttonBar = new JPanel();
    okButton = new JButton();
    cancelButton = new JButton();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    setModal(true);
    setTitle("Configure Visualization");
    Container contentPane = getContentPane();
    contentPane.setLayout(new BorderLayout());

    //======== dialogPane ========
    {
      dialogPane.setBorder(Borders.DIALOG_BORDER);
      dialogPane.setLayout(new BorderLayout());

      //======== contentPanel ========
      {
        contentPanel.setLayout(new FormLayout(
                new ColumnSpec[]{
                        FormFactory.RELATED_GAP_COLSPEC,
                        FormFactory.DEFAULT_COLSPEC,
                        FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                        new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
                        FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                        FormFactory.DEFAULT_COLSPEC,
                        FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                        FormFactory.DEFAULT_COLSPEC
                },
                new RowSpec[]{
                        FormFactory.DEFAULT_ROWSPEC,
                        FormFactory.LINE_GAP_ROWSPEC,
                        FormFactory.DEFAULT_ROWSPEC,
                        FormFactory.LINE_GAP_ROWSPEC,
                        FormFactory.DEFAULT_ROWSPEC,
                        FormFactory.UNRELATED_GAP_ROWSPEC,
                        new RowSpec(RowSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW)
                }));

        //---- titleSep ----
        titleSep.setBarAlignment(1);
        contentPanel.add(titleSep, cc.xywh(1, 1, 8, 1));

        //---- label2 ----
        label2.setText("Title:");
        label2.setLabelFor(titleFld);
        contentPanel.add(label2, cc.xy(2, 3));
        contentPanel.add(titleFld, cc.xywh(4, 3, 5, 1));

        //---- label1 ----
        label1.setText("Type:");
        label1.setLabelFor(typeCmb);
        contentPanel.add(label1, cc.xy(2, 5));
        contentPanel.add(typeCmb, cc.xywh(4, 5, 2, 1));

        //---- twoDBox ----
        twoDBox.setText("2D");
        twoDBox.setSelected(true);
        contentPanel.add(twoDBox, cc.xy(6, 5));

        //---- threeDBox ----
        threeDBox.setText("3D");
        contentPanel.add(threeDBox, cc.xy(8, 5));
        contentPanel.add(optionsPnl, cc.xywh(1, 7, 8, 1));
      }
      dialogPane.add(contentPanel, BorderLayout.CENTER);

      //======== buttonBar ========
      {
        buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
        buttonBar.setLayout(new FormLayout(
                new ColumnSpec[]{
                        FormFactory.GLUE_COLSPEC,
                        FormFactory.BUTTON_COLSPEC,
                        FormFactory.RELATED_GAP_COLSPEC,
                        FormFactory.BUTTON_COLSPEC
                },
                RowSpec.decodeSpecs("pref")));

        //---- okButton ----
        okButton.setText("OK");
        buttonBar.add(okButton, cc.xy(2, 1));

        //---- cancelButton ----
        cancelButton.setText("Cancel");
        buttonBar.add(cancelButton, cc.xy(4, 1));
      }
      dialogPane.add(buttonBar, BorderLayout.SOUTH);
    }
    contentPane.add(dialogPane, BorderLayout.CENTER);
    pack();
    setLocationRelativeTo(getOwner());
    // JFormDesigner - End of component initialization  //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JPanel dialogPane;
  private JPanel contentPanel;
  private TitledSeparator titleSep;
  private JLabel label2;
  private JTextField titleFld;
  private JLabel label1;
  private JComboBox typeCmb;
  private JCheckBox twoDBox;
  private JCheckBox threeDBox;
  private GraphOptionsPanel optionsPnl;
  private JPanel buttonBar;
  private JButton okButton;
  private JButton cancelButton;
  // JFormDesigner - End of variables declaration  //GEN-END:variables
}
