package anl.aida.client.gui;

import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import anl.aida.client.Keyword;
import anl.aida.client.net.EdgeCreatorCreator;
import anl.aida.client.net.TSFilterCreator;

import com.jgoodies.binding.beans.ExtendedPropertyChangeSupport;

/**
 *         Date: Mar 2, 2009 2:08:26 PM
 */
public class VizPropertyBean {

  private boolean canceled = true;

  public enum Type {

    NETWORK() {
      public String toString() {
        return "Semantic Map";
      }
    },

    CLUSTER() {
      public String toString() {
        return "Spatial Map";
      }
    },
    
    TIME_SERIES() {
      public String toString() {
	return "Time Series";
      }
    }
  }

  private String title;
  private List<Keyword> keywords;
  private boolean twod, threed;
  private Type type = Type.NETWORK;
  private TSFilterCreator nodeFilter;
  private double nodeThresh, edgeScoreThresh;
  private EdgeCreatorCreator edgeFilter;
  private int edgeDocThresh = 1;

  protected ExtendedPropertyChangeSupport pcs = new ExtendedPropertyChangeSupport(this);

  public VizPropertyBean(String title, List<? extends Keyword> keywords) {
    this.title = title;
    this.keywords = new ArrayList<Keyword>(keywords);
    twod = true;
    threed = false;
  }

  public String toString() {
    StringBuilder buf = new StringBuilder("VizPropertyBean[title=");
    buf.append(title);
    buf.append(", twod=");
    buf.append(twod);
    buf.append(", threed=");
    buf.append(threed);

    buf.append(", type=");
    buf.append(type);
    buf.append(", nodeFilter=");
    buf.append(nodeFilter);
    buf.append(", nodeThresh=");
    buf.append(nodeThresh);
    buf.append(", edgeScoreThresh=");
    buf.append(edgeScoreThresh);
    buf.append(", edgeFilter=");
    buf.append(edgeFilter);
    buf.append(", edgeDocThresh=");
    buf.append(edgeDocThresh);
    buf.append("]");
    return buf.toString();
  }

  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    if (!title.equals(this.title)) {
      String old = this.title;
      this.title = title;
      pcs.firePropertyChange("title", old, this.title);

    }
  }

  public Type getType() {
    return type;
  }

  public void setType(Type type) {
    if (this.type != type) {
      Type old = this.type;
      this.type = type;
      pcs.firePropertyChange("type", old, this.type);
    }
  }

  public boolean isTwod() {
    return twod;
  }

  public void setTwod(boolean twod) {
    if (twod != this.twod) {
      boolean old = this.twod;
      this.twod = twod;
      pcs.firePropertyChange("twod", old, this.twod);
    }
  }

  public boolean isThreed() {
    return threed;
  }

  public void setThreed(boolean threed) {
    if (threed != this.threed) {
      boolean old = this.threed;
      this.threed = threed;
      pcs.firePropertyChange("threed", old, this.threed);
    }
  }

  public EdgeCreatorCreator getEdgeFilter() {
    return edgeFilter;
  }

  public void setEdgeFilter(EdgeCreatorCreator edgeFilter) {
    EdgeCreatorCreator old = this.edgeFilter;
    this.edgeFilter = edgeFilter;
    pcs.firePropertyChange("edgeFilter", old, this.edgeFilter);
  }

  public TSFilterCreator getNodeFilter() {
    return nodeFilter;
  }

  public void setNodeFilter(TSFilterCreator nodeFilter) {
    TSFilterCreator old = this.nodeFilter;
    this.nodeFilter = nodeFilter;
    pcs.firePropertyChange("nodeFilter", old, this.nodeFilter);
  }

  public double getNodeThresh() {
    return nodeThresh;
  }

  public void setNodeThresh(double nodeThresh) {
    if (this.nodeThresh != nodeThresh) {
      double old = this.nodeThresh;
      this.nodeThresh = nodeThresh;
      pcs.firePropertyChange("nodeThresh", old, this.nodeThresh);
    }
  }

  public double getEdgeScoreThresh() {
    return edgeScoreThresh;
  }

  public void setEdgeScoreThresh(double edgeScoreThresh) {
    if (this.edgeScoreThresh != edgeScoreThresh) {
      double old = this.edgeScoreThresh;
      this.edgeScoreThresh = edgeScoreThresh;
      pcs.firePropertyChange("edgeScoreThresh", old, this.edgeScoreThresh);
    }
  }

  public int getEdgeDocThresh() {
    return edgeDocThresh;
  }

  public void setEdgeDocThresh(int edgeDocThresh) {
    if (this.edgeDocThresh != edgeDocThresh) {
      int old = this.edgeDocThresh;
      this.edgeDocThresh = edgeDocThresh;
      pcs.firePropertyChange("edgeDocThresh", old, this.edgeDocThresh);
    }
  }

  public List<Keyword> getKeywords() {
    return keywords;
  }

  public boolean isCanceled() {
    return canceled;
  }

  public void setCanceled(boolean canceled) {
    this.canceled = canceled;
  }

  public void addPropertyChangeListener(PropertyChangeListener x) {
    pcs.addPropertyChangeListener(x);
  }

  public void removePropertyChangeListener(PropertyChangeListener x) {
    pcs.removePropertyChangeListener(x);
  }
}
