/**
 * 
 */
package anl.aida.client.io;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import anl.aida.query.Trigger;

/**
 * Parses an alert file into triggers.
 * 
 */
public class AlertFileIO {

  public List<Trigger> read(String filename) throws IOException {
    BufferedReader reader = null;
    List<Trigger> triggers = new ArrayList<Trigger>();
    try {
      reader = new BufferedReader(new FileReader(new File(filename)));
      String line;

      int i = 0;
      String lines[] = new String[3];
      while ((line = reader.readLine()) != null) {
	lines[i] = line;
	i++;
	if (i == 3) {
	  Trigger trigger = new Trigger(lines[0], lines[1], lines[2]);
	  triggers.add(trigger);
	  i = 0;
	}
      }
    } finally {
      if (reader != null)
	reader.close();
    }

    return triggers;
  }

  public void write(List<Trigger> triggers, String filename) throws IOException {
    PrintWriter writer = null;
    try {
      writer = new PrintWriter(new BufferedWriter(new FileWriter(filename)));
      for (Trigger trigger : triggers) {
	writer.println(trigger.getName());
	String query = trigger.getQuery();
	query = query.replace(System.getProperty("line.separator"), " ");
	writer.println(query);
	writer.println(trigger.getEmail());
      }
    } finally {
      if (writer != null)
	writer.close();
    }
  }
}
