/**
 * 
 */
package anl.aida.client.io;

import java.awt.event.ActionEvent;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.JComponent;

import simphony.util.messages.MessageCenter;
import sun.swing.SwingUtilities2;

/**
 * Action that invoked the ImageExporter on a specified component.
 * 
 */
public class ImageExportAction extends AbstractAction {
  
  private static final MessageCenter ctr = MessageCenter.getMessageCenter(ImageExportAction.class);
  
  private JComponent comp;
  
  public ImageExportAction(JComponent comp) {
    super("Export As Image");
    this.comp = comp;
  }
  
  public void actionPerformed(ActionEvent e) {
    try {
      ImageExporter exporter = new ImageExporter(new ImageableComponent(comp));
      exporter.run(comp);
    } catch (IOException ex) {
      ctr.error("Error while exporting plot as image", ex);
    }
  }
}
