/**
 * 
 */
package anl.aida.client.io;

import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;

/**
 * Wraps a JComponent in the imageable interface.
 * 
 */
public class ImageableComponent implements Imageable {
  
  private JComponent comp;
  
  public ImageableComponent(JComponent comp) {
    this.comp = comp;
  }

  /* (non-Javadoc)
   * @see anl.mifs.client.io.Imageable#createImage()
   */
  @Override
  public BufferedImage createImage() {
    Rectangle bounds = comp.getBounds();
    BufferedImage img = comp.getGraphicsConfiguration().createCompatibleImage(bounds.width, bounds.height);
    Graphics2D g2d = img.createGraphics();
    comp.paint(g2d);
    g2d.dispose();
    return img;
  }
}
