package anl.aida.client.net;

import anl.aida.client.doc.DocumentContainer;
import anl.aida.core.DocumentID;

/**
 * Interface for classes that implement an edge.
 * CGEdges have a set of documents associated with them.
 *
 */
public interface CGEdge extends DocumentContainer {

  /**
   * Gets an iterable over the docs associated with this
   * edge.
   *
   * @return an iterable over the docs associated with this
   *         edge.
   */
  Iterable<DocumentID> documents();

  /**
   * Gets the number of documents associated with this edge.
   *
   * @return the number of documents associated with this edge.
   */
  int getDocumentCount();

  /**
   * Gets a label for this edge.
   *
   * @return a label for this edge.
   */
  String getLabel();


}
