package anl.aida.client.net;

import anl.aida.client.DocSetID;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.util.Pair;

import java.util.Collection;

/**
 *         Date: Feb 25, 2009 3:19:12 PM
 */
public class ConceptGraph<T> {

  private Graph<T, CGEdge> graph;
  private String title;
  private DocSetID docSetID;


  public ConceptGraph(String title, DocSetID docSetID, Graph<T, CGEdge> graph) {
    this.title = title;
    this.docSetID = docSetID;
    this.graph = graph;
  }

  public DocSetID getDocSetID() {
    return docSetID;
  }

  public String getTitle() {
    return title;
  }

  public Graph<T, CGEdge> getGraph() {
    return graph;
  }

  public Collection<T> getVertices() {
    return graph.getVertices();
  }

  public int getVertexCount() {
    return graph.getVertexCount();
  }

  public Collection<CGEdge> getInEdges(T t) {
    return graph.getInEdges(t);
  }

  public Collection<CGEdge> getEdges() {
    return graph.getEdges();
  }

  public Pair<T> getEndpoints(CGEdge cgEdge) {
    return graph.getEndpoints(cgEdge);
  }
}
