package anl.aida.client.net;

import edu.uci.ics.jung.graph.Graph;

/**
 * Interface for classes that implement edge creation. Implementors
 * should both evaluate whether the edge should be created and
 * and if so, then return the appropriate implementation.
 *
 */
public interface EdgeCreator {

  /**
   * Creates an edge between the two nodes if they should
   * be linked according to some implementor specific criteria.
   *
   * @param node1 the first node
   * @param node2 the second node
   * @param graph the graph where the edge will be created
   * @return boolean if the edge created, otherwise false.
   */
  boolean createEdge(TermNode node1, TermNode node2, Graph<TermNode, CGEdge> graph);
}
