package anl.aida.client.net;

import anl.aida.client.CacheElement;

/**
 * Interface for classes that create EdgeCreators.
 *
 */
public interface EdgeCreatorCreator {

  /**
   * Gets a descriptive label for the EdgeCreatorCreator.
   *
   * @return a descriptive label for the EdgeCreatorCreator.
   */
  String getLabel();

  /**
   * Creates an EdgeCreator from the specified parameters.
   *
   * @param element        the element used to get the STC, etc.
   * @param docThreshold   the shared doc count threshold
   * @param scoreThreshold the score threshold, if necessary
   * @return the created EdgeCreator.
   */
  EdgeCreator createEdgeCreator(CacheElement element, int docThreshold, float scoreThreshold);
}
