package anl.aida.client.net;

import anl.aida.client.CacheElement;
import anl.aida.score.OccurrenceFilter;
import anl.aida.score.TermScoreFilter;

/**
 * Creates an OccurrenceFilter.
 */
public class OccurrenceFilterCreator implements TSFilterCreator {

  /**
   * Gets a label for this creator.
   *
   * @return
   */
  public String getLabel() {
    return "Concept Occurrence";
  }

  /**
   * Creates a TermScoreFilter using the element and val.
   *
   * @param element the element to use -- getSTC etc from
   * @param val     a value to use (e.g. threshold).
   * @return the created TermScoreFilter
   */
  public TermScoreFilter createFilter(CacheElement element, float val) {
    return new OccurrenceFilter(element.getSTC());
  }
}
