package anl.aida.client.net;

import anl.aida.client.CacheElement;
import anl.aida.score.SVScorer;
import anl.aida.score.Scorer;
import anl.aida.score.ScorerThresholdFilter;
import anl.aida.score.TermScoreFilter;

/**
 * Creates a ScorerThresholdFilter that filters based on
 * similarity being >= to some threshold.
 *
 */
public class SimilarityFilterCreator implements TSFilterCreator {

  /**
   * Gets a label for this creator.
   *
   * @return
   */
  public String getLabel() {
    return "Semantic Vector Similarity";
  }

  /**
   * Creates a TermScoreFilter using the element and val.
   *
   * @param element the element to use -- getSTC etc from
   * @param val     a value to use (e.g. threshold).
   * @return the created TermScoreFilter
   */
  public TermScoreFilter createFilter(CacheElement element, float val) {
    Scorer scorer = new SVScorer(element.getSVS());
    return new ScorerThresholdFilter(scorer, val);
  }
}