package anl.aida.client.net;

import anl.aida.client.CacheElement;
import anl.aida.score.Scorer;
import anl.aida.score.ScorerThresholdFilter;
import anl.aida.score.TFScorer;

/**
 * 
 */
public class TFEdgeCC implements EdgeCreatorCreator {

  /**
   * Gets a descriptive label for the EdgeCreatorCreator.
   *
   * @return a descriptive label for the EdgeCreatorCreator.
   */
  public String getLabel() {
    return "Term Frequency Count";
  }

  /**
   * Creates an EdgeCreator from the specified parameters.
   *
   * @param element        the element used to get the STC, etc if necessary
   * @param docThreshold   the shared doc count threshold
   * @param scoreThreshold the score threshold, if necessary
   * @return the created EdgeCreator.
   */
  public EdgeCreator createEdgeCreator(CacheElement element, int docThreshold, float scoreThreshold) {
    Scorer scorer = new TFScorer(element.getSTC());
    return new ScorerThresholdEdgeCreator(docThreshold, new ScorerThresholdFilter(scorer, scoreThreshold));
  }
}