package anl.aida.client.net;

import anl.aida.client.CacheElement;
import anl.aida.score.Scorer;
import anl.aida.score.ScorerThresholdFilter;
import anl.aida.score.TFScorer;
import anl.aida.score.TermScoreFilter;

/**
 * Creates a ScorerThresholdFilter that filters based on
 * term frequency being >= to some threshold.
 *
 */
public class TFFilterCreator implements TSFilterCreator {

  /**
   * Gets a label for this creator.
   *
   * @return
   */
  public String getLabel() {
    return "Term Frequency Count";
  }

  /**
   * Creates a TermScoreFilter using the element and val.
   *
   * @param element the element to use -- getSTC etc from
   * @param val     a value to use (e.g. threshold).
   * @return the created TermScoreFilter
   */
  public TermScoreFilter createFilter(CacheElement element, float val) {
    Scorer scorer = new TFScorer(element.getSTC());
    return new ScorerThresholdFilter(scorer, val);
  }
}