package anl.aida.client.net;

import anl.aida.client.CacheElement;
import anl.aida.score.TermScoreFilter;

/**
 * Interface for classes that create TermScoreFilters.
 *
 */
public interface TSFilterCreator {

  /**
   * Gets a label for this creator.
   *
   * @return
   */
  String getLabel();

  /**
   * Creates a TermScoreFilter using the element and val.
   *
   * @param element the element to use -- getSTC etc from
   * @param val     a value to use (e.g. threshold).
   * @return the created TermScoreFilter
   */
  TermScoreFilter createFilter(CacheElement element, float val);
}
