package anl.aida.client.net;

import anl.aida.data.Axes;
import anl.aida.data.DataFrame;
import anl.aida.data.DataFrameAxis;
import anl.aida.data.DataFrameIndex;
import edu.uci.ics.jung.graph.Graph;
import edu.uci.ics.jung.graph.SparseGraph;

/**
 * Creates graphs from data frames and timesteps.
 */
public class ValueGraphCreator {

  public Graph<ValueNode, Object> createGraph(DataFrame frame, int timestep) {
    Graph<ValueNode, Object> graph = new SparseGraph<ValueNode, Object>();
    Axes<DataFrameAxis> axes = frame.getAxes();
    DataFrameIndex index = frame.getIndex();
    DataFrameAxis catAxis = axes.getNonTimeAxis();
    if (catAxis == null) {
      index.setTime(timestep);
      graph.addVertex(new ValueNode(frame.getDouble(index), frame.getVariable().getName()));
      
    } else {
      for (int i = 0; i < catAxis.getExtent(); i++) {
	String category = catAxis.getValueAsString(i);
	index.set(timestep, i);
	ValueNode node = new ValueNode(frame.getDouble(index), category);
	graph.addVertex(node);
      }
    }

    return graph;
  }
}
