package anl.aida.client.widget;

import anl.aida.client.net.ConceptGraph;
import anl.aida.client.net.TermNode;
import anl.aida.util.DateRange;

/**
 * Interface for classes that want to process a swap graph event.
 * 
 */
public interface GraphSwapable {
  
  /**
   * Swaps the current graph for the specified graph.
   * 
   * @param graph the new graph
   * @param range the date range the graph represents
   */
  void swapGraph(ConceptGraph<TermNode> graph, DateRange range);

}
