package anl.aida.client.widget;

import com.l2fprod.common.swing.JTaskPaneGroup;
import com.l2fprod.common.swing.plaf.TaskPaneGroupUI;

/**
 * Wraps L2f prods JTaskPane group so it uses a different UI
 * and a check box.
 *
 */
public class MTaskPaneGroup extends JTaskPaneGroup {

  private boolean selected = false;

  @Override
  public void setUI(TaskPaneGroupUI ui) {
    super.setUI(new MTaskPaneGroupUI());
  }

  /**
   * Gets whether or not this group is selected.
   *
   * @return whether or not this group is selected.
   */
  public boolean isSelected() {
    return selected;
  }

  /**
   * Sets the selection state of this group.
   *
   * @param selected the selection state
   */
  public void setSelected(boolean selected) {
    if (selected != this.selected) {
      this.selected = selected;
      repaint();
    }
  }
}
