/*
 * Created by JFormDesigner on Wed Mar 11 10:17:14 EDT 2009
 */

package anl.aida.client.widget;

import anl.aida.client.net.ConceptGraph;
import anl.aida.client.net.TSConceptGraphs;
import anl.aida.client.net.TermNode;
import anl.aida.util.DateRange;
import anl.aida.viz.NetworkDisplay;
import com.jgoodies.forms.factories.FormFactory;
import com.jgoodies.forms.layout.*;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

/**
 * @author User #1
 */
public class NetworkTimeSlider extends JPanel {

  private TSConceptGraphs graphs;
  private NetworkDisplay display;
  private int index = 0;

  private List<DateRange> ranges = new ArrayList<DateRange>();

  public NetworkTimeSlider() {
    initComponents();
  }

  public void init(NetworkDisplay display, TSConceptGraphs graphs, DateRange startRange) {
    dateLbl.setText(startRange.toString());
    this.graphs = graphs;
    this.display = display;
    int i = 0;
    for (DateRange range : graphs.getRanger().ranges()) {
      ranges.add(range);
      if (range.equals(startRange)) index = i;
      i++;
    }

    System.out.println("ranges.get(index) = " + ranges.get(index));

    nextBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (index < ranges.size() - 1) {
          index++;
          showGraph();
        }
      }
    });

    prevBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (index > 0) {
          index--;
          showGraph();
        }
      }
    });
  }

  private void showGraph() {
    DateRange range = ranges.get(index);
    dateLbl.setText(range.toString());
    ConceptGraph<TermNode> graph = graphs.getGraph(range);
    display.swapGraph(graph, null);
  }

  private void initComponents() {
    // JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    nextBtn = new JButton();
    dateLbl = new JLabel();
    prevBtn = new JButton();
    CellConstraints cc = new CellConstraints();

    //======== this ========
    setLayout(new FormLayout(
            new ColumnSpec[]{
                    FormFactory.DEFAULT_COLSPEC,
                    FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                    new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
                    FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
                    FormFactory.DEFAULT_COLSPEC
            },
            RowSpec.decodeSpecs("default")));

    //---- nextBtn ----
    nextBtn.setText("Next");
    add(nextBtn, cc.xy(1, 1));

    //---- dateLbl ----
    dateLbl.setText("text");
    add(dateLbl, cc.xy(3, 1));

    //---- prevBtn ----
    prevBtn.setText("Prev");
    add(prevBtn, cc.xy(5, 1));
    // JFormDesigner - End of component initialization  //GEN-END:initComponents
  }

  // JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
  // Generated using JFormDesigner non-commercial license
  private JButton nextBtn;
  private JLabel dateLbl;
  private JButton prevBtn;
  // JFormDesigner - End of variables declaration  //GEN-END:variables
}
