/**
 * 
 */
package anl.aida.gis;

import org.geotools.styling.Style;

import anl.aida.plot.PlotCreationException;

/**
 * Interface for classes that can produce a GIS style based on
 * an index value.
 * 
 */
public interface Styler {
  
  /**
   * Gets the style for the specified index.
   * 
   * @param index the index to get the style for
   * 
   * @return the style for the specified index.
   */
  Style getStyle(int index) throws PlotCreationException;

}
