package anl.aida.gis3D;

import gov.nasa.worldwind.WorldWindow;
import gov.nasa.worldwind.geom.LatLon;
import gov.nasa.worldwind.geom.Position;
import gov.nasa.worldwind.geom.Sector;

public class GIS3DUtils {

 public static Position getEyePositionForSector(WorldWindow worldWindow, Sector sector) {
    double delta_x = sector.getDeltaLonRadians();
    double delta_y = sector.getDeltaLatRadians();

    double earthRadius = worldWindow.getModel().getGlobe().getRadius();

    double horizDistance = earthRadius * delta_x;
    double vertDistance = earthRadius * delta_y;

    // Form a triangle consisting of the longest distance on the ground and the
    // ray from the eye to the center point
    // The ray from the eye to the midpoint on the ground bisects the FOV
    double distance = Math.max(horizDistance, vertDistance) / 2;
    double altitude = distance / Math.tan(worldWindow.getView().getFieldOfView().radians / 2);

    LatLon latlon = sector.getCentroid();
    return new Position(latlon, altitude);
  }

}
