package anl.aida.gis3D;

import gov.nasa.worldwind.geom.Angle;
import gov.nasa.worldwind.geom.LatLon;
import gov.nasa.worldwind.geom.Sector;

public class SectorCreator {

  private double minLat = Angle.POS90.getDegrees();
  private double minLon = Angle.POS180.getDegrees();
  private double maxLat = Angle.NEG90.getDegrees();
  private double maxLon = Angle.NEG180.getDegrees();

  public void addLatLon(LatLon latLon) {
    double lat = latLon.getLatitude().getDegrees();
    if (lat < minLat)
      minLat = lat;
    if (lat > maxLat)
      maxLat = lat;

    double lon = latLon.getLongitude().getDegrees();
    if (lon < minLon)
      minLon = lon;
    if (lon > maxLon)
      maxLon = lon;
  }

  public Sector createSector() {
    if (minLat == maxLat && minLon == maxLon)
      return Sector.EMPTY_SECTOR;

    return Sector.fromDegrees(minLat, maxLat, minLon, maxLon);
  }

}
