/**
 * 
 */
package anl.aida.plot;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import anl.aida.util.DateRange;

/**
 * Column key for a Category dataset. This key encapsulates a 
 * DateRange object.
 * 
 */
public class DateRangeColumnKey implements Comparable<DateRangeColumnKey> {
  
  private static DateFormat formatter = new SimpleDateFormat("MM/dd");
  
  DateRange range;
  String str;
  
  public DateRangeColumnKey(DateRange range) {
    this.range = range;
    str = formatter.format(range.getStart()) + " - " + formatter.format(range.getEnd());
  }

  @Override
  public int compareTo(DateRangeColumnKey o) {
    Date s1 = range.getStart();
    Date s2 = o.range.getStart();
    return s1.before(s2) ? -1 : s1.equals(s2) ? 0 : 1;
  }
  
  public String toString() {
    return str;
  }
}