/**
 * 
 */
package anl.aida.plot;

/**
 * Key for a plot row entry.
 * 
 */
public class PlotRowKey implements Comparable<PlotRowKey> {
  
  private String name;
  private double min = Double.POSITIVE_INFINITY, max = Double.NEGATIVE_INFINITY;
  private int index = -1;
  
  public PlotRowKey(String name, int index) {
    this(name);
    this.index = index;
  }
  public PlotRowKey(String name) {
    this.name = name;
  }
  
  void testMinMax(double val) {
    min = Math.min(min, val);
    max = Math.max(max, val);
  }

  @Override
  public int compareTo(PlotRowKey o) {
    return name.compareTo(o.name);
  }
  
  public String toString() {
    return name;
  }
  
  public int getIndex() {
    return index;
  }

  public String getName() {
    return name;
  }

  public double getMin() {
    return min;
  }

  public double getMax() {
    return max;
  }
  
  
}
