/**
 * 
 */
package anl.aida.plot;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Paint;
import java.awt.RenderingHints;
import java.awt.Shape;

import javax.swing.Icon;

/**
 * 
 */
public class ShapeIcon implements Icon {
  
  private Shape shape;
  private Paint paint;
  
  public ShapeIcon(Shape shape, Paint paint) {
    this.shape = shape;
    this.paint = paint;
  }

  /* (non-Javadoc)
   * @see javax.swing.Icon#getIconHeight()
   */
  @Override
  public int getIconHeight() {
    return shape.getBounds().height;
  }

  /* (non-Javadoc)
   * @see javax.swing.Icon#getIconWidth()
   */
  @Override
  public int getIconWidth() {
    return shape.getBounds().width + 6;
  }

  /* (non-Javadoc)
   * @see javax.swing.Icon#paintIcon(java.awt.Component, java.awt.Graphics, int, int)
   */
  @Override
  public void paintIcon(Component c, Graphics g, int x, int y) {
    Graphics2D g2 = (Graphics2D)g;
    int yOff = y + getIconHeight() / 2;
    int xOff = x + shape.getBounds().width;
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g2.translate(xOff, yOff);
    Paint old = g2.getPaint();
    g2.setPaint(paint);
    g2.fill(shape);
    g2.setPaint(old);
    g2.translate(-xOff, -yOff);
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
  }
}
