/* Generated By:JJTree: Do not edit this line. ASTCount.java */

package anl.aida.query;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import anl.aida.core.ScoredTermsCollection;
import anl.aida.util.IntIterator;

public class ASTCount extends SimpleNode {
  public ASTCount(int id) {
    super(id);
  }

  public ASTCount(Parser p, int id) {
    super(p, id);
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.mifs.query.SimpleNode#getCacheKey()
   */
  @Override
  public String getCacheKey() {
    return "count(" + children[0].getCacheKey() + ")";
  }

  private double evaluateSingleTerm(Frame source) {
    String term = ((ASTVar) children[0].jjtGetChild(0)).getName();
    ScoredTermsCollection stc = source.getSTC();
    int index = stc.getTermIndex(term);
    if (index == -1)
      return 0;
    else
      return stc.getTerm(index).getDocumentCount();
  }

  // returns the number of documents that contain
  // every term in the VarList.
  private double evaluateMultTerm(Frame source) {
    int count = children[0].jjtGetNumChildren();
    List<Set<Integer>> docSets = new ArrayList<Set<Integer>>();
    ASTVarList list = (ASTVarList)children[0];
    for (int i = 0; i < count; i++) {
      String term = ((ASTVar)list.jjtGetChild(i)).getName();
      ScoredTermsCollection stc = source.getSTC();
      int index = stc.getTermIndex(term);
      if (index == -1) {
	return 0;
      } else {
	IntIterator iter = stc.getDocumentsFor(index);
	Set<Integer> set = new HashSet<Integer>();
	while (iter.hasNext()) {
	  set.add(iter.next());
	}
	docSets.add(set);
      }
    }
    
    Set<Integer> set = docSets.get(0);
    for (int i = 1; i < docSets.size(); i++) {
      set.retainAll(docSets.get(i));
      if (set.size() == 0) return 0;
    }
    
    //System.out.println("set = " + set);
    //System.out.printf("%s %d%n", source.getSTC().getRange().toString(), set.size());
    return set.size();
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.mifs.query.SimpleNode#evaluate(anl.mifs.query.Frame)
   */
  @Override
  public double evaluate(Frame source) {
    // worth while caching as mean may have run through all these already.
    String cacheKey = getCacheKey() + source.getCurrentElement().getHeader().getDateRange();
    Double result = source.getCacheVal(cacheKey);
    if (result == null) {
      if (children[0].jjtGetNumChildren() == 1) {
	result = evaluateSingleTerm(source);
      } else {
	result = evaluateMultTerm(source);
      }
      source.cacheVal(cacheKey, result);
    }

    return result;
  }
}
