/**
 * 
 */
package anl.aida.query;

import anl.aida.core.ScoredTermsCollection;

/**
 * A Query that always returns a constant numeric value.
 * 
 * @author Nick Collier
 */
public class ConstantQuery implements Query {
  
  private float val;
  
  /**
   * Creates a ConstantQuery that returns the specified val
   * on execution.
   * 
   * @param val the constant value to return
   */
  public ConstantQuery(float val) {
    this.val = val;
  }

  /* (non-Javadoc)
   * @see anl.mifs.query.Query#execute(anl.mifs.core.ScoredTermsCollection)
   */
  @Override
  public float execute(ScoredTermsCollection stc) {
    return val;
  }
}
