package anl.aida.query;

import java.util.HashMap;
import java.util.Map;

import anl.aida.client.Cache;
import anl.aida.client.CacheElement;
import anl.aida.core.ScoredTermsCollection;

public class Frame {
  
  private Cache cache;
  private CacheElement currentElement;
  private Map<String, Double> valCache = new HashMap<String, Double>();
  
  
  /**
   * @param cache
   * @param currentElement
   */
  public Frame(Cache cache, CacheElement currentElement) {
    this.cache = cache;
    this.currentElement = currentElement;
  }

  public ScoredTermsCollection getSTC() {
    return currentElement.getSTC();
  }
  
  public void cacheVal(String key, double val) {
    valCache.put(key, val);
  }
  
  public Double getCacheVal(String key) {
    return valCache.get(key);
  }
  
  public Cache getCache() {
    return cache;
  }
  
  public CacheElement getCurrentElement() {
    return currentElement;
  }
  
  public void setCurrentElement(CacheElement element) {
    this.currentElement = element;
  }

}
