/**
 * 
 */
package anl.aida.query;

import anl.aida.core.ScoredTermsCollection;

/**
 * Queries a scored terms collection for the frequency count (number of
 * documents it appears in) of some particular term.
 * 
 * @author Nick Collier
 */
public class FrequencyCountQuery implements Query {
  
  private String term;
  
  /**
   * @param term
   */
  public FrequencyCountQuery(String term) {
    this.term = term;
  }


  /* (non-Javadoc)
   * @see anl.mifs.query.Query#execute(anl.mifs.core.ScoredTermsCollection)
   */
  @Override
  public float execute(ScoredTermsCollection stc) {
    int index = stc.getTermIndex(term);
    if (index == -1) return 0;
    return stc.getTerm(index).getDocumentCount();
  }
}
