/**
 * 
 */
package anl.aida.query;

import java.io.StringReader;

import anl.aida.client.Cache;
import anl.aida.client.CacheElement;
import anl.aida.util.DateRange;
import anl.aida.util.DateRangeProducer;

/**
 * Runs queries over a cache.
 * 
 * @author Nick Collier
 */
public class QueryRunner {
  
  public void run(String query, Cache cache) throws ParseException {
    DateRangeProducer ranger = cache.getRanger();
    DateRange rng = ranger.ranges().iterator().next();
    Frame frame = new Frame(cache, cache.getElement(rng));
    String input = query;
    if (!input.endsWith(";")) input += ";";
    Parser parser = new Parser(new StringReader(input));
    ASTstart start = parser.start();
    for (DateRange range : cache.getRanger().ranges()) {
      CacheElement element = cache.getElement(range);
      frame.setCurrentElement(element);
      double val = start.evaluate(frame);
      System.out.printf("%s: %f%n", range.toString(), val);
      element.release();
    }
  }
}
