package anl.aida.query;

import anl.aida.core.ScoredTermsCollection;


public class TriggerOp {
  
  private BooleanOp op;
  private Query rhs, lhs;
  
  public TriggerOp(BooleanOp op, Query rhs, Query lhs) {
    this.op = op;
    this.rhs = rhs;
    this.lhs = lhs;
  }
  
  /**
   * Executes this operation against the
   * two queries.
   * 
   * @param rhs the right hand side of the operation
   * @param lhs the left hand side of the operation
   * @return the result of the operation.
   */
  boolean execute(ScoredTermsCollection stc) {
    float rhsVal = rhs.execute(stc);
    float lhsVal = lhs.execute(stc);
    return op.execute(rhsVal, lhsVal);
  }
}
