/**
 * 
 */
package anl.aida.query;

import java.util.ArrayList;
import java.util.List;

import anl.aida.util.DateRange;

/**
 * The result of running a Trigger.
 * 
 * @author Nick Collier
 */
public class TriggerResult {
  
  private boolean triggered;
  private String description;
  private List<DateRange> ranges = new ArrayList<DateRange>();
  
  public TriggerResult(boolean triggered, String description) {
    this.triggered = triggered;
    this.description = description;
  }
  
  public TriggerResult(boolean triggered, String description, DateRange range) {
    this(triggered, description);
    ranges.add(range);
  }
  
  public void addRange(DateRange range) {
    ranges.add(range);
  }
 
  /**
   * @return the description
   */
  public String getDescription() {
    return description;
  }

  /**
   * @return the range
   */
  public Iterable <DateRange> ranges() {
    return ranges;
  }

  public boolean isTriggered() {
    return triggered;
  }

}
