package anl.aida.table;

import javax.swing.table.AbstractTableModel;

import anl.aida.data.DataFrame;

/**
 * Abstract base class for table models based on DataFrames.
 * 
 * @version $Revision$ $Date$
 */
public abstract class AbstractDataFrameTableModel extends AbstractTableModel {
  
  protected DataFrame frame;
  protected int colCount;
  protected int rowCount;
  protected String colNames[];
  protected int colNameOffset, rowNameOffset;

  public AbstractDataFrameTableModel(DataFrame frame) {
    this.frame = frame;
  }

  /* (non-Javadoc)
   * @see javax.swing.table.AbstractTableModel#getColumnName(int)
   */
  @Override
  public String getColumnName(int column) {
    return colNames[column];
  }

  /* (non-Javadoc)
   * @see javax.swing.table.TableModel#getValueAt(int, int)
   */
  @Override
  public Object getValueAt(int rowIndex, int columnIndex) {
    // TODO Auto-generated method stub
    return null;
  }

  /**
   * Returns the number of columns in the model. A <code>JTable</code> uses this
   * method to determine how many columns it should create and display by
   * default.
   * 
   * @return the number of columns in the model
   * @see #getRowCount
   */
  public int getColumnCount() {
    return colCount;
  }

  /**
   * Returns the number of rows in the model. A <code>JTable</code> uses this
   * method to determine how many rows it should display. This method should be
   * quick, as it is called frequently during rendering.
   * 
   * @return the number of rows in the model
   * @see #getColumnCount
   */
  public int getRowCount() {
    return rowCount;
  }
}
