package anl.aida.table;

import anl.aida.data.Axes;
import anl.aida.data.DataFrame;
import anl.aida.data.DataFrameAxis;
import anl.aida.data.DataFrameIndex;
import anl.aida.data.Units;

/**
 * DataFrameTableModel that displays the time in one column and
 * values by category in the other columns.
 * 
 * @version $Revision$ $Date$
 */
public class TCategoryDataFrameTableModel extends AbstractDataFrameTableModel {
  
  private Axes<DataFrameAxis> axes;

  public TCategoryDataFrameTableModel(DataFrame frame) {
    super(frame);
    axes = frame.getAxes();
    rowCount = axes.getTimeAxis().getExtent();
    DataFrameAxis axis = axes.getNonTimeAxis();
    colCount = axis.getExtent() + 1;
    colNames = new String[colCount];
    colNames[0] = axes.getTimeAxis().getName();
    
    for (int i = 0; i < axis.getExtent(); i++) {
      colNames[i + 1] = axis.getValueAsString(i);
    }
  }

  /**
   * Returns the value for the cell at <code>columnIndex</code> and
   * <code>rowIndex</code>.
   * 
   * @return the value Object at the specified cell
   * @param rowIndex
   *          the row whose value is to be queried
   * @param columnIndex
   *          the column whose value is to be queried
   */
  public Object getValueAt(int rowIndex, int columnIndex) {
    if (columnIndex == 0) return axes.getDate(rowIndex);

    DataFrameIndex index = frame.getIndex();
    index.set(rowIndex, columnIndex - 1);
    return frame.getDouble(index);
  }
}
