package anl.aida.table;

import anl.aida.data.Axes;
import anl.aida.data.DataFrame;
import anl.aida.data.DataFrameAxis;
import anl.aida.data.DataFrameIndex;
import anl.aida.data.Units;

/**
 * DataFrameTableModel that displays the time in one column and
 * a variables value in the other.
 * 
 * @version $Revision$ $Date$
 */
public class TVDataFrameTableModel extends AbstractDataFrameTableModel {
  
  private Axes<DataFrameAxis> axes;

  public TVDataFrameTableModel(DataFrame frame) {
    super(frame);
    axes = frame.getAxes();
    rowCount = axes.getTimeAxis().getExtent();
    colCount = 2;
    colNames = new String[2];
    colNames[0] = axes.getTimeAxis().getName();
    colNames[1] = frame.getVariable().getName() + " (" + 
    	Units.getFormattedName(frame.getVariable().getUnit()) + ")";
  }

  /**
   * Returns the value for the cell at <code>columnIndex</code> and
   * <code>rowIndex</code>.
   * 
   * @return the value Object at the specified cell
   * @param rowIndex
   *          the row whose value is to be queried
   * @param columnIndex
   *          the column whose value is to be queried
   */
  public Object getValueAt(int rowIndex, int columnIndex) {
    if (columnIndex == 0) return axes.getDate(rowIndex);

    DataFrameIndex index = frame.getIndex();
    index.setTime(rowIndex);
    return frame.getDouble(index);
  }
}
