/**
 * 
 */
package anl.aida.viz;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Paint;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

import anl.aida.client.net.CGEdge;
import edu.umd.cs.piccolo.nodes.PPath;

/**
 * Abstract edge styler that handles the creation of the edge.
 * The edge paint is delegated to a subclass.
 * 
 */
public abstract class AbstractEdgeStyler implements EdgeStyler {

  /* (non-Javadoc)
   * @see anl.mifs.viz.EdgeStyler#createNode(anl.mifs.client.net.CGEdge, java.awt.geom.Point2D, java.awt.geom.Point2D)
   */
  @Override
  public PPath createEdge(CGEdge edge, Point2D pt1, Point2D pt2) {
    Paint paint = getPaint(edge);
    
    PPath pEdge = new PPath();
    pEdge.setStrokePaint(paint);
    pEdge.setStroke(new BasicStroke(2));
    NodeUtils.setPaint(pEdge, paint);
    Line2D line = new Line2D.Float();
    line.setLine(pt1, pt2);
    pEdge.setPathTo(line);
    return pEdge;
  }
}
