package anl.aida.viz;


import edu.umd.cs.piccolo.PCanvas;
import edu.umd.cs.piccolo.PLayer;
import edu.umd.cs.piccolo.event.PBasicInputEventHandler;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.nodes.PPath;
import edu.umd.cs.piccolo.util.PBounds;

import java.awt.*;
import java.awt.geom.Point2D;

public abstract class AbstractMarqueeHandler extends PBasicInputEventHandler {

  private PPath rect;
  private Point2D start;
  private PBounds bounds;
  private PLayer layer = new PLayer();

  public void mousePressed(PInputEvent ev) {
    rect = new PPath();
    rect.setStroke(new BasicStroke(0));
    rect.setStrokePaint(Color.BLACK);
    start = ev.getPosition();
    Canvas2D canvas = ((Canvas2D) ev.getComponent());
    layer.addChild(rect);
    canvas.getCamera().addLayer(layer);
    
    bounds = null;
  }

  public void mouseDragged(PInputEvent ev) {
    bounds = new PBounds();
    bounds.add(start);
    bounds.add(ev.getPosition());
    rect.setPathTo(bounds);
    rect.repaint();
  }

  public void mouseReleased(PInputEvent ev) {
    layer.removeChild(rect);
    ev.getCamera().removeLayer(layer);
    execute(ev, bounds);
  }

  protected abstract void execute(PInputEvent ev, PBounds rect);
}
