package anl.aida.viz;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.event.PInputEvent;
import edu.umd.cs.piccolo.util.PNodeFilter;

/**
 *         Date: Feb 12, 2009 2:22:49 PM
 */
public class ClusterCentroidDragHandler extends DragHandler {

  private SimilarityClusterLayout layout;

  public ClusterCentroidDragHandler(SimilarityClusterLayout layout) {
    super(new CentroidFilter());
    this.layout = layout;
  }

  @Override
  protected void endDrag(PInputEvent evt) {
    super.endDrag(evt);
    PNode pNode = evt.getPickedNode();
    if (filter.accept(pNode)) {
      Integer index = (Integer) NodeUtils.getObject(pNode);
      layout.setCentroidLocation(index, evt.getPosition());
    }

  }

  private static class CentroidFilter implements PNodeFilter {

    public boolean accept(PNode pNode) {
      return NodeUtils.getType(pNode).equals(SimilarityClusterDisplay.CENTROID);
    }

    public boolean acceptChildrenOf(PNode pNode) {
      return false;
    }
  }
}
