package anl.aida.viz;

import java.awt.Paint;
import java.awt.geom.Point2D;
import java.util.Collection;

import anl.aida.client.net.CGEdge;
import edu.umd.cs.piccolo.nodes.PPath;

/**
 * Interface for classes that style edges.
 * 
 */
public interface EdgeStyler {
  
  /**
   * Creates a PPath to represent the specified edge.
   *
   * @param edge    the edge to reprsent.
   * @param pt1 the first end point of the edge
   * @param pt2 the second end point of the edge
   * @return a PPath representing the specified edge.
   */
  PPath createEdge(CGEdge edge, Point2D pt1, Point2D pt2);
  
  /**
   * Updates the styler with new edge info. This can
   * be used to recalculate min, max etc. when a graph
   * has changed. 
   * 
   * @param edges
   */
  void update(Collection<CGEdge> edges);

  /**
   * Gets the paint appropriate for the specified edge.
   *
   * @param edge the edge we want the paint for
   * @return the paint appropriate for the specified edge.
   */
  Paint getPaint(CGEdge edge);

}
