/**
 * 
 */
package anl.aida.viz;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

/**
 *
 */
public class ImageUtilities {
  
  public static BufferedImage createTransImage(BufferedImage img, float alpha) {
    BufferedImage dest = new BufferedImage(img.getWidth(), img.getHeight(),
	BufferedImage.TYPE_INT_ARGB);
    Graphics2D g2 = dest.createGraphics();
    g2.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, alpha));
    g2.drawImage(img, null, 0, 0);
    g2.dispose();
    return dest;
  }

  public static BufferedImage createAlphaColorImage(BufferedImage img, Color color) {
    BufferedImage dest = new BufferedImage(img.getWidth(), img.getHeight(),
	BufferedImage.TYPE_INT_ARGB);
    Graphics2D g2 = dest.createGraphics();
    g2.setComposite(AlphaComposite.Src);
    g2.drawImage(img, null, 0, 0);
    g2.dispose();
    int rgb = color.getRGB();
    for (int y = 0, n = dest.getHeight(); y < n; y++) {
      for (int x = 0, k = dest.getWidth(); x < k; x++) {
	if (dest.getRGB(x, y) == rgb) {
	  // changes rgb to alpha color
	  dest.setRGB(x, y, 0x8F1C1C);
	}
      }
    }
    return dest;
  }
}
