package anl.aida.viz;

import anl.aida.client.net.TermNode;
import edu.umd.cs.piccolo.nodes.PPath;

import java.awt.*;
import java.awt.geom.Point2D;


/**
 * Interface for classes that can style a node.
 *
 */
public interface NodeStyler {

  /**
   * Creates a PPath to represent the specified TermNode.
   *
   * @param tNode    the term node to reprsent.
   * @param location the location of the
   * @return a PNode to represent the specified TermNode.
   */
  PPath createNode(TermNode tNode, Point2D location);

  /**
   * Gets the paint appropriate for the specified term node.
   *
   * @param node the term node we want the paint for
   * @return the paint appropriate for the specified term node.
   */
  Paint getPaint(TermNode node);

  /**
   * Gets the size appropriate for the specified term node.
   *
   * @param node the node to get the size for
   * @return the size appropriate for the specified term node.
   */
  float getSize(TermNode node);

}
