package anl.aida.viz;

import java.util.List;

/**
 * Interface for classes that will listen for selection style events
 * on a visualiation.
 *
 */
public interface SelectionListener<T> {

  /**
   * Called when the specified list of items has been selected.
   *
   * @param selectedItems the selected items
   * @param canvas        the visualization canvas
   */
  void selectionOccurred(List<T> selectedItems, Canvas2D canvas);
}
