package anl.aida.viz;

import java.awt.Color;
import java.awt.Font;
import java.awt.GradientPaint;

import edu.umd.cs.piccolo.PCamera;
import edu.umd.cs.piccolo.nodes.PPath;
import edu.umd.cs.piccolo.nodes.PText;
import edu.umd.cs.piccolo.util.PBounds;

/**
 * 
 */
public class ToolTipper {

  private PCamera camera;
  private PText text;
  private PPath path;
  private boolean added = false;
  private Font font;

  public ToolTipper(PCamera camera) {
    this.camera = camera;
    font = new PText().getFont();
    font = font.deriveFont(Font.BOLD, 12f);
  }

  public void showTip(String ttext, float x, float y) {
    //Point2D pt = camera.localToView(new Point2D.Double(x, y));
    //x = (float) pt.getX();
    //y = (float) pt.getY();
    removeTip();
    added = true;
    text = new PText(ttext);
    text.setFont(font);
    text.setConstrainHeightToTextHeight(true);
    text.setConstrainWidthToTextWidth(true);
    text.setTextPaint(Color.WHITE);

    PBounds tBounds = text.getFullBounds();
    float height = (float) tBounds.getHeight() + 20;
    float width = (float) tBounds.getWidth() + 20;

    x = x + width < camera.getViewBounds().getWidth() ? x : x - width;
    y = y - height < 0 ? y : y - height;
    path = PPath.createRoundRectangle(x, y, width, height, 20, 20);
    PBounds pBounds = path.getFullBounds();
    path.setPaint(new GradientPaint((float) pBounds.getMinX(), (float) pBounds.getMinY(), Color.GRAY,
            (float) pBounds.getMaxX(), (float) pBounds.getMaxY(), Color.BLACK));
    path.setTransparency(.8f);
    path.setStroke(null);
    text.offset(pBounds.getOrigin().getX() + 10, pBounds.getOrigin().getY() + 10);

    camera.addChild(path);
    camera.addChild(text);
    //camera.addLayer(layer);
  }

  public void removeTip() {
    if (added) {
      camera.removeChild(text);
      camera.removeChild(path);
      //camera.removeLayer(layer);
      //layer.removeAllChildren();
      //camera.removeChild()
      added = false;
    }
  }
}
