package anl.aida.viz.layout;

import java.awt.*;
import java.awt.geom.Point2D;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 * Abstract base class for 2D layouts.
 *
 */
public abstract class AbstractLayout2D<T> implements Layout2D<T> {

  protected Map<T, Point2D> locations = new HashMap<T, Point2D>();
  protected Dimension size;

  public AbstractLayout2D(Collection<T> objs, Dimension size) {
    this.size = size;
    initNodes(objs);
  }

  protected void initNodes(Collection<T> objs) {
    Point2D.Double tmp = new Point2D.Double(0, 0);
    locations.clear();
    for (T obj : objs) {
      locations.put(obj, tmp);
    }
  }

  public Point2D getLocation(T obj) {
    return locations.get(obj);
  }
}
