/**
 * 
 */
package anl.aida.viz3d;

import java.awt.geom.Rectangle2D;
import java.util.ArrayList;
import java.util.List;

import javax.media.opengl.GL;
import javax.vecmath.Point3f;

import com.sun.opengl.util.j2d.TextRenderer;

/**
 * 
 */
public class Axis {
  
  private float tickInterval;
  private List<String> tickLabels = new ArrayList<String>();
  private float scale = .0011f;
  
  public Axis(float tickInterval) {
    this.tickInterval = tickInterval;
  }
  
  public void addTickLabel(String label) {
    tickLabels.add(label);
  }
  
  public void clearLabels() {
    tickLabels.clear();
  }
  
  public void draw(GL gl, Point3f pt, float zStart, float zEnd) {
    gl.glPushMatrix();
    gl.glTranslated(pt.x, pt.y, 0);
    gl.glBegin(GL.GL_LINES);
    gl.glColor3f(0, 0, 0);

    gl.glVertex3f(0, 0, zStart);
    gl.glVertex3f(0, 0, zEnd);
    gl.glEnd();

    int i = 0;
    for (float z = zStart; z <= zEnd; z += tickInterval) {
      if (i < tickLabels.size()) {
	String label = tickLabels.get(i);
	TextRenderer renderer = VShapeFactory.getInstance().getTextRenderer();
	Rectangle2D bounds = renderer.getBounds(label);
	float yOff = (float)(bounds.getHeight() * scale * .5f);

	renderer.begin3DRendering();
	    //renderer.setColor(color.x, color.y, color.z, color.w);
	renderer.draw3D(label, .015f, -yOff, z, scale);
	renderer.end3DRendering();
	i++;
      }
      gl.glBegin(GL.GL_LINES);
      gl.glVertex3f(0, 0, z);
      gl.glVertex3f(.01f, 0, z);
      gl.glEnd();
    }
    gl.glPopMatrix();
  }
}
