package anl.aida.viz3d;

import javax.media.opengl.GLAutoDrawable;
import javax.vecmath.Point3f;

import anl.aida.client.gui.DocOpsWidget;
import anl.aida.core.DocumentID;

/**
 * CanvasListener that mediates the interaction between a 
 * Canvas3D and a DocOpsWidget.
 * 
 */
public class DocOpsCanvasListener implements CanvasListener {
  
  private DocOpsWidget docOps;
  
  public DocOpsCanvasListener(DocOpsWidget docOps) {
    this.docOps = docOps;
  }

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.CanvasListener#init(javax.media.opengl.GLAutoDrawable, anl.mifs.viz3d.VNode)
   */
  @Override
  public void init(GLAutoDrawable drawable, VNode root) {}

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.CanvasListener#itemSelected(java.lang.Object)
   */
  @Override
  public void itemSelected(Object obj) {
    if (obj instanceof DocumentID) docOps.addDocument((DocumentID)obj);
  }

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.CanvasListener#reshape(javax.media.opengl.GLAutoDrawable, float, float, anl.mifs.viz3d.VNode)
   */
  @Override
  public void reshape(GLAutoDrawable drawable, float width, float height, VNode root) {}

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.CanvasListener#selectionsCleared()
   */
  @Override
  public void selectionsCleared() {
    docOps.clearDocuments();
  }

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.CanvasListener#vSpatialMoved(anl.mifs.viz3d.VSpatial, javax.vecmath.Point3f)
   */
  @Override
  public void vSpatialMoved(VSpatial spatial, Point3f localTrans) {}
}
