package anl.aida.viz3d;

import anl.aida.client.Cache;
import anl.aida.client.net.ConceptGraph;
import anl.aida.client.net.TermNode;
import anl.aida.client.widget.GraphSwapable;
import anl.aida.util.DateRange;

public class GraphRenderer implements GraphSwapable {
  
  private Canvas3D canvas;
  private TSGraphCanvasListener listener;
  
  public GraphRenderer(Cache cache, ConceptGraph<TermNode> graph, DateRange initRange) {
    canvas = new Canvas3D(cache);
    listener = new TSGraphCanvasListener(graph, initRange);
    canvas.addCanvasListener(listener);
    listener.initToolBar(canvas.getToolBar());
  }
 
  public Canvas3D getCanvas() {
    return canvas;
  }

  /* (non-Javadoc)
   * @see anl.mifs.client.widget.GraphSwapable#swapGraph(anl.mifs.client.net.ConceptGraph, anl.mifs.util.DateRange)
   */
  @Override
  public void swapGraph(ConceptGraph<TermNode> graph, DateRange range) {
    // listener needs to add the graph, but if it already has it then
    // tell StackRenderer to jump to that graph
    canvas.clearSelections();
    canvas.resetSelection();
    listener.addGraph(graph, range);
    
  }
}
