/**
 * 
 */
package anl.aida.viz3d;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Date;

import anl.aida.util.DateRange;

/**
 * 
 */
public class NodeUtils {
  
  public static final String TYPE_LABEL = "TYPE";
  public static final String NODE = "NODE";
  public static final String EDGE = "EDGE";
  public static final String OBJ = "OBJ";
  public static final String UNKNOWN = "__UNKNOWN__";
  public static final String EDGE_ENDS = "EDGE_ENDS";
  public static final String NODE_EDGES = "NODE_EDGES";
  public static final String NODE_COLOR = "NODE_COLOR";
  public static final String EDGE_COLOR = "EDGE_COLOR";
  public static final String GRAPH_DATE = "GRAPH_DATE";

  public static boolean isNode(VSpatial node) {
    Object obj = node.getProperty(TYPE_LABEL);
    return obj != null && obj.equals(NODE);
  }

  public static boolean isEdge(VSpatial node) {
    Object obj = node.getProperty(TYPE_LABEL);
    return obj != null && obj.equals(EDGE);
  }
  
  public static void setColor(VSpatial edge, Color color) {
    edge.putProperty(EDGE_COLOR, color);
  }
  
  public static Color getColor(VSpatial edge) {
    return (Color)edge.getProperty(EDGE_COLOR);
  }
  
  public static MaterialAppearence getAppearance(VSpatial node) {
    return (MaterialAppearence)node.getProperty(NODE_COLOR);
  }
  
  public static void setAppearence(VSpatial node, MaterialAppearence app) {
    node.putProperty(NODE_COLOR, app);
  }

  public static void setAsEdge(VSpatial edge, VSpatial one, VSpatial two) {
    edge.putProperty(TYPE_LABEL, EDGE);
    java.util.List<VSpatial> list = new ArrayList<VSpatial>();
    list.add(one);
    list.add(two);
    edge.putProperty(EDGE_ENDS, list);
  }
 
  public static void setAsNode(VSpatial node) {
    node.putProperty(TYPE_LABEL, NODE);
    node.putProperty(NODE_EDGES, new ArrayList<VSpatial>());
  }

  public static void setType(VSpatial node, Object type) {
    node.putProperty(TYPE_LABEL, type);
  }

  public static Object getType(VSpatial node) {
    Object type = node.getProperty(TYPE_LABEL);
    if (type == null) return UNKNOWN;
    return type;
  }

  public static void setObject(VSpatial node, Object obj) {
    node.putProperty(OBJ, obj);
  }
  
  public static void putGraphDate(VSpatial node, DateRange date) {
    node.putProperty(GRAPH_DATE, date);
  }
  
  public static DateRange getGraphDate(VSpatial node) {
    return (DateRange)node.getProperty(GRAPH_DATE);
  }

  public static Object getObject(VSpatial node) {
    return node.getProperty(OBJ);
  }
}
