package anl.aida.viz3d;

import javax.media.opengl.GL;

import com.sun.opengl.util.texture.Texture;

public class Slice {
  
  private float rotation, x, z;
  //private float[] color = {.2f, 0f, 0f, 0f};
  private Texture texture;
  
  public Slice(Texture texture) {
    this.texture = texture;
  }
  
  public void setParamters(float rotation, float x, float z) {
    this.x = x;
    this.rotation = rotation;
    this.z = z;
  }
  
  /**
   * Gets whether or not this slice is currently moving.
   * A slice is moving if its rotation is between 0 and
   * the maxium rotation.
   * 
   * @return whether or not this slice is currently moving.
   */
  public boolean isMoving() {
    return rotation > .001f && rotation < 90;
    
  }
  public synchronized boolean moveLeft() {
    if (rotation < 90) {
      rotation += 5f;
      if (rotation > 20f) z += .05f;
      x += .05f;
    }
    
    return rotation >= 90;
  }
  
  public synchronized boolean moveRight() {
    if (rotation > 0) {
      if (rotation > 20f) z -= .05f;
      rotation -= 5f;
      x -= 0.05f;
    }
    
    return rotation <= 0.001;
  }
  
  public void reset() {
    rotation = x = z = 0;
  }
  
  public String toString() {
    return String.format("Slice: x: %f, z: %f, rotation: %f", x, z, rotation);
  }
  
  public synchronized void draw(GL gl, float zOff, float xOff) {
    gl.glPushMatrix();
    //gl.glColor4fv(color, 0);
    gl.glTranslatef(-x + xOff, 0f, z + zOff);
    if (rotation != 0) gl.glRotatef(rotation, 0f, .5f, 0f);
    texture.bind();
    gl.glBegin(GL.GL_QUADS);
    
    gl.glTexCoord2f(0, 1);
    gl.glVertex2f(-.5f, -.5f);
    
    gl.glTexCoord2f(1, 1);
    gl.glVertex2f(.5f, -.5f);
    
    gl.glTexCoord2f(1, 0);
    gl.glVertex2f(.5f, .5f);
    
    gl.glTexCoord2f(0, 0);
    gl.glVertex2f(-.5f, .5f);
    
    gl.glEnd();
    gl.glPopMatrix();
  }
}
