/**
 * 
 */
package anl.aida.viz3d;

import javax.media.opengl.GL;

import com.sun.opengl.util.j2d.TextRenderer;

/**
 * Interface for classes that can draw as part
 * of a StackDisplay.
 * 
 */
public interface StackDrawable {
  
  /**
   * Initializes this StackDrawable. This may be called multiple times
   * during the life of this StackDrawable in response to OpenGL context 
   * changes.
   */
  void init();
  
  /**
   * Dispose of any resources this StackDrawable may be holding.
   */
  void dispose();
  
  /**
   * Draws the drawable using the current OpenGL interface.
   * 
   * @param gl the interface to OpenGL.
   */
  void draw(GL gl);
  
  /**
   * Gets an index that can be used to sort this drawable.
   * 
   * @return an index that can be used to sort this drawable.
   */
  long getSortIndex();
 
}
