/**
 * 
 */
package anl.aida.viz3d;

/**
 * A VSpatial that is drawn by a Stack. Prior to drawing the StackRenderer will notify
 * this drawable of its place in the stack. 
 * 
 */
public abstract class StackDrawable2 extends VNode {
  
  /**
   * Notifies this StackDrawable of its position in the stack prior to 
   * drawing. If the index is -1, then this StackDrawable is off the stack.
   * Index 0 is the top of the stack.
   * 
   * @param index the index of this StackDrawable in the stack 
   * @param stackSize the current size of the stack
   */
  public abstract void stackPosition(int index, int stackSize);

}
