/**
 * 
 */
package anl.aida.viz3d;

import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

/**
 * Handles Key events for a stack renderer.
 * 
 * <ol>
 * <li>Left Arrow - Moves the current stack item incrementally off the stack
 * <li>Right Arrow - Moves the current stack item incrementally on to the stack
 * <li>Up Arrow - Moves to the next stack item
 * <li>Down Arrow - Moves to the previous stack item
 * </ol>
 * 
 */
public class StackKeyHandler extends KeyAdapter {

  private StackRenderer2 renderer;

  public StackKeyHandler(StackRenderer2 renderer) {
    this.renderer = renderer;
  }

  public void keyPressed(KeyEvent evt) {

    if (evt.getKeyCode() == KeyEvent.VK_LEFT) {
      renderer.moveOff();
      renderer.getDrawable().display();

    } else if (evt.getKeyCode() == KeyEvent.VK_RIGHT) {
      renderer.moveOn();
      renderer.getDrawable().display();

    } else if (evt.getKeyCode() == KeyEvent.VK_UP) {
      renderer.next();
      renderer.getDrawable().display();

    } else if (evt.getKeyCode() == KeyEvent.VK_DOWN) {
      renderer.prev();
      renderer.getDrawable().display();
    }
  }
}
