/**
 * 
 */
package anl.aida.viz3d;

/**
 * A VNode that contains a time series graph.
 * If this is on the top of the stack, the node labels will
 * be displayed otherwise they will not.
 * 
 * 
 */
public class TSGraphVNode extends StackDrawable2 {
  
  private boolean isTop = true;

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.StackDrawable2#stackPosition(int, int)
   */
  @Override
  public void stackPosition(int index, int stackSize) {
    boolean isTop = index == 0;
    if (isTop != this.isTop) {
      this.isTop = isTop;
      labelsVisible(this, isTop);
    }
  }
  
  private void labelsVisible(VNode parent, boolean visible) {
    // recurse into children and find any LabeledShapes and set
    // their label visibility
    for (VSpatial child : parent.children) {
      if (child instanceof LabeledShape) {
	((LabeledShape)child).setLabelVisible(visible);
      } else if (child instanceof VNode) {
	labelsVisible((VNode)child, visible);
      }
    }
  }
}
