package anl.aida.viz3d;

import static javax.media.opengl.GL.GL_COLOR_BUFFER_BIT;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.media.opengl.DebugGL;
import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCanvas;
import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.glu.GLU;
import javax.swing.JFrame;
import javax.vecmath.AxisAngle4f;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;

import com.sun.opengl.util.GLUT;

public class Test3D implements GLEventListener {
  
  private GLU glu = new GLU();
  private MouseRotate rotator;
  private MouseTranslate translator;
  private MouseWheelZoom wheelZoomer;
  private MouseZoom zoomer;
  private Color background;
  private GLCanvas canvas;
  private NodeSelector selector;
  private Point3f viewLocation = new Point3f();
  
  private Box worldSizeAtZero;
  
  private VNode root;
 

  public Test3D(GLCanvas canvas) {
    this.canvas = canvas;
    rotator = new MouseRotate(canvas, 0, 0);
    translator = new MouseTranslate(canvas);
    wheelZoomer = new MouseWheelZoom(canvas);
    zoomer = new MouseZoom(canvas);
    //selector = new NodeSelector(canvas);
  }
  
  private void createScene(GL gl) {
    root = new VNode();
    VShapeFactory.init();
    
    VSpatial one = VShapeFactory.getInstance().createCircle(.03f, 32);
    //one.setColor(Color.GREEN);
    one.translate(-.1f, -.2f, 0);
    root.addChild(one);
    
    
    one = VShapeFactory.getInstance().createCircle(.03f, 32);
    //one.setColor(Color.PINK);
    one.translate(-0.48990658f, -0.40988848f, -2.0861626E-7f);
    root.addChild(one);
    
    VSpatial text = VShapeFactory.getInstance().createLabel("Sample Text");
    //text.setColor(Color.WHITE);
    //root.addChild(text);
    
    LabeledShape labelNode = new LabeledShape(VShapeFactory.getInstance().createCircle(.05f, 32), 
	"Influenza", new float[]{ .001f, .001f, 0});
    //labelNode.setNodeColor(Color.YELLOW);
    labelNode.setLabelColor(Color.WHITE);
    labelNode.translate(.2f, .2f, 0);
    root.addChild(labelNode);
   
    
    VSpatial two = VShapeFactory.getInstance().createCircle(.03f, 32);
    //two.setColor(Color.LIGHT_GRAY);
    two.translate(-.2f, .1f, 0);
    root.addChild(two);
    
    VSpatial cyl = VShapeFactory.getInstance().createDisk(.03f, .1f, 32);
    //cyl.setColor(Color.BLUE);
    cyl.translate(.2f, -.2f, 0);
    root.addChild(cyl);
    
    Point3f source = two.getBoundingSphere().getCenterRef();
    Point3f target = cyl.getBoundingSphere().getCenterRef();
    
    VLine node = new VLine(source, target);
    root.addChild(node);
    
    /*
    VSpatial three = VNodeFactory.getInstance().createCircle(gl, .03f, 32);
    three.setColor(Color.DARK_GRAY);
    three.translate(0f, .3f, 0);
    root.addChild(three);
    */
    
    /*
    Point3f source = two.getBoundingBox().getCenterRef();
    Point3f target = new Point3f(labelNode.getNodeBoundingBox().getCenterRef());
    
    // need to transform from LabeNode's node coordinates to
    // LabelNode coords
    labelNode.transform(target);
    
    LineNode line = new LineNode(source, target);
    line.setColor(Color.BLACK);
    root.addVNode(line);
    root.addVNode(one);
    root.addVNode(two);
    root.addVNode(labelNode);
    
    VSpatial disk = VNodeFactory.getInstance().createDisk(gl, 32, .1f);
    root.addVNode(disk);
    disk.scale(.1f, .1f, .1f);
    disk.translate(-.2f, -.2f, 0);
    */
  }

  public void init(GLAutoDrawable drawable) {
    drawable.setGL(new DebugGL(drawable.getGL()));
    
    System.err.println("Chosen GLCapabilities: " + drawable.getChosenGLCapabilities());
    
    GL gl = drawable.getGL();
    background = Color.decode("#99CCFF").darker();
    // Color c = Color.BLACK;
    gl.glClearColor(background.getRed() / 255f, background.getGreen() / 255f,
	background.getBlue() / 255f, 0f);
    gl.setSwapInterval(0);
    gl.glShadeModel(GL.GL_SMOOTH);
    gl.glEnable(GL.GL_DEPTH_TEST);
    gl.glEnableClientState(GL.GL_VERTEX_ARRAY);
    //gl.glDepthFunc(GL.GL_LEQUAL);
    gl.glHint(GL.GL_PERSPECTIVE_CORRECTION_HINT, GL.GL_NICEST);

    drawable.addMouseListener(rotator);
    drawable.addMouseMotionListener(rotator);
    drawable.addMouseListener(translator);
    drawable.addMouseMotionListener(translator);
    drawable.addMouseListener(zoomer);
    drawable.addMouseMotionListener(zoomer);
    drawable.addMouseWheelListener(wheelZoomer);
    drawable.addMouseListener(selector);
    
    createScene(gl);
    root.updateWorldTransformation();
  }


  @Override
  public void display(GLAutoDrawable drawable) {
    
    GL gl = drawable.getGL();
    gl.glClear(GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
    gl.glEnable(GL.GL_MULTISAMPLE);

    gl.glPushMatrix();
    
    root.localTrans.set(translator.getTranslation());
    root.localTrans.add(wheelZoomer.getTranslation());
    root.localTrans.add(zoomer.getTranslation());
    rotator.process(root);
    root.draw(gl);
    
    /*
    gl.glColor3fv(yellow, 0);
    glu.gluQuadricDrawStyle(quadric, GLU.GLU_FILL);
    glu.gluDisk(quadric, 0, .03f, 32, 1);
    
    gl.glColor3f(0, 0, 0);
    glu.gluQuadricDrawStyle(quadric, GLU.GLU_SILHOUETTE);
    glu.gluDisk(quadric, 0, .031f, 32, 1);
    */

    gl.glPopMatrix();
    
    /*
    BoundingSphere sphere = root.get(4).getBoundingSphere();
    //System.out.println("sphere = " + sphere);
    gl.glPushMatrix();
    gl.glColor3f(0, 0, 0);
    gl.glTranslatef(sphere.getCenterRef().x, sphere.getCenterRef().y, sphere.getCenterRef().z);
    AxisAngle4f angle = new AxisAngle4f();
    angle.set(root.get(3).worldRotation);
    gl.glRotatef((float)Math.toDegrees(angle.angle), angle.x, angle.y, angle.z);
    new GLUT().glutWireSphere(sphere.getRadius(), 32, 12);
    gl.glPopMatrix();
    */
   
    gl.glDisable(GL.GL_MULTISAMPLE);
    selector.process(gl, viewLocation, root);
  }

  @Override
  public void displayChanged(GLAutoDrawable drawable, boolean modeChanged, boolean deviceChanged) {
  }

  @Override
  public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
    GL gl = drawable.getGL();
    float aspect = (float)width / height;

    gl.glMatrixMode(GL.GL_PROJECTION);
    gl.glLoadIdentity();
    glu.gluPerspective(35.0f, aspect, 1.0, 20.0);
    gl.glMatrixMode(GL.GL_MODELVIEW);
    gl.glLoadIdentity();
    glu.gluLookAt(0, 0, 1.3, 0, 0, -1, 0, 1, 0);
    viewLocation.set(0, 0, 1.3f);
    
    worldSizeAtZero = Utils3D.getWorldSizeAtZ(gl, .3f, -18.3f, 0);
  }
  public static void main(String[] args) {
    final JFrame frame = new JFrame();
    frame.setLayout(new BorderLayout());
    // turns on anti-aliasing
    GLCapabilities caps = new GLCapabilities();
    caps.setSampleBuffers(true);
    caps.setNumSamples(4);
    GLCanvas canvas = new GLCanvas(caps);
    frame.add(canvas, BorderLayout.CENTER);
    final Test3D test3D = new Test3D(canvas);
    canvas.addGLEventListener(test3D);
    frame.setSize(900, 775);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setVisible(true);
  }
}
