package anl.aida.viz3d;

import java.awt.Color;
import java.awt.geom.Rectangle2D;

import javax.media.opengl.GL;
import javax.vecmath.Color4f;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;

import com.sun.opengl.util.j2d.TextRenderer;

/**
 * VNode that draws a label.This renders at 0, 0, 0 and so
 * a translation should be used to place it.
 * 
 * 
 */
public class VLabel extends VSpatial {
  
  private String label;
  private Color4f color = new Color4f(Color.white);
  private float scale = .001f;

  /**
   * @param render
   * @param label
   */
  public VLabel(String label) {
    this.label = label;
    TextRenderer renderer = VShapeFactory.getInstance().getTextRenderer();
    Rectangle2D rect = renderer.getBounds(label);
    rect.setRect(0, 0, rect.getWidth() * scale, rect.getHeight() * scale);
    boundingSphere = Utils3D.createBoundingSphere(rect);
  }
  
  public void setColor(Color color) {
    this.color.set(color);
  }
  
  public Color4f getColor() {
    return color;
  }
  

  /* (non-Javadoc)
   * @see anl.mifs.viz3d.AbstractVNode#doDraw(javax.media.opengl.GL)
   */
  @Override
  protected void doDraw(GL gl) {
    TextRenderer renderer = VShapeFactory.getInstance().getTextRenderer();
    renderer.begin3DRendering();
    renderer.setColor(color.x, color.y, color.z, color.w);
    renderer.draw3D(label, 0, 0, 0, scale);
    renderer.end3DRendering();
    
  }


  /**
   * Unimplemented for a label as a label cannot be picked.
   */
  @Override
  public final void intersects(Point3f rayOrigin, Vector3f rayDirection, Accumulator accumulator) {}
  
  
}
