package anl.aida.client.doc;

import anl.aida.client.CacheElement;
import anl.aida.client.doc.ClientDocument;
import anl.aida.client.doc.DefaultDocumentsModel;
import anl.aida.client.doc.DocSets;
import anl.aida.client.doc.DocumentsModel;
import anl.aida.core.MIFSDocument;
import anl.aida.core.STCHeader;
import anl.aida.core.STCReader;
import anl.aida.core.ScoredTermsCollection;
import anl.aida.util.AIDAException;
import static org.junit.Assert.assertEquals;
import org.junit.Test;

import java.io.File;
import java.io.IOException;

/**
 * 
 *         Date: Feb 6, 2009 3:12:12 PM
 */
public class DocTests {

  @Test
  public void testDocModel() throws AIDAException, IOException {
    STCReader reader = new STCReader();
    STCHeader header = reader.readHeader("./cache/stc_02082009.bin");
    ScoredTermsCollection stc = reader.readCollection("./cache/stc_02082009.bin");

    CacheElement element = new CacheElement(0, new File("./cache/stc_02082009.bin"), header);

    // dummy keyword generator
    DocumentsModel model = new DefaultDocumentsModel(DocumentsModel.NO_ID, element);
    int i = 0;
    DocSets sets = model.createDocumentSets(100);
    for (int j = 0; j < sets.getSetCount(); j++) {
      for (ClientDocument doc : sets.getDocuments(j)) {
        MIFSDocument mdoc = stc.getDocument(i++);
        assertEquals(mdoc.getTitle(), doc.getTitle());
        assertEquals(mdoc.getPath(), doc.getPath());
      }
    }
  }
}
