package anl.aida.plot;

import java.awt.BorderLayout;
import java.io.IOException;

import javax.swing.JFrame;

import anl.aida.client.net.ValueGraphCreator;
import anl.aida.client.net.ValueNode;
import anl.aida.data.DataFrame;
import anl.aida.data.mock.WIDataFeed;
import anl.aida.plot.GraphPlotRenderer;
import edu.uci.ics.jung.graph.Graph;

public class Plot3DTest {
  
  public void run() throws IOException {
    WIDataFeed feed = new WIDataFeed();
    DataFrame data = feed.getDataFrame(feed.getVariables().get(0));
    Graph<ValueNode, Object> graph = new ValueGraphCreator().createGraph(data, 0);
    
    GraphPlotRenderer renderer = new GraphPlotRenderer(data, graph);
    JFrame frame = new JFrame();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setLayout(new BorderLayout());
    frame.add(renderer.getPanel(), BorderLayout.CENTER);
    frame.setSize(600, 600);
    frame.setVisible(true);
  }
  
  public static void main(String[] args) throws IOException {
    Plot3DTest test = new Plot3DTest();
    test.run();
  }

}
