package anl.aida.plot;

import java.awt.BorderLayout;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;

import anl.aida.data.DataFrame;
import anl.aida.data.mock.WIDataFeed;
import anl.aida.plot.TimeSeriesPlotWidget;

public class TimeSeriesTest {
  
  public void run() throws IOException {
    JFrame frame = new JFrame();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setLayout(new BorderLayout());
    
    WIDataFeed feed = new WIDataFeed();
    DataFrame data = feed.getDataFrame(feed.getVariables().get(0));
    List<DataFrame> frames = new ArrayList<DataFrame>();
    frames.add(data);
    DFTimeSeriesParams params = new DFTimeSeriesParams(frames, new int[]{29, 34});
    TimeSeriesPlotWidget plot = new TimeSeriesPlotWidget(params);
    //TimeSeriesPlot plot = new TimeSeriesPlot(data, new int[]{29, 34});
    frame.add(plot.getPanel(), BorderLayout.CENTER);
    frame.setSize(600, 600);
    frame.setVisible(true);
  }
  
  
  public static void main(String[] args) throws IOException {
    TimeSeriesTest test = new TimeSeriesTest();
    test.run();
  }

}
