/**
 * 
 */
package anl.aida.plot.io;

import java.util.ArrayList;
import java.util.List;

import anl.aida.plot.PlotType;

/**
 * Encapsulates Chart data read from a project file.
 * 
 */
public class PlotData {
  
  private PlotType type;
  private String title;
  private List<String> formulas = new ArrayList<String>();
  
  public PlotData(PlotType type, String title) {
    this.type = type;
    this.title = title;
  }
  
  public String getTitle() {
    return title;
  }
  
  public void addFormula(String formula) {
    formulas.add(formula);
  }
  
  public int getFormulaCount() {
    return formulas.size();
  }
  
  public Iterable<String> formulas() {
    return formulas;
  }
  
  public PlotType getType() {
    return type;
  }
  
  

}
