package anl.aida.plot.io;

import static org.junit.Assert.*;

import java.io.File;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import javax.xml.stream.XMLStreamException;

import org.junit.Test;

import anl.aida.plot.io.ProjectReader;

public class ProjectReaderTests {
  
  private String[] expectedFormulas = {"H1N1[1]", "Fever_Flu[2] / All[2]", "AH3[3]", "A_H1[3]", "A_Not_Subtyped[3]",
     "B[3]", "Novel_H1[3]", "Fever_Flu[2]", "All[2]", "Fever_Flu[2]"};
  
  @Test
  public void testRead() throws IOException, XMLStreamException {
    ProjectReader reader = new ProjectReader();
    Project project = reader.read(new File("./projects/project.xml"));
    Set<String> expected = new HashSet<String>();
    for (String formula : expectedFormulas) {
      expected.add(formula);
    }
    
    for (String formula : project.formulas()) {
      assertTrue(expected.remove(formula));
    }
    assertEquals(0, expected.size());
  }
}
