package anl.aida.query;

import java.io.File;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

import javax.xml.stream.XMLStreamException;

import org.junit.Test;

import anl.aida.client.Cache;
import anl.aida.client.CacheElement;
import anl.aida.client.io.CacheFileReader;
import anl.aida.core.MIFSDocument;
import anl.aida.core.ScoredTermsCollection;
import anl.aida.util.IntIterator;

public class QueryTests {
  
  DateFormat format = new SimpleDateFormat("MM/dd/yyyy");
  
  @Test
  public void testQueryRunner() throws anl.aida.query.ParseException, IOException, XMLStreamException {
    CacheFileReader reader = new CacheFileReader();
    Cache cache = reader.read(new File("./cache/cache.xml"));
    
    CacheElement element = cache.getElement(1);
    System.out.println("element.getHeader().getDateRange() = " + element.getHeader().getDateRange());
    
    ScoredTermsCollection stc = element.getSTC();
    int termIndex = stc.getTermIndex("cholera");
    System.out.println("\nDocs from getFrequency\n");
    for (MIFSDocument doc : stc.documents()) {
      if (stc.getFrequency(doc.getSTCIndex(), termIndex) > 0) {
	System.out.print(doc.getSTCIndex() + ", ");
      }
    }
    
    System.out.println("\nDocs from getDocsFor\n");
    IntIterator iter = stc.getDocumentsFor(termIndex);
    while (iter.hasNext()) {
      System.out.print(iter.next() + ", ");
    }
    
    
    
    /*
    QueryRunner runner = new QueryRunner();
    runner.run("count(salmonella) > 14 or count(hepatitis) == 4", cache);
    */
    
    
    /*
    Query rhs = new FrequencyCountQuery("salmonella");
    Query lhs = new ConstantQuery(16);
    TriggerOp op = new TriggerOp(new GreaterThan(), rhs, lhs);
    TriggerRunner runner = new TriggerRunner(cache);
    
    TriggerResult result = runner.run(op);
    assertTrue(result.isTriggered());
    
    int[] dayExpected = {1, 2};
    int[] monthExpected = {1, 1};
    
    Calendar cal = GregorianCalendar.getInstance();
    int i = 0;
    for (DateRange range : result.ranges()) {
      cal.setTime(range.getStart());
      int month = cal.get(Calendar.MONDAY);
      assertEquals(monthExpected[i], month);
      int day = cal.get(Calendar.DAY_OF_MONTH);
      assertEquals(dayExpected[i], day);
      i++;
    }
    */

  }

}
