/**
 * 
 */
package anl.aida.ae.gate;

import gate.FeatureMap;

/**
 * Interface for classes that can determine whether or not 
 * a particular annotation will be created based on values in
 * a GATE feature map. 
 * 
 */
public interface AnnotationBuilderFilter {
  
  /**
   * Determines whether or not a particular annotation should be created
   * based on feature values in a gate feature map.
   * 
   * @param map the GATE feature map
   * 
   * @return true if the annotation should built otherwise false.
   */
  boolean buildAnnotation(FeatureMap map);

}
