package anl.aida.ae.gate;

/**
 * Enumeration of the java type of a Feature value.
 * 
 */
public enum FeatureType {

  STRING, FLOAT, DOUBLE, LONG, INT, BOOLEAN, FSARRAY;

  /**
   * Returns a FeatureType identified by the specified string. The
   * strings are: string, float, double, long, int, fsarray.
   *
   * @param val the string representation of the FeatureType
   * @return the FeatureType identified by the specified string, otherwise null.
   */
  public static FeatureType parse(String val) {
    val = val.toLowerCase();
    if (val.equals("string")) return STRING;
    if (val.equals("float")) return FLOAT;
    if (val.equals("double")) return DOUBLE;
    if (val.equals("long")) return LONG;
    if (val.equals("int")) return INT;
    if (val.equals("boolean")) return BOOLEAN;
    if (val.equals("fsarray")) return FSARRAY;

    return null;
  }
}
