package anl.aida.ae.gate;

import org.apache.uima.cas.FeatureStructure;
import org.apache.uima.cas.Feature;
import gate.FeatureMap;

/**
 * Builds GATE / UIMA features from a GATE / UIMA source.
 *
 */
public class InputFeatureBuilder extends AbstractFeatureBuilder {

  public InputFeatureBuilder(String gateName, Feature feature, FeatureType fType) {
    super(gateName, fType, feature);
  }

  /**
   * Transfers UIMA features to a FeatureMap or vis-a-versa.
   *
   * @param parent the UIMA featureStructure containing the feature
   * @param map the feature map to put the feature in
   */
  public void build(FeatureStructure parent, FeatureMap map) {
    switch (fType) {
      case STRING:
        map.put(gateName, parent.getStringValue(feature));
        break;
      case FLOAT:
        map.put(gateName, parent.getFloatValue(feature));
        break;
      case DOUBLE:
        map.put(gateName, parent.getDoubleValue(feature));
        break;
      case LONG:
        map.put(gateName, parent.getLongValue(feature));
        break;
      case INT:
        map.put(gateName, parent.getIntValue(feature));
        break;
      case BOOLEAN:
        map.put(gateName, parent.getBooleanValue(feature));
        break;
      default:
        // todo throw some exp
    }
  }
}
