package anl.aida.ae.gate;

import gate.AnnotationSet;
import gate.Document;
import org.apache.uima.cas.CAS;
import org.apache.uima.cas.Type;
import org.apache.uima.cas.text.AnnotationFS;

/**
 * Updates existing UIMA annotations from existing GATE ones.
 *
 */
public class OutputUpdateAnnBuilder extends AbstractUGAnnotationBuilder {

  public OutputUpdateAnnBuilder(String gateType, Type type) {
    super(type, gateType);
  }

  /**
   * Creates new annotations of the type specified in the constructor
   * from those in the GATE doc.
   *
   * @param cas
   * @param doc
   */
  public void run(CAS cas, Document doc) {
    AnnotationSet set = doc.getAnnotations().get(gateType);
    for (gate.Annotation ann : set) {
      AnnotationFS antFS = cas.createAnnotation(type, ann.getStartNode().getOffset().intValue(),
              ann.getEndNode().getOffset().intValue());
      // todo create the features.
      cas.addFsToIndexes(antFS);
    }
  }
}