package anl.aida.ae.lucene;

import org.apache.lucene.document.Document;

import java.io.IOException;
import java.io.Reader;

/**
 * Interface for classes that can produce a Reader
 * to be used to retrieve content to be indexed by Lucene.
 *
 */
public interface ReaderProducer {

  /**
   * Gets a reader to read content based on information
   * in the doc. For example, the content may be some
   * fields in the document.
   *
   * @param doc the doc
   * @return a reader to read content based on information
   *         in the doc.
   * @throws IOException if there is a problem getting the reader
   */
  Reader getReader(Document doc) throws IOException;
}
