package anl.aida.ae.lucene;

import java.util.HashSet;
import java.util.Set;

import org.apache.lucene.index.Term;

import anl.aida.util.Filter;

/**
 * 
 * Terms filter that filters out a predefined list of stop words.
 * 
 */
public class StopWordFilter implements Filter<Term> {
  
  private Set<String> stopSet = new HashSet<String>();
  private String[] stopWords = {"from", "s", "said", "has",  "he", "have", "who", "had",
      "his", "after", "been", "were", "about", "more", "when", "http", "also", "out", 
      "t", "which", "up", "would", "than", "other", "we", "people", "all", "its", 
      "over", "i", "some", "because", "can", "could", "before", "what", "so", 
      "them", "just", "say", "how", "nyt", "timestopics", "topics.nytimes.com"};

  public StopWordFilter() {
    for (String word : stopWords) {
      stopSet.add(word);
    }
  }
  
  /**
   * Evaluates the term against the set of stop words.
   */
  public boolean evaluate(Term item) {
    String text = item.text();
    return !stopSet.contains(text);
  }
}
