package anl.aida.ae.lucene;

import anl.aida.util.Filter;

import org.apache.lucene.index.Term;

/**
 * Filters out terms that have any numeric component
 * as well as any  terms whose length is less than a
 * minimum length.
 *
 */

public class WordFilter implements Filter<Term> {

  private int minWordSize = 1;

  public WordFilter(int minWordSize) {
    this.minWordSize = minWordSize;
  }

  public boolean evaluate(Term item) {
    String text = item.text();

    if (text.length() < minWordSize) return false;

    for (char c : text.toCharArray()) {
      if (Character.isDigit(c)) return false;
    }

    return true;
  }
}
