package anl.aida.core;

import anl.aida.util.DateRange;

/**
 * Encapsulates the header info of an STC file.
 *
 */
public class STCHeader {

  private int docCount, termCount;
  private DateRange range;

  public STCHeader(int docCount, int termCount, DateRange range) {
    this.docCount = docCount;
    this.termCount = termCount;
    this.range = range;
  }

  public DateRange getDateRange() {
    return range;
  }

  public int getDocCount() {
    return docCount;
  }

  public int getTermCount() {
    return termCount;
  }

  public long getTimestamp() {
    return 0;
  }
}
