package anl.aida.data;

public class DataFrameStringAxis extends DataFrameAxis implements StringCoordAxis {

  /**
   * Creates a DataFrameAxis for the specified axis with origin and extent equal
   * to that of the axis.
   * 
   * @param axis
   *          the axis
   * @param index
   *          the array index of this axis
   */
  public DataFrameStringAxis(StringCoordAxis axis, int index) {
    super(axis, index);
  }

  /**
   * Creates a DataFrameAxis for the specified axis with the specified origin
   * and extent.
   * 
   * @param origin
   *          the origin of the range
   * @param extent
   *          the extent of the range
   * @param axis
   *          the axis
   * @param index
   *          the array index of this axis
   */
  public DataFrameStringAxis(StringCoordAxis axis, int origin, int extent, int index) {
    super(axis, origin, extent, index);
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.aida.data.StringCoordAxis#getIndex(java.lang.String)
   */
  @Override
  public int getIndex(String value) {
    return ((StringCoordAxis) axis).getIndex(value);
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.aida.data.StringCoordAxis#getString(int)
   */
  @Override
  public String getString(int index) {
    return ((StringCoordAxis) axis).getString(index);
  }

}
