/**
 * 
 */
package anl.aida.data;

/*
 * 
 */
public class DefaultStringCoordAxis extends AbstractCoordAxis implements StringCoordAxis {

  private String[] vals;
  
  public DefaultStringCoordAxis(String[] vals, AxisData data) {
    super(data);
    this.vals = vals;
  }

  /* (non-Javadoc)
   * @see anl.mifs.data.StringCoordAxis#getString(int)
   */
  @Override
  public String getString(int index) {
    return vals[index];
  }

  /* (non-Javadoc)
   * @see anl.mifs.data.CoordAxis#getValue(int)
   */
  @Override
  public double getValue(int index) {
    return 0;
  }
  
  /**
   * Gets the value as String at the specified index.
   * 
   * @param index the index of the value to get
   * @return the value as String at the specified index.
   */
  public String getValueAsString(int index) {
    return getString(index);
  }

  /* (non-Javadoc)
   * @see anl.mifs.data.StringCoordAxis#getIndex(java.lang.String)
   */
  @Override
  public int getIndex(String value) {
    for (int i = 0; i < vals.length; i++) {
      if (value.equals(vals[i])) return i;
    }
    
    return INDEX_NOT_FOUND;
  }
  
  /**
   * Gets whether or not the this axis is compatible with the specified axis.
   * Two axes are compatible if they can be used together in the same formula.
   * 
   * @param axis
   *          the axis to check for compatibility
   * @return true if this axis is compatibilty with the other axis, otherise
   *         false.
   */
  public boolean isCompatible(CoordAxis axis) {
    // identity test
    if (axis == this) return true;
    long extent = axis.getRange().getExtent();
    if (axis.getAxisType().equals(this.getAxisType()) && extent == this.getRange().getExtent()) {
      for (int i = 0; i < extent; i++) {
	if (!getValueAsString(i).equals(axis.getValueAsString(i)))
	  return false;
      }
      return true;
    }
    return false;
  }
}
