/**
 * 
 */
package anl.aida.data;

/**
 * Axis that maps indices to Strings. 
 * 
 */
public interface StringCoordAxis extends CoordAxis {
  
  int INDEX_NOT_FOUND = -1;
  
  /**
   * Gets the String value at the specified index.
   * 
   * @param index the index of the String value
   * 
   * @return the String value at the specified index.
   */
  String getString(int index);
  
  /**
   * Gets the index of the specified value.
   * 
   * @param value the value whose index we want
   * 
   * @return the index of the specified value or INDEX_NOT_FOUND if
   * the value is not found
   */
  int getIndex(String value);

}
