package anl.aida.data;

import java.util.Date;

/**
 * Interface for the time coordinate axis.
 * 
 * @version $Revision$ $Date$
 */
public interface TimeCoordAxis extends CoordAxis {
  /**
   * Returns the Date for the specified timestep, or null if the timestep is
   * invalid.
   * 
   * @param timestep
   *          the time step we want the date for.
   * @return the Date for the specified timestep
   */
  Date getDate(int timestep);

  /**
   * Gets the timestep that corresponds to the specified date. If no such
   * timestep is found then return Axes.TIME_STEP_NOT_FOUND.
   * 
   * @param date
   *          the date whose time step we want
   * @return the timestep that corresponds to the specified date. If no such
   *         timestep is found then return Axes.TIME_STEP_NOT_FOUND.
   */
  int getTimeStep(Date date);
}
