package anl.aida.data;

import java.util.Calendar;

/**
 * Time interval unit enumeration.
 * 
 */
public enum TimeIntervalUnit {
  
  YEAR() {
    public int getCalendarEquivalent() {
      return Calendar.YEAR;
    }
    
  },
  
  DAY_OF_MONTH() {
    public int getCalendarEquivalent() {
      return Calendar.DAY_OF_MONTH;
    }
  },
  
  DAY_OF_YEAR() {
    public int getCalendarEquivalent() {
      return Calendar.DAY_OF_YEAR;
    }
  },
  
  HOUR() {
    public int getCalendarEquivalent() {
      return Calendar.HOUR;
    }
  },
  
  SECOND() {
    public int getCalendarEquivalent() {
      return Calendar.SECOND;
    }
  },
  
  MINUTE() {
    public int getCalendarEquivalent() {
      return Calendar.MINUTE;
    }
  },
  
  MONTH() {
    public int getCalendarEquivalent() {
      return Calendar.MONTH;
    }
  },
  
  WEEK() {
    public int getCalendarEquivalent() {
      return Calendar.WEEK_OF_YEAR;
    }
  },
  
  MILLISECOND() {
    public int getCalendarEquivalent() {
      return Calendar.MILLISECOND;
    }
  };
  
  
  public abstract int getCalendarEquivalent();

}
