package anl.aida.reader;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.Calendar;
import java.util.GregorianCalendar;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;

public class IndependentIndexMaker extends GuardianIndexMaker{

	static String START_DATE="1992-5-1";
	static String END_DATE="1992-12-31";

	public IndependentIndexMaker(){
	}
	
	  private static class ArchiveMaker implements DocumentProcessor {

		    // timestamp:::link:::title:::author
          
		    private PrintWriter writer;
		    private String month = "";
		    public long timeStamp;
		    public ArchiveMaker(String file) throws IOException {
		      writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
		    }

		    public void processLine(String line) {
		     
		        if(line.contains("/science/")|| line.contains("/world/")|| line.contains("/uk/")) {
		        
		        	if (line.startsWith("<http://www.independent.co.uk/news/") && line.contains(".html>")) {
		        		int index = line.indexOf(">");
		        		String link = line.substring(1, index);
		        		index = line.indexOf(Integer.toString(timeOfYear)+"/");
		        		int start = index + 5;
		        		int end = start + 3;
		        		String linkMonth = line.substring(start, end);
		        		start = end + 1;
		        		end = start + 2;
	//	        		String day = line.substring(start, end);
		        		System.out.println(line);
		        		String title = "";
		        		start = line.indexOf(">") + 1;
		        		end = line.indexOf(" By<");
		        		if (end != -1) {
		        			title = line.substring(start, end);
		        		} else {
		        			end = line.length();
		        			title = line.substring(start, end);
		        		}
		        	
		        		if (!month.equals(linkMonth)) {
		        			//writer.println(String.format("%s 2009", linkMonth));
		        			month = linkMonth;
		        		}
		        		writer.println(String.format("%d:::%s:::%s:::", timeStamp, link, title));
				      }
		        }
		}


		    @Override
		    public boolean done() {
		      return false;
		    }

		    public void close() throws IOException {
		      writer.close();
		    }

		    /*
		     * (non-Javadoc)
		     * 
		     * @see anl.aida.reader.DocumentProcessor#reset()
		     */
		    @Override
		    public void reset() {
		      // TODO Auto-generated method stub

		    }
		  }

	  public void parseTime() throws ParseException{
			start = format.parse(START_DATE);
		    end = format.parse(END_DATE);
		    long days=end.getTime()-start.getTime();
		    totalTicks=(days/86400000)+1;
		}
		
	public static void main(String[] args) throws IOException, ParseException {
		IndependentIndexMaker iim = new IndependentIndexMaker();
		StringExtractor extractor = new StringExtractor();
		ArchiveMaker maker = new ArchiveMaker("./independent_archive_index.txt");
		String[] months = { "January","February","March", "April", "May","June",
				"July","August","September","October","November","December" };
		iim.parseTime();

		Calendar cal = GregorianCalendar.getInstance();
		int current=0;
		cal.setTime(iim.start);
		   while(current<iim.totalTicks) {
		    
		    timeOfYear=cal.get(Calendar.YEAR);
		    	  
		      maker.timeStamp = cal.getTime().getTime();
		      
		     
		      String url = "http://www.independent.co.uk/dayinapage/"+Integer.toString(cal.get(Calendar.YEAR))
		      	+"/"+months[cal.get(Calendar.MONTH)]+"/"+
		    	 cal.get(Calendar.DAY_OF_MONTH)+"/";
		      
		      timeOfMonth=months[cal.get(Calendar.MONTH)];
		      timeOfDay=Integer.toString(cal.get(Calendar.DAY_OF_MONTH));
		      System.out.println("Processing URL: " + url);
		      extractor.run(url, maker);
		      cal.add(Calendar.DAY_OF_MONTH, 1);
		      current++;
		   }
		  maker.close();
		} 
}
