package anl.aida.reader;


import anl.aida.reader.ContentComponentReader;

/**
 * AIDAComponentReader implementation for reading CNNExpansion web entries.
 * The list of links should be in a file in the "standard" index
 * format. Namely,
 * 
 * timestamp:::link:::title:::author
 * 
 * The author or authors is optional.
 * 
 */
public class IndependentReader extends ContentComponentReader {
  
  public static final String INDEX_FILE = "anl.msc.reader.IndependentIndex";
  private static final String CACHE_DIR_KEY = "anl.msc.reader.IndependentCacheContentDir";
  private static final String CACHE_INDEX_KEY = "anl.msc.reader.IndependentCacheContentIndex";
  
  /* (non-Javadoc)
   * @see anl.aida.reader.ContentComponentReader#getCacheDirectoryKey()
   */
  @Override
  protected String getCacheDirectoryKey() {
    return CACHE_DIR_KEY;
  }

  /* (non-Javadoc)
   * @see anl.aida.reader.ContentComponentReader#getCacheIndexKey()
   */
  @Override
  protected String getCacheIndexKey() {
    return CACHE_INDEX_KEY;
  }


  public IndependentReader() {
    reader = new IndependentHTMLReader();
  }

  
  /* (non-Javadoc)
   * @see anl.aida.reader.AbstractAIDAComponentReader#getIndexFile()
   */
  @Override
  protected String getIndexFileKey() {
    return INDEX_FILE;
  }


  /* (non-Javadoc)
   * @see anl.aida.reader.ContentComponentReader#getContentSource()
   */
  @Override
  protected String getContentSource() {
    return ReaderConstants.INDEPENDENT_SOURCE;
  }
}
