package anl.aida.reader;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.Calendar;
import java.util.GregorianCalendar;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;


public class LATimesIndexMaker extends GuardianIndexMaker{
	static String START_DATE="2008-12-21";
	static String END_DATE="2009-1-31";
	static int timeOfYear;
	static String timeOfDay;
	static String timeOfMonth;
	static String category;
	
	  private static class ArchiveMaker implements DocumentProcessor {

		    // timestamp:::link:::title:::author

		    private PrintWriter writer;
		    private String month = "";
		    public long timeStamp;
		    

		    public ArchiveMaker(String file) throws IOException {
		      writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
		    }

		    public void processLine(String line) {
		      // System.out.println("line = " + line);
		    	
		   if(line.contains("/local/")||line.contains("/world/")||line.contains("science")||line.contains("/nation/")|| line.contains("/science/") ||
				   line.contains("/news/")){
		    if (line.startsWith("<http://articles.latimes.com/"+timeOfYear+"/"+timeOfMonth+"/"+timeOfDay+"/")) {
		    	int index = line.indexOf(">");
		    	String link = line.substring(1, index);
		    	index = line.indexOf(Integer.toString(timeOfYear)+"/");
		    	int start = index + 5;
		    	int end = start + 3;
		    	String linkMonth = line.substring(start, end);
		    	start = end + 1;
		    	end = start + 2;
			
		    	String title = "";
		    	start = line.indexOf(">") + 1;
		    	end = line.indexOf(" By<");
		    	if (end != -1) {
		    		title = line.substring(start, end);
		    	} else {
		    		end = line.length();
		    		title = line.substring(start, end);
		    	}

		    	if (!month.equals(linkMonth)) {
		    		//writer.println(String.format("%s 2009", linkMonth));
		    		month = linkMonth;
		    	}
		    	writer.println(String.format("%d:::%s:::%s:::", timeStamp, link, title));
		    	// System.out.printf("item:%n\t%s%n\t%s%n\t%s%n\t%s%n", link, title,
		    	// linkMonth, day);

		      	}
		   	  }
		   }

		    @Override
		    public boolean done() {
		      return false;
		    }

		    public void close() throws IOException {
		      writer.close();
		    }

		    /*
		     * (non-Javadoc)
		     * 
		     * @see anl.aida.reader.DocumentProcessor#reset()
		     */
		    @Override
		    public void reset() {
		      // TODO Auto-generated method stub

		    }
		  }
		  
	  public void parseTime() throws ParseException{
			start = format.parse(START_DATE);
			end = format.parse(END_DATE);
		    long days=end.getTime()-start.getTime();
		    totalTicks=(days/86400000)+1;
		}	  

	public static void main(String[] args) throws IOException, ParseException  {
		LATimesIndexMaker lam = new LATimesIndexMaker();
		StringExtractor extractor = new StringExtractor();
		ArchiveMaker maker = new ArchiveMaker("./latimes_archive_index.txt");
		String[] months = { "jan","feb","mar", "apr", "may","jun",
				"jul","aug","sep","oct","nov","dec" };
		
		String[] days={"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16",
	    		"17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"};
		
		lam.parseTime();

		Calendar cal = GregorianCalendar.getInstance();
		int current=0;
		cal.setTime(lam.start);
		   while(current<lam.totalTicks) {
		    
		    timeOfYear=cal.get(Calendar.YEAR);
		    	  
		      maker.timeStamp = cal.getTime().getTime();
		      
		     
		      String url = "http://articles.latimes.com/"+Integer.toString(cal.get(Calendar.YEAR))
		      	+"/"+months[cal.get(Calendar.MONTH)]+"/"+days[cal.get(Calendar.DAY_OF_MONTH)-1];
		      
		      timeOfMonth=months[cal.get(Calendar.MONTH)];
		      timeOfDay=days[cal.get(Calendar.DAY_OF_MONTH)-1];
		      System.out.println("Processing URL: " + url);
		      extractor.run(url, maker);
		      cal.add(Calendar.DAY_OF_MONTH, 1);
		      current++;
		   }
		  maker.close();
		} 

}
