package anl.aida.reader;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import anl.aida.util.AIDAException;

/**
 * Quick and dirty file to read ntarc_archive_index.txt
 * and read / parse each article in the index using the
 * NTARCHtmlReader.
 * 
 * @deprecated Index file has changed so will not work
 */
public class NTARCArchiveReader {
  
  private DateFormat format = new SimpleDateFormat("MMMMM yyyy");
  private Calendar cal = GregorianCalendar.getInstance();
  
  public void run(ReaderResultProcessor proc) throws IOException, ParseException, AIDAException {
    NTARCHtmlReader tarcReader = new NTARCHtmlReader();
    
    BufferedReader reader = new BufferedReader(new FileReader("./ntarc_archive_index.txt"));
    String line;
    cal.set(2009, 0, 1, 6, 0, 0);
    
    while ((line = reader.readLine()) != null) {
      line = line.trim();
      if (Character.isDigit(line.charAt(0))) {
	cal.set(Calendar.DAY_OF_MONTH, Integer.parseInt(line.substring(0, 2)));
	
	int index = line.indexOf(">");
	String url = line.substring(4, index);
	String title = line.substring(index + 1);
	
	System.out.printf("item:%n\t%s%n\t%s%n\t%s%n", url.trim(), title.trim(), cal.getTime().toString());
	
	ReaderResult result = tarcReader.read(url, title, cal.getTime(), "");
	proc.process(result);
	
      } else {
	// its a month and year
	Date date = format.parse(line);
	cal.setTime(date);
	cal.set(Calendar.HOUR_OF_DAY, 9);
      }
    }
  }
}
