package anl.aida.reader;

/**
 * An article entry as represent by the JSON returned from the 
 * NYT article search API.This class is automatically instantiated
 * and filled using Gson -- the JSON to java converter.
 * 
 */
public class NYTEntry {
  
  private String byline, date, title, url;

  /**
   * @return the byline
   */
  public String getByline() {
    return byline;
  }

  /**
   * @return the date
   */
  public String getDate() {
    return date;
  }

  /**
   * @return the title
   */
  public String getTitle() {
    return title;
  }

  /**
   * @return the url
   */
  public String getUrl() {
    return url;
  }
  
  public String toString() {
    return String.format("Entry:%n\t%s%n\t%s%n\t%s%n\t%s%n", title, url, byline, date);
  }
}
