package anl.aida.reader;

/**
 * An search result as represented by the JSON returned from the 
 * NYT article search API.This class is automatically instantiated
 * and filled using Gson -- the JSON to java converter. It will contain
 * the current offset, the list of article entries for that offset and
 * the total number of articles over all the offsets.
 * 
 * @author Nick Collier
 */
public class NYTSearchResult {
  
  private String offset;
  private NYTEntry[] results;
  private int total;
  
  /**
   * @return the offset
   */
  public String getOffset() {
    return offset;
  }
  /**
   * @return the results
   */
  public NYTEntry[] getResults() {
    return results;
  }
  /**
   * @return the total
   */
  public int getTotal() {
    return total;
  }
  
  

}
