/**
 * 
 */
package anl.aida.reader;


/**
 * AIDAComponentReader implementation for reading NYTimes web entries. The list
 * of links should be in a file in the "standard" index format. Namely,
 * 
 * timestamp:::link:::title:::author
 * 
 * The author or authors is optional.
 * 
 */
public class NYTimesReader extends ContentComponentReader {

  public static final String INDEX_FILE = "anl.aida.reader.NYTIndex";
  private static final String CCONTENT_DIR_KEY = "anl.aida.reader.NYTCacheContentDir";
  private static final String CCONTENT_INDEX_KEY = "anl.aida.reader.NYTCacheContentIndex";

  public NYTimesReader() {
    reader = new NYTimesHTMLReader();
  }

  /*
   * (non-Javadoc)
   * 
   * @see anl.aida.reader.AbstractAIDAComponentReader#getIndexFile()
   */
  @Override
  protected String getIndexFileKey() {
    return INDEX_FILE;
  }


  /* (non-Javadoc)
   * @see anl.aida.reader.ContentComponentReader#getContentSource()
   */
  @Override
  protected String getContentSource() {
    return ReaderConstants.NYTIMES_SOURCE;
  }

  /* (non-Javadoc)
   * @see anl.aida.reader.ContentComponentReader#getCacheDirectoryKey()
   */
  @Override
  protected String getCacheDirectoryKey() {
    return CCONTENT_DIR_KEY;
  }

  /* (non-Javadoc)
   * @see anl.aida.reader.ContentComponentReader#getCacheIndexKey()
   */
  @Override
  protected String getCacheIndexKey() {
    return CCONTENT_INDEX_KEY;
  }

  /*
  @Override
  public void initialize(ConfigurableResource resource, Date cacheStartDate)
      throws ResourceInitializationException {
    super.initialize(resource, cacheStartDate);

    String cacheContent = (String) resource.getConfigParameterValue(CACHE_CONTENT_KEY);
    if (Boolean.parseBoolean(cacheContent)) {
      String dir = (String) resource.getConfigParameterValue(CCONTENT_DIR_KEY);
      String index = (String) resource.getConfigParameterValue(CCONTENT_INDEX_KEY);
      UIMAFramework.getLogger(getClass()).log(Level.INFO, String.format("Caching Retrieved Content in %s, %n\tindex: %s",
	  dir, index));
      try {
	super.processors.add(new ResultCacher(dir, index));
      } catch (IOException e) {
	UIMAFramework.getLogger(getClass()).log(Level.SEVERE, "Unable to create result cacher", e);
      }
    }

    String[] line = indexIter.nextParsedLine(new String[4]);
    indexIter.rewind();
    String url = line[StandardIndexLineParser.URL];
    if (!url.startsWith("http://")) {
      String indexFile = (String) resource.getConfigParameterValue(INDEX_FILE);
      File file = new File(indexFile);
      nytReader = new CachedContentReader(ReaderConstants.NYTIMES_SOURCE, file.getParent());
    }
  }*/
}
