package anl.aida.reader;

import java.util.Date;

public class ReaderResultBuilder {

  private ReaderResult result = new ReaderResult();

  public ReaderResultBuilder setDate(ParsedDate date) {
    result.setDate(date);
    return this;
  }

  public ReaderResultBuilder setDate(Date date) {
    result.setDate(new ParsedDate(date));
    return this;
  }

  public ReaderResultBuilder setAuthors(ParsedAuthors authors) {
    result.setAuthors(authors);
    return this;
  }

  public ReaderResultBuilder setTitle(String title) {
    result.setTitle(title);
    return this;
  }

  public ReaderResultBuilder setLocation(String location) {
    result.setLocation(location);
    return this;
  }

  public ReaderResultBuilder setLink(String link) {
    result.setLink(link);
    return this;
  }

  public ReaderResultBuilder setContents(String contents) {
    result.setContents(contents);
    return this;
  }
  
  public ReaderResultBuilder setSource(String source) {
    result.setSource(source);
    return this;
  }
  
  public ReaderResult createResult() {
    return new ReaderResult(result);
  }
}
