package anl.aida.reader.local;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;

public class ColumbusTelegramIndexMaker extends YorkNewsTimesIndexMaker{
	  private static class ArchiveMaker implements DocumentProcessor {

		    // timestamp:::link:::title:::author
		    public DateFormat format = new SimpleDateFormat("yyyy-M-d");
		    private PrintWriter writer;
		    public long timeStamp;
		    public ArchiveMaker(String file) throws IOException {
		      writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
		    }

		    public void processLine(String line) {
		    	if(line.contains("result(s) found")){
		    		String first=line.split("of")[1].split("result")[0];
		    		int n=Integer.parseInt(first.trim());
		    		N=n;
		    	}
		    	if(line.contains("Most Read"))
		    		done=true;
		    	if(done)
		    		return;
		        if (line.contains("/news/") && line.contains("article") &&
		        		!line.contains("hottopics") && !line.contains("Loading") && !line.contains("obituaries") && 
		        		!line.contains("Breaking News")) {
//		        		have=true;
	        		int index = line.indexOf(">");
	        		if(index==line.length()-1)
	        			return;
	        		String link = line.substring(1, index);
	        		index = line.indexOf(Integer.toString(timeOfYear)+"/");
	        		int start = index + 5;
	        		int end = start + 3;
//	        		String linkMonth = line.substring(start, end);
	        		start = end + 1;
	        		end = start + 2;
//	        		String day = line.substring(start, end);
	        	
	        		String title = "";
	        		start = line.indexOf(">") + 1;
	        		end = line.length();
	        		if (end != -1) {
	        			title = line.substring(start, end);
	        		} else {
	        			end = line.length();
	        			title = line.substring(start, end);
	        		}
		        	String[] linkB=link.split("/");
		        	Calendar c = new GregorianCalendar();
		        	c.set(Calendar.YEAR, Integer.parseInt(linkB[4]));
		        	c.set(Calendar.MONTH, Integer.parseInt(linkB[5])-1);
		        	c.set(Calendar.DAY_OF_MONTH,Integer.parseInt(linkB[6])-1);
					timeStamp=c.getTimeInMillis();
		        	writer.println(String.format("%d:::%s:::%s:::",timeStamp,link, title));
//					System.out.printf(String.format("%d:::%s:::%s:::", timeStamp,link, title));
	        		
				 }
		        
//		        if(countHave>0)
//		        	have=true;
//		        else
//		        	have=false;
		}


		    @Override
		    public boolean done() {
		      return false;
		    }

		    public void close() throws IOException {
		      writer.close();
		    }

		    /*
		     * (non-Javadoc)
		     * 
		     * @see anl.aida.reader.DocumentProcessor#reset()
		     */
		    @Override
		    public void reset() {
		      // TODO Auto-generated method stub

		    }
		  }

	public void run(String urlBase,String addOn, String file) throws IOException, ParseException {
//		http://www.dailygate.com/shared-content/search
//		/index.php?search=date&o=0&l=20&s=recent&d1=9-16-2008&d2=10-14-2008&o=103
		
		StringExtractor extractor = new StringExtractor();
		ArchiveMaker maker = new ArchiveMaker(file);
		parseTime();

		Calendar cal = GregorianCalendar.getInstance();
		Calendar e = GregorianCalendar.getInstance();
		cal.setTime(start);
		e.setTime(end);
		 
		int t=0;
		      while(t<N) {
//		    	  countHave=0;
//		    	  int day=cal.get(Calendar.DAY_OF_MONTH)-1;
		    	  String url=urlBase+monthsI[cal.get(Calendar.MONTH)]+"-"+days[cal.get(Calendar.DAY_OF_MONTH)]+"-"+
		  		+cal.get(Calendar.YEAR)+"&d2="+monthsI[e.get(Calendar.MONTH)]
		  		  +"-"+days[e.get(Calendar.DAY_OF_MONTH)]+"-"+
		  		+e.get(Calendar.YEAR)+"&o="+t;
		    	  System.out.println("Processing URL: " + url);
		    	  extractor.run(url, maker);
		    	  t=t+20;
		    	  done=false;
		      }
//		      have=true;
//		      cal.add(Calendar.DAY_OF_MONTH, 1);
//		      current++;
		    maker.close();
		  } 
	
	  public static void main(String[] args){
		  String baseUrl="http://www.columbustelegram.com/shared-content/search" +
		  		"/index.php?search=date&o=0&l=20&s=recent&d1=";
		  String addOn="";
		  String index="./columbustelegram_index.txt";
		  ColumbusTelegramIndexMaker sci = new ColumbusTelegramIndexMaker();
		  try {
			sci.run(baseUrl,addOn,index);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	  }
}
