package anl.aida.reader.local;

import java.io.File;
import java.io.IOException;
import java.util.Date;

import org.apache.uima.resource.ConfigurableResource;
import org.apache.uima.resource.ResourceInitializationException;

import anl.aida.reader.AbstractAIDAComponentReader;
import anl.aida.reader.CachedContentReader;
import anl.aida.reader.ContentReader;
import anl.aida.reader.ReaderResult;
import anl.aida.util.StandardIndexLineParser;

public class GrandIslandIndependentReader extends AbstractAIDAComponentReader{
	  public static final String INDEX_FILE = "anl.aida.reader.local.GrandIslandIndependentIndex";
	  
	  private ContentReader ltReader = new GrandIslandIndependentHTMLReader(ReaderConstantsMiner.GRANDISLANDINDEPENDENT_SOURCE, 
			  "Commenting is currently disabled on all stories","/articles/");
	  
	  public GrandIslandIndependentReader() {
	   
	  }

	  /* (non-Javadoc)
	   * @see anl.aida.reader.AbstractAIDAComponentReader#getNextResult()
	   */
	  @Override
	  protected ReaderResult getNextResult() throws IOException {
	    lineItems = indexIter.nextParsedLine(lineItems);
	    location = lineItems[StandardIndexLineParser.URL];
	    Date date = new Date(Long.parseLong(lineItems[StandardIndexLineParser.TIMESTAMP]));
	    checkDate(date);
	    
	    return ltReader.read(location,  lineItems[StandardIndexLineParser.TITLE], date, "");
	  }
	  
	  @Override
	  protected String getIndexFileKey() {
	    return INDEX_FILE;
	  }

	  @Override
	  public void initialize(ConfigurableResource resource, Date startDate) throws ResourceInitializationException {
	    super.initialize(resource, startDate);
	    String[] line = indexIter.nextParsedLine(new String[4]);
	    indexIter.rewind();
	    String url = line[StandardIndexLineParser.URL];
	    if (!url.startsWith("http://")) {
	      String indexFile = (String)resource.getConfigParameterValue(INDEX_FILE);
	      File file = new File(indexFile);
	      ltReader = new CachedContentReader(ReaderConstantsMiner.GRANDISLANDINDEPENDENT_SOURCE, file.getParent());
	    }
	  }
}
