package anl.aida.reader.local;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.util.Calendar;
import java.util.GregorianCalendar;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;

public class GrandIslandIndexMaker extends DailyIowanIndexMaker{
	static String START_DATE="2009-3-01";
	static String END_DATE="2009-11-01";
	static int timeOfYear;
	static String timeOfDay;
	static String timeOfMonth;
	static String category;
	
	  private static class ArchiveMaker implements DocumentProcessor {

		    // timestamp:::link:::title:::author

		    private PrintWriter writer;
		    public long timeStamp;
		    

		    public ArchiveMaker(String file) throws IOException {
		      writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
		    }

		    public void processLine(String line) {
		      // System.out.println("line = " + line);
			   
		    if (line.contains("<http://www.theindependent.com/articles/") &&
		    		line.contains(timeOfMonth) && line.contains(timeOfDay) && !line.endsWith(">") 
		    		&& (line.contains("local") || line.contains("regional")) && line.contains("news")) {
        		int index = line.indexOf(">");
        		int st = line.indexOf("<");
        		String link = line.substring(st+1, index);
        		index = line.indexOf(Integer.toString(timeOfYear)+"/");
        		int start = index + 5;
        		int end = start + 3;
//        		String linkMonth = line.substring(start, end);
        		start = end + 1;
        		end = start + 2;
//	        		String day = line.substring(start, end);
        		
        		String title = "";
        		start = line.indexOf(">") + 1;
        		end = line.length();
        		if (end != -1) {
        			title = line.substring(start, end);
        		} else {
        			end = line.length();
        			title = line.substring(start, end);
        		}
		    	writer.println(String.format("%d:::%s:::%s:::", timeStamp, link, title));
		    	System.out.println(String.format("%d:::%s:::%s:::", timeStamp, link, title));
		    	// linkMonth, day);

		      	}
		   	 
		   }

		    @Override
		    public boolean done() {
		      return false;
		    }

		    public void close() throws IOException {
		      writer.close();
		    }

		    /*
		     * (non-Javadoc)
		     * 
		     * @see anl.aida.reader.DocumentProcessor#reset()
		     */
		    @Override
		    public void reset() {
		      // TODO Auto-generated method stub

		    }
		  }
		  
	  public void parseTime() throws ParseException{
			start = format.parse(START_DATE);
			end = format.parse(END_DATE);
		    long days=end.getTime()-start.getTime();
		    totalTicks=(days/86400000)+1;
		}	  

	public static void main(String[] args) throws IOException, ParseException  {
		GrandIslandIndexMaker lam = new GrandIslandIndexMaker();
		StringExtractor extractor = new StringExtractor();
		ArchiveMaker maker = new ArchiveMaker("./grandislandindependent_index.txt");
		String[] months = { "1","2","3", "4", "5","6",
				"7","8","9","10","11","12" };
		
		String[] days={"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16",
	    		"17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"};
		
		lam.parseTime();

		Calendar cal = GregorianCalendar.getInstance();
		int current=0;
		cal.setTime(lam.start);
		   while(current<=lam.totalTicks) {
		    
		    timeOfYear=cal.get(Calendar.YEAR);
		    	  
		      maker.timeStamp = cal.getTime().getTime();
		      
		     
		      String url = "http://gidedicated.com/archives/?year="+Integer.toString(cal.get(Calendar.YEAR))
		      	+"&month="+months[cal.get(Calendar.MONTH)]+"&day="+days[cal.get(Calendar.DAY_OF_MONTH)];
		      
		      timeOfMonth=months[cal.get(Calendar.MONTH)];
		      timeOfDay=days[cal.get(Calendar.DAY_OF_MONTH)];
		      System.out.println("Processing URL: " + url);
		      extractor.run(url, maker);
		      cal.add(Calendar.DAY_OF_MONTH, 1);
		      current++;
		   }
		  maker.close();
		} 
}
