package anl.aida.reader.local;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Map;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;

public class MuscatineJournalIndexMaker extends QuadCityIndexMaker{
	
	 protected static Map<String,String> record = new HashMap<String,String>();
	 static int timeOfYear;
	 static String timeOfDay;
	 static String timeOfMonth;
	 static int N=1;
//	 static String category;
//   private static boolean have=true;
	 static int countHave=0;
	 public DateFormat format = new SimpleDateFormat("yyyy-M-d");
	 String[] monthsI={"1","2","3","4","5","6","7","8","9","10","11","12"};
	 static String[] days={"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16",
	    		"17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"};
	 int[]year;
	 public long totalTicks;
	 public Date start;
	 public Date end;
     public static Calendar now;
     
  private static class ArchiveMaker implements DocumentProcessor {

	    // timestamp:::link:::title:::author

	    private PrintWriter writer;
	    public long timeStamp;
	    

	    public ArchiveMaker(String file) throws IOException {
	      writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
	    }

	    public void processLine(String line) {
	      // System.out.println("line = " + line);
		   
	    if (line.contains("<http://www.muscatinejournal.com/articles/") && !line.contains("><") && !line.endsWith(">")) {
	    	if(record.containsKey(line))
	    		return;
    		int index = line.indexOf(">");
    		if(index==line.length()-1)
    			return;
    		String link = line.substring(1, index);
    		index = line.indexOf(Integer.toString(timeOfYear)+"/");
    		int start = index + 5;
    		int end = start + 3;
//    		String linkMonth = line.substring(start, end);
    		start = end + 1;
    		end = start + 2;
//    		String day = line.substring(start, end);
    	
    		String title = "";
    		start = line.indexOf(">") + 1;
    		end = line.length();
    		if (end != -1) {
    			title = line.substring(start, end);
    		} else {
    			end = line.length();
    			title = line.substring(start, end);
    		}
        		
    		record.put(line, line);
//	    	if (!month.equals(linkMonth)) {
//	    		//writer.println(String.format("%s 2009", linkMonth));
//	    		month = linkMonth;
//	    	}
	    	writer.println(String.format("%d:::%s:::%s:::", timeStamp, link, title));
	    	System.out.println(String.format("%d:::%s:::%s:::", timeStamp, link, title));
	    	// linkMonth, day);

	      	}
	   	  
	   }

	    @Override
	    public boolean done() {
	      return false;
	    }

	    public void close() throws IOException {
	      writer.close();
	    }

	    /*
	     * (non-Javadoc)
	     * 
	     * @see anl.aida.reader.DocumentProcessor#reset()
	     */
	    @Override
	    public void reset() {
	      // TODO Auto-generated method stub

	    }
	  }
	  
  public void parseTime() throws ParseException{
		start = format.parse(START_DATE);
		end = format.parse(END_DATE);
	    long days=end.getTime()-start.getTime();
	    totalTicks=(days/86400000)+1;
	}	  
  
   public void run(String urlBase,String indexFile, String addOn){
	  
		StringExtractor extractor = new StringExtractor();
		ArchiveMaker maker=null;
		try {
			maker = new ArchiveMaker(indexFile);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		String[] months = { "01","02","03","04","05","06","07","08","09","10","11","12"};
		
//		String[] days={"01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16",
//	   		"17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"};
		
		try {
			parseTime();
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		Calendar cal = GregorianCalendar.getInstance();
		int current=0;
		cal.setTime(start);
		   while(current<=totalTicks) {
		    
		    timeOfYear=cal.get(Calendar.YEAR);
		    	  
		      maker.timeStamp = cal.getTime().getTime();
		      now=cal;
		     
		      String url = urlBase+Integer.toString(cal.get(Calendar.YEAR))
		      	+"/"+months[cal.get(Calendar.MONTH)]+"/"+days[cal.get(Calendar.DAY_OF_MONTH)-1]+"/news/";
		      
		      timeOfMonth=months[cal.get(Calendar.MONTH)];
		      timeOfDay=days[cal.get(Calendar.DAY_OF_MONTH)-1];
		      System.out.println("Processing URL: " + url);
		      try {
				extractor.run(url, maker);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		      cal.add(Calendar.DAY_OF_MONTH, 1);
		      current++;
		   }
		  try {
			maker.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
   }
   
  public static void main(String[] args)  {
	 MuscatineJournalIndexMaker mji = new MuscatineJournalIndexMaker();
	 String indexFile="./muscatinejournal_index.txt";
	 String urlBase="http://www.muscatinejournal.com/articles/";
	 mji.run(urlBase,indexFile,"");
  }
	  
}
