package anl.aida.reader.local;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;

public class QuadCityIndexMaker {
	protected static String START_DATE="2009-03-01";
	protected static String END_DATE="2009-11-01";
	static int timeOfYear;
	static String timeOfDay;
	static String timeOfMonth;
	static int N=1;
//	static String category;
//  private static boolean have=true;
    static int countHave=0;
    public DateFormat format = new SimpleDateFormat("yyyy-M-d");
    String[] monthsI={"1","2","3","4","5","6","7","8","9","10","11","12"};
    String[] days={"00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16",
    		"17","18","19","20","21","22","23","24","25","26","27","28","29","30","31"};
	int[]year;
	public long totalTicks;
	public Date start;
	public Date end;
	protected static Date now;
	protected static boolean done=false;
	
	public QuadCityIndexMaker(){
	}
	  private static class ArchiveMaker implements DocumentProcessor {

		    // timestamp:::link:::title:::author
		    public DateFormat format = new SimpleDateFormat("yyyy-M-d");
		    private PrintWriter writer;
		    private String month = "";
		    private String link="";
		    public long timeStamp;
		    public boolean active=false;
		    public ArchiveMaker(String file) throws IOException {
		      writer = new PrintWriter(new BufferedWriter(new FileWriter(file)));
		    }

		    public void processLine(String line) {
		    	if(line.contains("Most Read"))
		    		done=true;
		    	if(done)
		    		return;
		        if (line.contains("/news/") &&  line.contains("/local/") && line.contains("article") &&
		        		!line.contains("hottopics") && !line.contains("Loading")) {
//		        		have=true;
	        		int index = line.indexOf(">");
	        		if(index==line.length()-1)
	        			return;
	        		String link = line.substring(1, index);
	        		index = line.indexOf(Integer.toString(timeOfYear)+"/");
	        		int start = index + 5;
	        		int end = start + 3;
//	        		String linkMonth = line.substring(start, end);
	        		start = end + 1;
	        		end = start + 2;
//	        		String day = line.substring(start, end);
	        	
	        		String title = "";
	        		start = line.indexOf(">") + 1;
	        		end = line.length();
	        		if (end != -1) {
	        			title = line.substring(start, end);
	        		} else {
	        			end = line.length();
	        			title = line.substring(start, end);
	        		}
		        		
					timeStamp=now.getTime();
						
		        	writer.println(String.format("%d:::%s:::%s:::",timeStamp,link, title));
//					System.out.printf(String.format("%d:::%s:::%s:::", timeStamp,link, title));
	        		
					active=false;
				 }
		        
//		        if(countHave>0)
//		        	have=true;
//		        else
//		        	have=false;
		}


		    @Override
		    public boolean done() {
		      return false;
		    }

		    public void close() throws IOException {
		      writer.close();
		    }

		    /*
		     * (non-Javadoc)
		     * 
		     * @see anl.aida.reader.DocumentProcessor#reset()
		     */
		    @Override
		    public void reset() {
		      // TODO Auto-generated method stub

		    }
		  }
		  
	  public void parseTime() throws ParseException{
			start = format.parse(START_DATE);
		    end = format.parse(END_DATE);
		    long days=end.getTime()-start.getTime();
		    totalTicks=(days/86400000)+1;
		}

	public void run(String baseUrl,String addOn, String indexFile) throws IOException, ParseException {
//		http://www.qctimes.com/search/?byDate=true&limit=50
//		&start_date=6%2F4%2F2009&end_date=6%2F4%2F2009&category=news%2Flocal&month=6&day=4&year=2009
		
		StringExtractor extractor = new StringExtractor();
		ArchiveMaker maker = new ArchiveMaker(indexFile);
		parseTime();

		Calendar cal = GregorianCalendar.getInstance();
		Calendar e = GregorianCalendar.getInstance();
		cal.setTime(start);
		e.setTime(end);
		e.add(Calendar.DAY_OF_YEAR, 1); 
		
		      while(cal.before(e)) {
//		    	  countHave=0;
//		    	  int day=cal.get(Calendar.DAY_OF_MONTH)-1;
		    	  String url = baseUrl+monthsI[cal.get(Calendar.MONTH)]+"%2F"+days[cal.get(Calendar.DAY_OF_MONTH)]+"%2F"+
    		  		+cal.get(Calendar.YEAR)+"&end_date="+monthsI[cal.get(Calendar.MONTH)]
    		  		  +"%2F"+days[cal.get(Calendar.DAY_OF_MONTH)]+"%2F"+
    		  		+cal.get(Calendar.YEAR)+addOn+monthsI[cal.get(Calendar.MONTH)]+
    		  		"&day="+days[cal.get(Calendar.DAY_OF_MONTH)]+"&year="+cal.get(Calendar.YEAR);
		    	  System.out.println("Processing URL: " + url);
		    	  now=cal.getTime();
		    	  extractor.run(url, maker);
		    	  done=false;
		    	 cal.add(Calendar.DAY_OF_YEAR, 1);
		      }
//		      have=true;
//		      cal.add(Calendar.DAY_OF_MONTH, 1);
//		      current++;
		    maker.close();
		  } 
	
	public static void main(String[] args){
		String baseUrl="http://www.qctimes.com/search/?byDate=true&limit=50&start_date=";
		String index="./quadcity_index.txt";
		String addOn="&category=news%2Flocal&month=";
		QuadCityIndexMaker qim = new QuadCityIndexMaker();
		try {
			qim.run(baseUrl,addOn,index);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}
