package anl.aida.score;

import anl.aida.core.DocumentID;
import anl.aida.util.MIFSRuntimeException;

/**
 * Interface for classes that can score a term w/r to
 * a document.
 *
 */
public interface Scorer {
  
  /**
   * Gets a score for the specified term w/r to
   * the specified document.
   *
   * @param term the term whose score we want
   * @param id   the id of the document
   * @return a score for the specified term w/r to
   *         the specified document.
   * @throws MIFSRuntimeException if there's an error getting the score.
   */
  float getScore(String term, DocumentID id) throws MIFSRuntimeException;
}
