package anl.aida.score;

import anl.aida.core.DocumentID;

/**
 * Filters documents based on the term score for that Document.
 *
 */
public interface TermScoreFilter {

  /**
   * Evaluates the term and document.
   *
   * @param term the term to evaluate against
   * @param id   the id of the document to evaluate
   * @return true if the document passes the filter w/r to the specified term, otherwise false.
   */
  boolean evaluate(String term, DocumentID id);
}

