package anl.aida.util;

import java.util.Enumeration;
import java.util.Iterator;

/**
 * Wraps an enumeration in the Iterable interface.
 *
 */
public class EnumIter<T> implements Iterator<T>, Iterable<T> {

  private Enumeration enumeration;

  public EnumIter(Enumeration enumeration) {
    this.enumeration = enumeration;
  }

  public boolean hasNext() {
    return enumeration.hasMoreElements();
  }

  public T next() {
    return (T) enumeration.nextElement();
  }

  public void remove() {
    throw new UnsupportedOperationException();
  }

  public Iterator<T> iterator() {
    return this;
  }
}
