package anl.aida.util;


/**
 * Generic filter interface for evaluating individual
 * items.
 *
 */
public interface Filter<T> {

  /**
   * Evaluates an item against some implementor specific
   * criteria and returns true if the item passes the filter.
   *
   * @param item the item to evaluate
   * @return true if the item passes the filter, otherwise false.
   */
  boolean evaluate(T item);
}
