package anl.aida.util;

import java.util.HashSet;
import java.util.Set;

import org.apache.lucene.index.Term;

import anl.aida.ae.lucene.Keywords;

public class KeywordFilter implements Filter<Term> {

  private Set<String> keepSet = new HashSet<String>();

  /**
   * Constructor for adding keywords to filter
   * 
   * @param keywords
   */
  public KeywordFilter(Keywords keywords) {
    keepSet.addAll(keywords.getKeywordsAsTerms());
  }

  public boolean evaluate(Term item) {
    return keepSet.contains(item.text());
  }

}
