package anl.aida.util;

import java.util.Iterator;

/**
 * Implements an iterable and iterator over an array of type T.
 *
 */
public class ObjectArrayIter<T> implements Iterable<T>, Iterator<T> {

  private T[] array;
  private int index;

  public ObjectArrayIter(T[] array) {
    this.array = array;
    index = 0;
  }

  public Iterator<T> iterator() {
    return this;
  }

  public boolean hasNext() {
    return index < array.length;
  }

  public T next() {
    T val = array[index];
    index++;
    return val;
  }

  public void remove() {
    throw new UnsupportedOperationException();
  }
}