package anl.gtou;

import gate.FeatureMap;

import java.io.IOException;

import org.apache.uima.cas.Feature;
import org.apache.uima.cas.FeatureStructure;
import org.apache.uima.cas.TypeSystem;

import anl.aida.ae.gate.FeatureBuilder;

public class DiseaseConverter implements FeatureBuilder {

  private Feature kind;
  private Feature canonicalName;

  public DiseaseConverter(TypeSystem system) throws IOException {
    kind = system.getFeatureByFullName("anl.aida.types.Disease:kind");
    canonicalName = system.getFeatureByFullName("anl.aida.types.Disease:canonicalName");
  }

  // FeatureStructure is UIMA : FeatureMap is Gate
  @Override
  public void build(FeatureStructure parent, FeatureMap map) {
    String kindGate = (String) map.get("kind");
    parent.setStringValue(kind, kindGate);

    String canonicalNameGate = (String) map.get("canonicalName");
    parent.setStringValue(canonicalName, canonicalNameGate);
  }
}
