package anl.gtou;

import anl.aida.ae.gate.FeatureBuilder;

import org.apache.uima.cas.FeatureStructure;
import org.apache.uima.cas.Feature;
import org.apache.uima.cas.TypeSystem;
import gate.FeatureMap;

/**
 *         Date: Jan 19, 2009 3:12:56 PM
 */
public class OrthMatcher implements FeatureBuilder {

  private Feature ortho;

  public OrthMatcher(TypeSystem system) {
    ortho = system.getFeatureByFullName("de.julielab.jules.types.Token:orthogr");
  }


  /**
   * Transfers UIMA features to a FeatureMap or vis-a-versa.
   *
   * @param parent the UIMA featureStructure containing the feature
   * @param map    the feature map to put the feature in
   */
  public void build(FeatureStructure parent, FeatureMap map) {
    String orth = (String)map.get("orth");
    if (orth != null) {
      if (orth.equalsIgnoreCase("lowerCase")) parent.setStringValue(ortho, "lowercase");
      if (orth.equalsIgnoreCase("mixedCaps")) parent.setStringValue(ortho, "multicaps");
      if (orth.equalsIgnoreCase("upperInitial")) parent.setStringValue(ortho, "capitalized");
      if (orth.equalsIgnoreCase("allCaps")) parent.setStringValue(ortho, "uppercase");
    }
  }
}
