package anl.aida.reader;

import java.io.IOException;

import org.htmlparser.Tag;
import org.htmlparser.beans.StringBean;

import anl.aida.reader.DocumentProcessor;
import anl.aida.reader.StringExtractor;

/**
 * Catch all class for testing some string extraction from web pages.
 * 
 */
public class ExtractStrings {
  
  public static class PreBean extends StringBean {

    @Override
    public void visitEndTag(Tag tag) {
      super.visitEndTag(tag);
      if (!mIsPre) mBuffer.append("\nPRE_OFF\n");
    }

    @Override
    public void visitTag(Tag tag) {
      // TODO Auto-generated method stub
      super.visitTag(tag);
      if (mIsPre) mBuffer.append("\nPRE_ON\n");
    }
    
   
  }
  
  

  public static void main(String[] args) throws IOException {
    final PreBean bean = new PreBean();
    StringExtractor extractor = new StringExtractor(bean);
    
    // String url =
    // "http://www.nytimes.com/2009/01/01/world/asia/01indo.html?pagewanted=print";
    // String url =
    // "http://www.nytimes.com/2009/01/01/world/middleeast/01mideast.html?_r=1&pagewanted=print";
    // String url =
    // "http://www.nationalterroralert.com/updates/2009/03/01/company-discovers-marine-one-security-breach/";

    String urlSpec = "http://query.nytimes.com/gst/fullpage.html?res=9505EFDF1639F932A05756C0A96F9C8B63&sec=&spon=&pagewanted=print";
    // String referer = "http://www.nytimes.com";
    String referer = "http://query.nytimes.com/gst/fullpage.html?res=9906E2DF143CF932A35752C0A96F9C8B63";

    String url = "http://www.promedmail.org/pls/otn/f?p=2400:1001:1692285671124542::NO::F2400_P1001_BACK_PAGE,F2400_P1001_PUB_MAIL_ID:1000,77985";
    /*
    URL url = new URL(urlSpec);
    HttpURLConnection conn = (HttpURLConnection) url.openConnection();
    conn.setRequestProperty("User-Agent", "HTMLParser/1.6");
    conn.setRequestProperty("Accept-Encoding", "gzip, deflate");
    conn.addRequestProperty("REFERER", "http://www.nytimes.com");
    */

    extractor.run(url, referer, new DocumentProcessor() {
      
      boolean preOn = false;
      public void processLine(String line) {
	if (line.startsWith("PRE_OFF") && preOn) preOn = false;
	if (preOn) System.out.println("line = " + line);
	if (line.startsWith("PRE_ON") && !preOn)  preOn = true;
      }

      @Override
      public boolean done() {
	return false;
      }

      @Override
      public void reset() {
      }
    });

  }
}
