package anl.aida.reader;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;

import anl.aida.reader.NYTEntry;
import anl.aida.reader.NYTSearchResult;

import com.google.gson.Gson;

public class TimesAPI {
  
  public static void main(String[] args) throws IOException {
    
    // http://api.nytimes.com/svc/search/v1/article?query=cloud computing des_facet:[COMPUTERS AND THE INTERNET] 
    //org_facet:[GOOGLE INC]

    
    Gson gson = new Gson();
    String key = "50df38a409ff40edabf854caecc902c4:7:58168816";
    
    String query = URLEncoder.encode(" ", "UTF-8");
    String facet = URLEncoder.encode("nytd_section_facet:[U.S.]", "UTF-8");
    String dateRange = "begin_date=20090312&end_date=20090317";
    int offset = 1;
    
    String urlString = String.format("http://api.nytimes.com/svc/search/v1/article?query=%s+%s&fields=date,title,url,byline&%s&offset=%d&api-key=%s", query, facet, 
	dateRange, offset, key);
    System.out.println("url = " + urlString);
    
    URL url = new URL(urlString);
    HttpURLConnection connection = (HttpURLConnection) url.openConnection();
    BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
    
    NYTSearchResult result = gson.fromJson(reader, NYTSearchResult.class);
    System.out.println("result.getTotal() = " + result.getTotal());
    for (NYTEntry ent : result.getResults()) {
      System.out.println(ent);
      System.out.println();
    }
    
    reader.close();
    connection.disconnect();
   
  }
 

}
