package anl.aida.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import anl.aida.reader.ChicagoTribuneHTMLReader;
import anl.aida.reader.ReaderResult;

/**
 * Quick and dirty code to convert index files into the new format.
 * 
 */
public class Converter {
  
  Calendar cal = GregorianCalendar.getInstance();
  
  public void tribFileConvert() throws IOException, ParseException {

    DateFormat format = new SimpleDateFormat("MMM yyyy");

    BufferedReader reader = null;
    PrintWriter out = null;
    cal.set(2009, 0, 1, 6, 0, 0);

    try {
      reader = new BufferedReader(new FileReader("./corpus/indices/trib_archive_index.txt"));
      out = new PrintWriter(new BufferedWriter(new FileWriter(
	  "./corpus/indices/trib_archive_index2.txt")));
      String line;
      cal.set(2009, 0, 1, 6, 0, 0);

      while ((line = reader.readLine()) != null) {
	line = line.trim();
	if (Character.isDigit(line.charAt(0))) {
	  cal.set(Calendar.DAY_OF_MONTH, Integer.parseInt(line.substring(0, 2)));

	  int index = line.indexOf(">");
	  String url = line.substring(4, index);
	  String title = line.substring(index + 1);

	  System.out.printf("item:%n\t%s%n\t%s%n\t%s%n", url.trim(), title.trim(), cal.getTime()
	      .toString());

	  out.printf("%d:::%s:::%s:::%n", cal.getTimeInMillis(), url, title);

	} else {
	  // its a month and year
	  Date date = format.parse(line);
	  cal.setTime(date);
	  cal.set(Calendar.HOUR_OF_DAY, 9);
	}
      }

    } finally {
      reader.close();
      out.close();
    }

  }
  
  public void ntarcFileConvert() throws IOException, ParseException {

    DateFormat format = new SimpleDateFormat("MMMMM yyyy");
    

    BufferedReader reader = new BufferedReader(new FileReader("./ntarc_archive_index.txt"));
    String line;
    cal.set(2009, 0, 1, 6, 0, 0);
    
    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("./ntarc_archive_index2.txt")));

    while ((line = reader.readLine()) != null) {
      line = line.trim();
      if (Character.isDigit(line.charAt(0))) {
	cal.set(Calendar.DAY_OF_MONTH, Integer.parseInt(line.substring(0, 2)));

	int index = line.indexOf(">");
	String url = line.substring(4, index);
	String title = line.substring(index + 1);

	System.out.printf("item:%n\t%s%n\t%s%n\t%s%n", url.trim(), title.trim(), cal.getTime()
	    .toString());
	
	out.printf("%d:::%s:::%s:::%n", cal.getTimeInMillis(), url, title);
	
	
      } else {
	// its a month and year
	Date date = format.parse(line);
	cal.setTime(date);
	cal.set(Calendar.HOUR_OF_DAY, 9);
      }

    }
    
    reader.close();
    out.close();
    
  }

  public static void main(String[] args) throws IOException, ParseException {
    Converter converter = new Converter();
    converter.tribFileConvert();
    
    
  
  }
}


