package anl.aida.util;

import static junit.framework.Assert.assertTrue;
import static org.junit.Assert.assertEquals;
import org.junit.Test;

import anl.aida.util.HighestTermScores;
import anl.aida.util.TermScore;

import java.util.HashSet;
import java.util.Set;

/**
 * 
 */
public class UtilTests {

  @Test
  public void testHighestTermsScores() {
    String[] terms = {"A", "B", "C", "A", "D", "E", "F", "G", "H", "B"};
    int[] vals = {5, 2, 3, 10, 10, 5, 6, 7, 1, 3};
    boolean[] expected = {true, true, true, true, true, true, true,
            true, false, false};

    // top six should be A, D, G, F, E

    HighestTermScores scores = new HighestTermScores(5);
    for (int i = 0; i < terms.length; i++) {
      boolean res = scores.add(terms[i], vals[i]);
      assertEquals(String.valueOf(i), expected[i], res);
    }


    Set<String> exTerms = new HashSet<String>();
    exTerms.add("A");
    exTerms.add("F");
    exTerms.add("G");
    exTerms.add("D");
    exTerms.add("E");
    float prevScore = 0;
    for (TermScore ts : scores.termScores()) {
      assertTrue(ts.getScore() >= prevScore);
      prevScore = ts.getScore();
      assertTrue(exTerms.remove(ts.getTerm()));
    }
    assertEquals(0, exTerms.size());
  }
}
